Package: Biobase
Title: Biobase: Base functions for Bioconductor
Description: Functions that are needed by many other packages or which
        replace R functions.
biocViews: Infrastructure
URL: https://bioconductor.org/packages/Biobase
BugReports: https://github.com/Bioconductor/Biobase/issues
Version: 2.72.0
License: Artistic-2.0
Authors@R: c(
    person("R.", "Gentleman", role="aut"),
    person("V.", "Carey", role = "aut"),
    person("M.", "Morgan", role="aut"),
    person("S.", "Falcon", role="aut"),
    person("Haleema", "Khan",
        role = "ctb",
        comment = "'esApply' and 'BiobaseDevelopment' vignette translation from Sweave to Rmarkdown / HTML"
    ),
    person("Bioconductor Package Maintainer",
        role = "cre",
        email = "maintainer@bioconductor.org"
    ))
Suggests: tools, tkWidgets, ALL, RUnit, golubEsets, BiocStyle, knitr,
        limma
Depends: R (>= 2.10), BiocGenerics (>= 0.27.1), utils
Imports: methods
VignetteBuilder: knitr
LazyLoad: yes
Collate: tools.R strings.R environment.R vignettes.R packages.R
        AllGenerics.R VersionsClass.R VersionedClasses.R
        methods-VersionsNull.R methods-VersionedClass.R DataClasses.R
        methods-aggregator.R methods-container.R methods-MIAxE.R
        methods-MIAME.R methods-AssayData.R
        methods-AnnotatedDataFrame.R methods-eSet.R
        methods-ExpressionSet.R methods-MultiSet.R methods-SnpSet.R
        methods-NChannelSet.R anyMissing.R rowOp-methods.R
        updateObjectTo.R methods-ScalarObject.R zzz.R
git_url: https://git.bioconductor.org/packages/Biobase
git_branch: RELEASE_3_23
git_last_commit: 65ae7a9
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: yes
Packaged: 2026-04-28 20:51:49 UTC; biocbuild
Author: R. Gentleman [aut],
  V. Carey [aut],
  M. Morgan [aut],
  S. Falcon [aut],
  Haleema Khan [ctb] ('esApply' and 'BiobaseDevelopment' vignette
    translation from Sweave to Rmarkdown / HTML),
  Bioconductor Package Maintainer [cre]
Maintainer: Bioconductor Package Maintainer <maintainer@bioconductor.org>

# Biobase

[![Static Badge](https://img.shields.io/badge/Project_Name-Biobase-blue)](https://github.com/lignum-vitae/biobase)
[![Python Version from PEP 621 TOML](https://img.shields.io/python/required-version-toml?tomlFilePath=https%3A%2F%2Fraw.githubusercontent.com%2Flignum-vitae%2Fbiobase%2Fmain%2Fpyproject.toml)](https://github.com/lignum-vitae/biobase/blob/main/pyproject.toml)
[![PyPI version](https://img.shields.io/pypi/v/biobase.svg)](https://pypi.python.org/pypi/biobase)
[![License: MIT](https://img.shields.io/badge/License-MIT-green.svg)](https://opensource.org/licenses/MIT)
[![GitHub branch check runs](https://img.shields.io/github/check-runs/lignum-vitae/biobase/main)](https://github.com/lignum-vitae/biobase)

A Python package providing standardized biological constants and substitution matrices
for bioinformatics pipelines.
Biobase aims to eliminate the need to repeatedly recreate common biological data
structures and scoring systems in your code.

## Table of Contents

- [Quick Start](#quick-start)
  - [Access amino acid properties](#access-amino-acid-properties)
  - [Use substitution matrices](#use-substitution-matrices)
  - [Analyse DNA sequences](#analyse-dna-sequences)
  - [Find protein motifs](#find-protein-motifs)
  - [Parse FASTA](#parse-fasta)
- [Requirements](#requirements)
- [Installation](#installation)
  - [Regular Installation](#regular-installation)
  - [Development Installation](#development-installation)
- [Running Files](#running-files)
- [Data Files](#data-files)
- [Project Goals](#project-goals)
- [Contributing](#contributing)
- [License](#license)

## Quick Start

#### Access amino acid properties

```python
from biobase.constants import ONE_LETTER_CODES, MONO_MASS
print(ONE_LETTER_CODES)  # 'ACDEFGHIKLMNPQRSTVWY'
print(MONO_MASS['A'])    # 71.037113805
print(CODON_TABLE["AUG"])    # M
```

#### Use substitution matrices

```python
from biobase.matrix import Blosum
blosum62 = Blosum(62)
print(blosum62['A']['A'])  # 4
print(blosum62['W']['C'])  # -2
```

#### Analyse DNA sequences

```python
from biobase.analysis import Dna
sequence = "ATCGTAGC"
print(Dna.complement(sequence))               # 'TAGCATCG'
print(Dna.complement(sequence, reverse=True)) # 'GCTACGAT'
print(Dna.transcribe(sequence))               # 'AUCGUAGC'
print(Dna.translate(sequence))                # 'IV'
print(Dna.calculate_gc_content(sequence))     # 50.0
print(Dna.calculate_at_content(sequence))     # 50.0
print(Dna.entropy(sequence))                  # 2.0

seq = "ccatgccctaaatggggtag"
for start, end, orf in Dna.find_orfs(seq, include_seq=True)
    print(start, end, orf)
# 2, 11, "ATGCCCTAA"
# 11, 20, "ATGGGGTAG"
```

#### Analyse Nucleotides

```python
from biobase.analysis import Nucleotides

print(Nucleotides.molecular_weight("A"))               # 135.13
print(Nucleotides.cumulative_molecular_weight("ATCG")) # 523.48
print(Nucleotides.translate("AUGUUGUCGCCUU"))          # 'MLSP'
```

#### Find protein motifs

```python
from biobase.analysis import find_motifs
sequence = "ACDEFGHIKLMNPQRSTVWY"
print(find_motifs(sequence, "DEF"))
# [(1, 4)]

test_dict = {
    ">SP001": "ACDEFCDEFCDEFGHIKLMN",  # has matches for "CDE" that span indexes [(1, 4), (5, 8), (9, 12)]
    ">SP002": "MNPQRSTVWYACDEFGHIKL",  # has match for "CDE" that span indexes [(11, 14)]
    ">SP003": "AAAAAAAAAAAAAAAAAA12",  # invalid: contains "1", "2"
    ">SP004": "GGGGGGGGGGGGGGGGGGGG",  # no match
    ">SP005": "HHHHHHHHHHHHHHHHH@#$",  # invalid: contains "@", "#", "$"
    ">SP006": "DDDDDDDDDDDDDDDDDDDD",  # no match
    ">SP007": "CDEFGHCDEFKLCDEFPQRS",  # has matches for "CDE" that span indexes [(0, 3), (6, 9), (12, 15)]
    ">SP008": "LLLLLLLLLLLLLLLLLLLL",  # no match
    ">SP009": "KKKKKKKKKKKK123KKKKK",  # invalid: contains "1", "2", "3"
    ">SP010": "CDEACDEDCDEFAAAAAAAA",  # has matches for "CDE" that span indexes [(0, 3), (4, 7), (8, 11)]
}
matched, invalid, non_match = find_motifs(test_dict, "CDE")
print("Matches:")
for seq, matches in matched.items():
    print(f"{seq}")
    print(f"{"".join([f"{match[0]} to {match[1]}\n" for match in matches])}")
print(f"Invalid sequences:\n{"".join([f"{seq}: {invs}\n" for seq, invs in invalid.items()])}")
print(f"Sequences without matches:\n{"".join([f"- {nm}\n" for nm in non_match])}")

# Matches:
# >SP001
# 1 to 4
# 5 to 8
# 9 to 12

# >SP002
# 11 to 14

# >SP007
# 0 to 3
# 6 to 9
# 12 to 15

# >SP010
# 0 to 3
# 4 to 7
# 8 to 11

# Invalid sequences:
# >SP003: {'2', '1'}
# >SP005: {'$', '@', '#'}
# >SP009: {'2', '1', '3'}

# Sequences without matches:
# - >SP004
# - >SP006
# - >SP008
```

#### Parse FASTA

```python
from biobase.parser import FastaParser, fasta_parser
fasta = """>CAA39742.1 cytochrome b (mitochondrion) [Sus scrofa]
MTNIRKSHPLMKIINNAFIDLPAPSNISSWWNFGSLLGICLILQILTGLFLAMHYTSDTTTAFSSVTHIC"""

# Class that yields generator
records = list(FastaParser(fasta))
r: FastaRecord = records[0]
print(r.id) # CAA39742.1
print(r.seq) # MTNIRKSHPLMKIINNAFIDLPAPSNISSWWNFGSLLGICLILQILTGLFLAMHYTSDTTTAFSSVTHIC

# Function that returns list
records = fasta_parser(fasta)
for r in records:
    print(r.id) # CAA39742.1
    print(r.seq) # MTNIRKSHPLMKIINNAFIDLPAPSNISSWWNFGSLLGICLILQILTGLFLAMHYTSDTTTAFSSVTHIC

```

#### Parse FASTQ

```python
from biobase.parser import FastqParser, fastq_parser
fastq = """@2fa9ee19-5c51-4281-abdd-eac86
CGGTAGCCAGCTGCGTTCAGTATG
+
%%%+++'''@@@???<<<??????"""

# Class that yields generator
records = list(FastqParser(fastq))
r: FastqRecord = records[0]
print(r.id) # 2fa9ee19-5c51-4281-abdd-eac86
print(r.seq) # CGGTAGCCAGCTGCGTTCAGTATG

# Function that returns list
records = fastq_parser(fastq)
for r in records:
    print(r.id) # 2fa9ee19-5c51-4281-abdd-eac86
    print(r.seq) # CGGTAGCCAGCTGCGTTCAGTATG
```

## Requirements

- Python 3.10+
- pip (for installation)

## Installation

### Regular Installation

`pip install biobase`

### Development Installation

Clone the repository and install in editable mode:

```nginx
git clone https://github.com/lignum-vitae/biobase.git
cd biobase
uv pip install -e ".[dev]"
```

Files can be run using `uv run <file_name>` if in the same directory/folder
as the file.

If not using uv, to ensure that relative imports correctly work, run files using
the module path from the project root. To run the sub_matrix file, use the command
`python -m src.biobase.matrix.sub_matrix`

## Data Files

- `src/biobase/matrices/`: Scoring matrix data stored in JSON file format

## Project Goals

Biobase aims to provide Python-friendly versions of common biological constants
and tools for bioinformatics pipelines. Key objectives:

1. Standardize biological data structures
2. Provide efficient implementations of common scoring systems
3. Ensure type safety and validation
4. Maintain comprehensive documentation
5. Support modern Python practices

## Contributing

We welcome contributions! Please read our:

- [Code of Conduct](https://github.com/lignum-vitae/biobase/blob/main/docs/CODE_OF_CONDUCT.md)
- [Contribution Guidelines](https://github.com/lignum-vitae/biobase/blob/main/docs/CONTRIBUTING.md)

### Stability

This project is in the beta stage. APIs may change without warning until version
1.0.0.

## License

This project is licensed under the MIT License - see the
[LICENSE](https://github.com/lignum-vitae/biobase/blob/main/LICENSE) file for details.

# ==========================================================================
# Uncategorized tools for Biobase
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# testBioCConnection
# openPDF
# listLen; reverseSplit
# rowQ; rowMedians; rowMin; rowMax
# copySubstitute
# isUnique
# cache
# userQuery
# ==========================================================================
testBioCConnection <- function() {
   ## Stifle the "connected to www.... garbage output
   curNetOpt <- getOption("internet.info")
   on.exit(options(internet.info=curNetOpt), add=TRUE)
   options(internet.info=3)
   ## First check to make sure they have HTTP capability.  If they do
   ## not, there is no point to this exercise.
   http <- as.logical(capabilities(what="http/ftp"))
   if (http == FALSE)
      return(FALSE)
   ## find out where we think that bioC is
   bioCoption <- getOption("BIOC")
   if (is.null(bioCoption))
      bioCoption <- "http://www.bioconductor.org"
   ## Now check to see if we can connect to the BioC website
   biocURL <- url(paste0(bioCoption,"/main.html"))
   options(show.error.messages=FALSE)
   test <- try(readLines(biocURL)[1])
   options(show.error.messages=TRUE)
   if (inherits(test,"try-error"))
      return(FALSE)
   else
      close(biocURL)
   return(TRUE)
}
# ==========================================================================
openPDF <- function(file, bg=TRUE) {
   OST <- .Platform$OS.type
   if (OST=="windows")
      shell.exec(file)
   else
      if (OST == "unix") {
         bioCOpt <- getOption("BioC")
         pdf <- getOption("pdfviewer")
         msg <- NULL
         if (is.null(pdf))
             msg <- "getOption('pdfviewer') is NULL"
         else if (length(pdf)==1 && nchar(pdf[[1]])==0)
             msg <- "getOption('pdfviewer') is ''"
         if (!is.null(msg))
             stop(msg, "; please use 'options(pdfviewer=...)'")
         cmd <- paste(pdf,file)
         if( bg )
            cmd <- paste(cmd, "&")
         system(cmd)
      }
    return(TRUE)
}
# ==========================================================================
reverseSplit = function(inList) {
   if (length(inList)==0) {
       return(inList)
   }
   lens = sapply(inList, length)
   nms = rep(names(inList), lens)
   vals = unlist(inList)
   split(nms, vals)
}
# ==========================================================================
copySubstitute = function(src, dest, symbolValues,
                          symbolDelimiter = "@",
                          allowUnresolvedSymbols = FALSE,
                          recursive = FALSE,
                          removeExtension = "\\.in$") {
   ## Check integrity of arguments (...lots of bureaucracy)
   mess = NULL
   if (!is.list(symbolValues) && !is.vector(symbolValues))
      mess = "'symbolValues' must be a list or vector."
   if (!all(sapply(symbolValues, is.character)))
      mess = "'symbolValues' must only contain characters."
   if (is.null(names(symbolValues)) || any(names(symbolValues)==""))
      mess = "'symbolValues' must have non-empty names."
   if (!(is.character(symbolDelimiter) && length(symbolDelimiter)==1 && all(nchar(symbolDelimiter)==1)))
      mess = "'symbolDelimiter' must be a single character."
   if (!is.logical(allowUnresolvedSymbols))
      mess = "'allowUnresolvedSymbols' must be of type logical."
   if(!is.null(mess))
      stop(mess)
   ## Here the actual subsitution and copying work is done
   ## cin and cout are single files or connections
   cpSubsCon = function(cin, cout) {
      txt = readLines(cin)
      for (i in seq(along.with=symbolValues)) {
          txt = gsub(nm[i], symbolValues[[i]], txt, fixed=TRUE)
          if (any(is.na(txt)))
              stop("trying to replace ", nm[i], " by an NA")
      }
      ## check for unresolved symbols
      if(!allowUnresolvedSymbols) {
         re = regexpr(paste0(symbolDelimiter, ".+", symbolDelimiter), txt)
         wh = which(re>0)
         if(length(wh)>0) {
            ml   = attr(re, "match.length")
            mess = "UNRESOLVED SYMBOLS:\n"
            mess <- paste0(mess, paste(sapply(wh, function(i) {
                paste("Line", i, ":", substr(txt[i], re[i], re[i] + ml[i]))
            }), collapse="\n"))
            stop(mess)
         }
      }
      ## finito
      writeLines(text=txt, con=cout)
   }
   ## Substitution on filenames
   subsFileName = function(x) {
      res = gsub(removeExtension, "", x)
      for (i in seq(along.with=symbolValues)) {
         res = gsub(nm[i], symbolValues[[i]], res)
         if (any(is.na(res)))
             stop("trying to replace ", nm[i], " by an NA")
      }
      return(res)
   }
   ## Iterate over character vectors of filenames and
   ## recursively descend into directories
   cpSubs = function(src, dest) {
      usage = paste("\n* Usage:",
         "\n* with recursive=FALSE:",
         "\n* 'src' a connection open for reading or a file name AND",
         "\n* 'dest' a connection open for writing or a file name",
         "\n* with recursive=TRUE:",
         "\n* 'src' a vector of file and directory names and 'dest' a directory name\n\n")
      if (!recursive) {
         ## {file,connection} to {file,connection}
         if ((("connection" %in% class(src) && isOpen(src, rw="r")) ||
             (is.character(src) && length(src)==1)) &&
             (("connection" %in% class(dest) && isOpen(dest, rw="w")) ||
             (is.character(dest) && length(dest)==1)))
         {
            if(is.character(dest))
               dest = subsFileName(dest)
            cpSubsCon(src, dest)
            return(invisible(NULL))
         }
      }
      else {
         ## recursive: file(s) and/or directory(ies) to directory
         if (is.character(src) && is.character(dest) && length(dest==1)) {
            ## if 'dest' does not exist, create
            if (file.access(dest) != 0) {
               if (!dir.create(dest))
                  stop("'dest' does not exist, and cannot be created: ", dest)
            }
            ## process src
            isdir = file.info(src)$isdir
            for (k in seq(along.with=src)) {
               ## name of source file or directory (without path)
               tmp  = unlist(strsplit(src[k], .Platform$file.sep))
               tmp  = subsFileName(tmp[length(tmp)])
               ## name of destination file or directory (with path)
               destname = file.path(dest, tmp)
               if (isdir[k]) {
                  if(!dir.create(destname))
                     stop("directory cannot be created: ", destname)
                  cpSubs(dir(src[k], full.names=TRUE), destname)
               }
               else
                  cpSubsCon(src[k], destname)
            } ## for k
            return(invisible(NULL))
         } ## if(is.character...)
      } ## if(recursive)else
      stop(usage)
   } ## cpSubs
   ## DO IT!
   nm  = paste0(symbolDelimiter, names(symbolValues), symbolDelimiter)
   cpSubs(src, dest)
}
# ==========================================================================
note <- function(...) {
    ## A "less drastic" version of warning()
    if (nargs() > 0) {
        message <- paste("Note:",...,"\n")
        cat(message)
    }
}

## ==================================================
isUnique = function(x){

  rv = rep(TRUE, length(x))

  if(length(x)>=2) {
    ord = order(x)
    ox = x[ord]
    ## compare consecutive values
    neq = (ox[-length(ox)]!=ox[-1])
    ## a value is unique if neither its predecessor nor successor
    ## in the ordered vector are the same
    rv[ord] = c(neq, TRUE) & c(TRUE, neq)
  }

  return(rv)
}
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## O.Sklyar, EBI, 2006
matchpt <- function(x, y) {
  storage.mode(x)="double"
  if (is.vector(x))
    x <- matrix(x, ncol = 1L, nrow = length(x))
  if (!(is.matrix(x) && is.numeric(x)))
    stop("'x' must be a numeric matrix.")

  if (!missing(y)) {
    storage.mode(y)="double"
    if (is.vector(y))
      y <- matrix(y, ncol = 1L, nrow = length(y))
    if (!(is.matrix(y) && is.numeric(y)))
      stop("y must be a numeric matrix.")
    if (ncol(x) != ncol(y))
      stop("x and y must have the same number of columns.")
  } else {
    y <- NULL
  }
  
  res <- .Call("matchpt", x, y, PACKAGE = "Biobase")
  res <- as.data.frame(res)
  rownames(res) <- rownames(x)
  return(res)
}

## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cache <- function(expr, dir=".", prefix="tmp_R_cache_") {
    pexpr <- parse(text=deparse(substitute(expr)))
    pexpr <- as.list(pexpr[[1]])
    name <- as.character(pexpr[[2]])
    RHS <- pexpr[[3]]
    cachefile <- file.path(dir, paste0(prefix, name, ".RData"))
    if(file.exists(cachefile)) {
        load(cachefile)
        assign(name, get(name), envir=parent.frame())
    } else {
        dir.create(dir, recursive=TRUE, showWarnings=FALSE)
        assign(name, eval(RHS, envir=parent.frame()), envir=parent.frame())
        save(list=name, file=cachefile, envir=parent.frame())
    }
    invisible(get(name, envir=parent.frame()))
}
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
validMsg <- function(msg, result) {
    if (is.character(result)) {
        append(msg, result)
    } else msg
}

checkClass <- function(object, expected, prefix="", call.=FALSE, ...) {
    if (!is(object, expected))
      stop(prefix, " '", deparse(substitute(object)), "' is class '",
           paste(class(object), collapse="', '"),
           "' but should be or extend '",
           paste(expected, collapse="', '"), "'", call.=call., ...)
}

## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

userQuery <- function(msg, allowed=c("y","n"), default = "n",
                      case.sensitive = FALSE) {
    ## Prompts the user with a string and for an answer
    ## repeats until it gets allowable input
  if(interactive()){
    repeat {
      allowMsg <- paste0("[", paste(allowed,collapse="/"), "] ")
      outMsg <- paste(msg, allowMsg)
      cat(outMsg)
      if(case.sensitive)
        ans <- readLines(n=1)
      else
        ans <- tolower(readLines(n=1))
      if (ans %in% allowed)
        break
      else
        cat(ans, "is not a valid response, try again.\n")
    }
    return(ans)
  }else{
    return(default)
  }
}

unsafeSetSlot <- function(obj, slot, value) {
    
    ## This function _assumes_ that there is exactly on references to
    ## 'obj'; the number of references is not usually detectable from
    ## casual perusal of the code, because R only maintains the
    ## _illusion_ of pass by value. Use this with the greatest care,
    ## if at all.

    invisible(.Call("unsafe_set_slot", obj, slot, value))
}

subListExtract <- function(L, name, simplify=FALSE, keep.names=TRUE) {
    ## Return a list or vector obtained by extracting the element named
    ## 'name' from each inner list of L.
    ##
    ## L - list
    ## name - character vector length 1, name of inner list element
    ## simplify - return an atomic vector or error if TRUE
    ## keep.names - if TRUE, keep names of L on result
    ##
    ## this is just a mockup, to play with the desired interface
    ## and behavior.  will be replaced with a C version.
    .Call(sublist_extract, L, name, simplify, keep.names)
    
##     f <- function(x) {
##         wh <- match(name, names(x), 0)
##         if (wh > 0)
##           x[[wh]]
##         else                            # would be nice to have index in msg
##           stop("bad inner list, no element named ", name)
##     }

##     if (!simplify)
##       ans <- lapply(L, f)
##     else {
##         ans <- sapply(L, f)
##         if (is.list(ans))
##           stop("unable to simplify")
##     }
##     if (!keep.names)
##       names(ans) <- NULL
##     ans
}

assayDataNew <-
    function(storage.mode = c("lockedEnvironment", "environment", "list"),
             ...)
{
    storage.mode <- match.arg(storage.mode) ## defaults to "lockedEnvironment"
    assayData <- switch(storage.mode,
                        lockedEnvironment =,
                        environment = new.env(parent=emptyenv()),
                        list = list())
    
    arglist <- list(...)
    if((length(arglist)>0L) &&
       ((is.null(names(arglist))) || any(names(arglist)=="")))
        stop("all arguments must be named")

    for (nm in names(arglist)) {
        elt <- arglist[[nm]]
        if (!is.null(dimnames(elt)))
            dimnames(elt) <- lapply(dimnames(elt), unname)
        assayData[[nm]] <- elt
    }
    if (storage.mode == "lockedEnvironment")
        assayDataEnvLock(assayData)
    msg <- assayDataValidMembers(assayData)
    if (!is.logical(msg)) stop(msg)
    assayData
}

assayDataValidMembers <- function(assayData, required) {
    msg <- NULL
    eltNames <-
      if ("list" == assayDataStorageMode(assayData)) names(assayData)
      else ls(assayData)
    if (!missing(required)) {
        absent <- required[!required %in% eltNames]
        if (length(absent) != 0)
          msg <- c(msg, paste0("'AssayData' missing '", absent ,"'" ,
                               collapse = "\n\t"))
    }
    dimsOk <-
      sapply(eltNames, function(elt)
             tryCatch(length(dim(assayData[[elt]]))>1,
                      error=function(err) FALSE))
    if (!all(dimsOk)) 
      msg <- c(msg, paste0("'AssayData' elements with invalid dimensions: '",
                           paste(eltNames[!dimsOk], collapse="' '"), "'"))
    if (length(assayData)>1) {
        eltRowNames <- rownames(assayData[[eltNames[[1]]]])
        rowNamesOk <- 
          all(sapply(eltNames[-1], function(elt)
                     all(eltRowNames == rownames(assayData[[elt]]))))
        if (!rowNamesOk)
          msg <- c(msg, "'AssayData' elements with different rowNames")
    }
    if (is.null(msg)) TRUE else msg
}

assayDataStorageMode <- function(object) {
  if (is(object, "list"))
    "list"
  else if (environmentIsLocked(object))
    "lockedEnvironment"
  else
    "environment"
}

setMethod("storageMode", "AssayData", assayDataStorageMode)

assayDataStorageModeReplace <- function(object, value) {
    storageMode <- assayDataStorageMode(object)
    if (storageMode == value) return(object)
    names <- if (storageMode == "list") names(object) else ls(object)
    switch(value,
           lockedEnvironment = {
               assayData <- new.env(parent=emptyenv())
               for (nm in names) assayData[[nm]] <- object[[nm]]
               assayDataEnvLock(assayData)
               assayData
           }, environment = {
               assayData <- new.env(parent=emptyenv())
               for (nm in names) assayData[[nm]] <- object[[nm]]
               assayData
           }, list = as.list(object))
}

setReplaceMethod("storageMode",
                 signature=c(object="AssayData", value="character"),
                 assayDataStorageModeReplace)

assayDataEnvLock <- function(assayData)
  lockEnvironment(assayData, bindings=TRUE)

assayDataSubsetElements <-
  function(object, elts, storageMode = assayDataStorageMode(object)) {
    if (any(duplicated(elts)))
      stop("'AssayData' element names must be unique")
    names <-
        if (storageMode(object)=="list") names(object)
        else ls(object)
    if (!all(elts %in% names))
      stop("'AssayData' missing elements: '",
           paste0(elts[!elts %in% names], collapse="', '"), "'")
    switch(storageMode,
           lockedEnvironment = {
               assayData <- new.env(parent = emptyenv())
               for (nm in elts) assayData[[nm]] <- object[[nm]]
               assayDataEnvLock(assayData)
               assayData
           },
           environment = {
               assayData <- new.env(parent = emptyenv())
               for (nm in elts) assayData[[nm]] <- object[[nm]]
               assayData
           },
           list = {
               object[elts]
           })
}

setMethod("assayData",
          signature=signature(object="AssayData"),
          function(object) object)

.assayDataDimnames <- function(assayData) {
    switch(storageMode(assayData), lockedEnvironment=, environment = {
        result <- vector("list", length(assayData))
        names(result) <- ls(assayData)
        for (nm in ls(assayData))
            result[[nm]] <- dimnames(assayData[[nm]])
        result
    }, list=lapply(assayData, dimnames))
}

setMethod("sampleNames", signature(object="AssayData"),
          function(object) {
              if (!length(object))
                return(character(0))
              safe.colnames <-
                function(x) if (ncol(x) == 0) character(0) else colnames(x)
              switch(assayDataStorageMode(object),
                     list=safe.colnames(object[[1]]),
                     safe.colnames(object[[ls(object)[1]]]))
          })

setReplaceMethod("sampleNames", signature(object="AssayData", value="list"),
    function(object, value) 
{
    .names_found_unique <- function(names, table)
    {
        ok <- !is.null(names) && all(names %in% table) && 
              !any(duplicated(names))
        if (!ok) {
            txt <- "'sampleNames' replacement list must have unique named elements
                    corresponding to assayData element names"
            stop(paste(strwrap(txt, exdent=2), colapse="\n"))
        }
    }
    mode <- assayDataStorageMode(object)
    switch(mode, lockedEnvironment = {
        .names_found_unique(names(value), ls(object))
        object <- copyEnv(object)
    }, environment = {
        .names_found_unique(names(value), ls(object))
    }, list= {
        .names_found_unique(names(value), names(object))
    })
    for (nm in names(value)) {
        dn <- dimnames(object[[nm]])
        if (is.null(dn))
            dn <- vector("list", length(dim(object[[nm]])))
        dn[[2]] <- value[[nm]]
        dimnames(object[[nm]]) <- dn
    }
    if (mode == "lockedEnvironment")
        assayDataEnvLock(object)
    object
})

setReplaceMethod("sampleNames", signature(object="AssayData", value="ANY"),
    function(object, value)
{
    mode <- assayDataStorageMode(object)
    dims <- switch(mode, lockedEnvironment=, environment = {
        result <- vector("list", length(object))
        names(result) <- ls(object)
        for (nm in ls(object))
            result[[nm]] <- ncol(object[[nm]])
        result
    }, list = {
        lapply(object, ncol)
    })
    
    if (length(dims)==0 && length(value) !=0)
        return(object)                    # early exit; no samples to name
    if (!all(dims==length(value))) {
        txt <- sprintf("'value' length (%d) must equal sample number in AssayData (%d)",
                       length(value), dims[[1]])
        stop(paste(strwrap(txt, exdent=2), collapse="\n"))
    }

    nms <- switch(mode, lockedEnvironment = {
        object <- copyEnv(object)
        ls(object)
    }, environment = ls(object), list = names(object))

    for (nm in nms) {
        dn <- dimnames(object[[nm]])
        if (is.null(dn))
            dn <- vector("list", length(dim(object[[nm]])))
        dn[[2]] <- value
        dimnames(object[[nm]]) <- dn
    }

    if (mode == "lockedEnvironment")
        assayDataEnvLock(object)
    object
})

setMethod("featureNames", signature(object="AssayData"),
          function(object) {
              if (!length(object))
                return(character(0))
              safe.rownames <-
                function(x) if (nrow(x) == 0) character(0) else rownames(x)
              switch(assayDataStorageMode(object),
                     list=safe.rownames(object[[1]]),
                     safe.rownames(object[[ls(object)[1]]]))
          })

setReplaceMethod("featureNames", signature(object="AssayData", value="ANY"),
    function(object, value) 
{
    mode <- assayDataStorageMode(object)
    dims <- switch(mode, lockedEnvironment=, environment = {
        result <- vector("list", length(object))
        names(result) <- ls(object)
        for (nm in ls(object)) result[[nm]] <- nrow(object[[nm]])
        result
    }, list = lapply(object, nrow))
    if (length(dims)==0 && length(value) !=0)
        return(object)                    # early exit; no features to name
    if (!all(dims==length(value))) {
        txt <- sprintf("'value' length (%d) must equal feature number in AssayData (%d)",
                       length(value), dims[[1]])
        stop(paste(strwrap(txt, exdent=2), collapse="\n"))
    }

    nms <- switch(mode, lockedEnvironment = {
        object <- copyEnv(object)
        ls(object)
    }, environment = ls(object), list=names(object))

    for (nm in nms) {
        dn <- dimnames(object[[nm]])
        if (is.null(dn))
            dn <- vector("list", length(dim(object[[nm]])))
        dn[[1]] <- value
        dimnames(object[[nm]]) <- dn
    }

    if (mode == "lockedEnvironment")
        assayDataEnvLock(object)
    object
})

setMethod("combine", c("AssayData", "AssayData"), function(x, y, ...) {
    storage.mode <- assayDataStorageMode(x)
    nmfunc <- if ("environment"==class(x)) ls else names

    if (assayDataStorageMode(y) != storage.mode)
      stop("assayData must have same storage, but are '",
           storage.mode, "', '", assayDataStorageMode(y))
    if (length(nmfunc(x)) != length(nmfunc(y)))
      stop("assayData have different numbers of elements:\n\t",
           paste(nmfunc(x), collapse=" "), "\n\t",
           paste(nmfunc(y), collapse=" "))
    if (!all(nmfunc(x) == nmfunc(y)))
      stop(paste("assayData have different element names:",
                 paste(nmfunc(x), collapse=" "),
                 paste(nmfunc(y), collapse=" "), sep="\n\t"))
    if ("list" == storage.mode) {
        aData <- lapply(names(x), function(nm) combine(x[[nm]],y[[nm]]))
        names(aData) <- names(x)
    } else {
        aData <- new.env(parent=emptyenv())
        for (nm in ls(x)) aData[[nm]] <- combine(x[[nm]], y[[nm]])
        if ("lockedEnvironment" == storage.mode) assayDataEnvLock(aData)
    }
    aData
})

assayDataDim <- function(object) {
  nms <- if (assayDataStorageMode(object) == "list") names(object) else ls(object)
  if ( length( nms ) == 0 ) return( NA )
  d <- dim( object[[ nms[[1]] ]])
  names(d) <- c( "Features", "Samples", rep("...", max(length(d)-2, 0)))
  d
}

##FIXME: RG says I don't know if you should ignore non-matrix objects or
## not -  for now I have put in an informative error message
assayDataDims <- function(object) {
  nms <- if (assayDataStorageMode(object) == "list") names(object) else ls(object)
  if (length(nms) == 0)
    return(matrix(integer(0), nrow = 2, ncol = 0, 
                  dimnames = list(c("Features", "Samples"), character(0))))
  d <- sapply(nms, function(i) dim(object[[i]]))
  rownames(d) <- c("Features", "Samples", rep("...", nrow(d)-2))
  colnames(d) <- nms
  d[,order(colnames(d)), drop=FALSE]
}

# ==========================================================================
# Biobase package initialization
# ==========================================================================
.onLoad <- function(libname, pkgname) {
    ## need contents to load at library attach - not at build time
    .initContents() ## in environment.R
    .buildBiobaseOpts() ## in environment.R
}

.onAttach <- function(libname, pkgname) {
    msg0 <- "Vignettes contain introductory material; view with
             'browseVignettes()'. To cite Bioconductor, see
             'citation(\"Biobase\")', and for packages
             'citation(\"pkgname\")'."
    msg <- strwrap(paste(msg0, collapse=""), exdent=4, indent=4)
    packageStartupMessage(paste(c("Welcome to Bioconductor\n", msg),
                                collapse="\n"), "\n")
    addVigs2WinMenu("Biobase") 
}

.onUnload <- function( libpath ) {
  library.dynam.unload( "Biobase", libpath )
}

setMethod("initialize", signature(.Object="AnnotatedDataFrame"),
          function(.Object, data = data.frame(), varMetadata = data.frame(),
                   ...)
{
    tryCatch({
        if (missing(varMetadata)) {
            if (!missing(data)) checkClass(data, "data.frame", class(.Object))
            varMetadata <- data.frame(
                labelDescription = rep.int(NA_character_, ncol(data)),
                stringsAsFactors = FALSE
            )
            row.names(varMetadata) <- as.character(colnames(data))
        } else {
            checkClass(varMetadata, "data.frame", class(.Object))
            if (!"labelDescription" %in% colnames(varMetadata))
                varMetadata[["labelDescription"]] <-
                    rep.int(NA_character_, nrow(varMetadata))
            row.names(varMetadata) <- names(data)
        }
        varMetadata[["labelDescription"]] <-
            as.character(varMetadata[["labelDescription"]])
    }, error=function(err) {
        stop(conditionMessage(err),
             "\n  AnnotatedDataFrame 'initialize' could not update varMetadata:",
             "\n  perhaps pData and varMetadata are inconsistent?")
    })
    callNextMethod(.Object, data=data, varMetadata=varMetadata, ...)
})

validAnnotatedDataFrame <- function( object ) 
{
    msg <- NULL
    if (!is(object, "AnnotatedDataFrame"))
        msg <- c(msg, paste("cannot validate", class(object),
                            "as AnnotatedDataFrame" ))
    if (length(row.names(varMetadata(object))) !=
        length(colnames(pData(object))))
        msg <- c(msg, paste("all AnnotatedDataFrame pData column names",
                            "must be present as rows in varMetadata",
                            "and vice versa"))
    else if (any(row.names(varMetadata(object)) != colnames(pData(object))))
      msg <- c(msg, paste("AnnotatedDataFrame colnames of data differ",
                          "from row.names of varMetadata"))
    if ( !("labelDescription" %in% colnames(varMetadata(object))))
      msg <- c(msg, paste("AnnotatedDataFrame varMetadata",
                          "missing labelDescription column"))
    if (length(dimLabels(object))!=2)
      msg <- c(msg, "dimLabels must be a character vector of length 2")
    if (is.null(msg)) TRUE else msg
}

setValidity("AnnotatedDataFrame", validAnnotatedDataFrame)

setAs("AnnotatedDataFrame", "data.frame", function(from) {
    pData(from)
})

setMethod("updateObject", signature(object="AnnotatedDataFrame"),
          function(object, ..., verbose=FALSE) {
              if (verbose) message("updateObject(object = 'AnnotatedDataFrame')")
              object <- asS4(object)
              if (isVersioned(object) && isCurrent(object)["AnnotatedDataFrame"])
                callNextMethod()
              else {
                  ## version 1.0.0. -> 1.1.0 needs a new slot "dimLabels"
                  to <- new(class(object))
                  varMetadata(to) <- updateObject(varMetadata(object))
                  pData(to) <- updateObject(pData(object))
                  to
              }
          })

annotatedDataFrameFromMatrix <- function(object, byrow=FALSE, ...) {
    ## contract: 'object' is matrix-like, with dim, rownames, colnames
    ## methods. Returns AnnotatedDataFrame with appropriate dimensions.
    dims <- dim(object)
    if (is.null(dims) || all(dims==0))
        annotatedDataFrameFrom(NULL, byrow=byrow, ...)
    else {
        n <- if (byrow) dims[1] else dims[2]
        nms <-
            if(byrow) rownames(object)
            else colnames(object)
        data <- data.frame(numeric(n), row.names=nms)[,FALSE]
        dimLabels <-
            if (byrow) c("featureNames", "featureColumns")
            else c("sampleNames", "sampleColumns")
        AnnotatedDataFrame(data=data, dimLabels=dimLabels)
    }
}

setMethod("annotatedDataFrameFrom",
          signature(object="matrix"),
          annotatedDataFrameFromMatrix)

annotatedDataFrameFromNull <- function(object, byrow=FALSE, ...) {
    dimLabels <-
        if (byrow) c("featureNames", "featureColumns")
        else c("sampleNames", "sampleColumns")
    AnnotatedDataFrame(data=data.frame(), dimLabels=dimLabels)
}

setMethod("annotatedDataFrameFrom",
          signature(object="NULL"),
          annotatedDataFrameFromNull)

annotatedDataFrameFromAssayData <- function(object, byrow=FALSE, ...) {
    eltNames <-
        if (is(object, "environment")) ls(object)
        else names(object)
    if (length(eltNames)==0)
        annotatedDataFrameFrom(NULL, byrow=byrow, ...)
    else
        annotatedDataFrameFrom(object[[eltNames[1]]], byrow=byrow, ...)
}

setMethod("annotatedDataFrameFrom",
          signature(object="AssayData"),
          annotatedDataFrameFromAssayData)

head.AnnotatedDataFrame <- function(x, n=6L, ...) {
    ## essentially, utils:::head.data.frame
    stopifnot(length(x) == 1L)
    n <- if (n < 0L) {
        max(nrow(x) + n, 0L)
    } else min(n, nrow(x))
    x[seq_len(n), ]
}

tail.AnnotatedDataFrame <- function(x, n=6L, ...) {
    ## essentially, utils:::tail.data.frame
    stopifnot(length(x) == 1L)
    nrx <- nrow(x)
    n <- if (n < 0L) 
        max(nrx + n, 0L)
    else min(n, nrx)
    x[seq.int(to = nrx, length.out = n), , drop = FALSE]
}

setMethod("dimnames", "AnnotatedDataFrame", function(x) {
    dimnames(pData(x))
})

setReplaceMethod("dimnames", "AnnotatedDataFrame", function(x, value) {
    sampleNames(x) <- value[[1]]
    varLabels(x) <- value[[2]]
    x
})

setMethod("dim", "AnnotatedDataFrame", function( x ) {
  d <- dim(pData(x))
  names(d) <- dimLabels(x)
  d
})

setMethod("dimLabels", "AnnotatedDataFrame", function(object) {
    object@dimLabels
})

setReplaceMethod("dimLabels",
                 signature=signature(
                   object="AnnotatedDataFrame",
                   value="character"),
                 function(object, value) {
                     object@dimLabels <- value
                     object
                 })

setMethod("pData", "AnnotatedDataFrame", function(object) object@data)

setReplaceMethod("pData",
                 signature=signature(
                   object="AnnotatedDataFrame",
                   value="data.frame"),
                 function(object, value) {
                     idx <- match(names(value), rownames(varMetadata(object)))
                     varMetadata <- varMetadata(object)[idx,,drop=FALSE]
                     row.names(varMetadata) <- names(value)
                     initialize(object, data=value, varMetadata=varMetadata)
                 })

setMethod("sampleNames", "AnnotatedDataFrame",
    function(object) row.names(object@data))

setReplaceMethod("sampleNames",
    signature(object="AnnotatedDataFrame", value="ANY"),
    function(object, value) 
{
    if (!is.null(value) && (length(value) != dim(object@data)[[1]]))
        stop("number of new names (", length(value), ") ",
             "should equal number of rows in AnnotatedDataFrame (",
             dim( object )[[1]], ")")
    row.names(object@data) <- value
    object
})

setMethod("featureNames",
          signature(object="AnnotatedDataFrame"),
          function(object) sampleNames(object))

setReplaceMethod("featureNames",
                 signature(object="AnnotatedDataFrame", value="ANY"),
                 function(object, value) {
                     sampleNames(object) <- value
                     object
                 })

setMethod("varLabels", "AnnotatedDataFrame", function(object) colnames(object@data))

setReplaceMethod("varLabels",
    signature("AnnotatedDataFrame", "ANY"),
    function(object, value) 
{
    if (!is.null(value) && (length(value) != dim(object@data)[[2]]))
        stop("number of new varLabels (", length(value), ") ",
             "should equal number of columns in AnnotatedDataFrame (",
             dim(object)[[2]], ")")
    if (!is.null(value)) {
        ## silently ignore attempts to set colnames to NULL
        colnames(object@data) <- value
        row.names(object@varMetadata) <- value
    }
    object
})

setMethod("varMetadata", "AnnotatedDataFrame",
          function(object) object@varMetadata )

setReplaceMethod("varMetadata", c("AnnotatedDataFrame", "data.frame"),
                 function(object, value)
{
    if (!("labelDescription" %in% colnames(value)))
        warning("'varMetadata' must have column 'labelDescription'")
    rinfo <- .row_names_info(value)
    if (0L != length(varLabels(object))) {
        if (0L <= rinfo) {
            ## not 'automatic'
            bad <- setdiff(row.names(value), varLabels(object))
            if (0L != length(bad)) {
                fmt <- "'%s' not in 'varLabels(<AnnotatedDataFrame>)'"
                nms <- paste(selectSome(bad), collapse="', '")
                stop(sprintf(fmt, nms))
            }
        }
        if (ncol(object) != abs(rinfo)) {
            fmt <- "varMetadata has %d row(s), 'value' has %d"
            stop(sprintf(fmt, ncol(object), nrow(value)))
        }
        if (0 < ncol(pData(object)))
            row.names(value) <- names(pData(object))
    }
    object@varMetadata <- value
    object
})

setMethod("[",
          signature(x="AnnotatedDataFrame"),
          function(x, i, j, ..., drop) {
              if (missing(drop)) drop = FALSE
              else if (drop)
                stop("'AnnotatedDataFrame' does not support drop = TRUE")
              if(missing(j)) {
                  mD <- x@varMetadata
                  pD <- x@data[i,,drop = drop]
              } else {
                  mD <- x@varMetadata[j,,drop = drop]
                  if( missing( i ))
                    pD <- x@data[,j,drop = drop]
                  else
                    pD <- x@data[i,j,drop = drop]
              }
              initialize(x, data=pD, varMetadata=mD)
          })

##setMethod("$", "AnnotatedDataFrame", function(x, name) `$`(pData(x), name))
setMethod("$", "AnnotatedDataFrame", function(x, name) {
    eval(substitute(pData(x)$NAME_ARG, list(NAME_ARG=name)))
})

setReplaceMethod("$", "AnnotatedDataFrame", function(x, name, value) {
    x[[name]] <- value
    x
})

setMethod("[[", "AnnotatedDataFrame", function(x, i, j, ...) pData(x)[[i]] )

setReplaceMethod("[[",
                 signature=signature(x="AnnotatedDataFrame"),
                 function(x, i, j, ..., value) {
                     pData(x)[[i]] <- value
                     for (metadata in names(list(...)))
                       varMetadata(x)[i, metadata] <- list(...)[[metadata]]
                     x
                 })

setAs("phenoData", "AnnotatedDataFrame", function(from) {
  from <- asS4(from)
  ## data
  data <- from@pData
  ## varMetadata
  cnames <- colnames(data)
  varMetadata <- from@varMetadata
  if (all(dim(varMetadata)==0)) {
    varMetadata <- data.frame(numeric(length(cnames)),row.names=cnames)[,FALSE]
  }
  ## varLabels -- as column in varMetadata,or warn
  varLabels <- from@varLabels
  if (length(varLabels)>0 && !("labelDescription" %in% colnames(varMetadata)))
    varMetadata[["labelDescription"]] <- as.character(varLabels[cnames])
  else if (length(varLabels)>0)
    warning("contents of varLabels ignored\n", call.=FALSE)
  else
    varMetadata[["labelDescription"]] <- rep.int(NA_character_, nrow(varLabels))
  AnnotatedDataFrame(
      data=data,
      varMetadata=varMetadata,
      dimLabels=c("sampleNames", "sampleColumns"))
})

setAs("data.frame", "AnnotatedDataFrame",
      function(from) AnnotatedDataFrame(data=from))
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
selectSome <- function(obj, maxToShow=5) {
  len <- length(obj)
  if (maxToShow<3) maxToShow <- 3
  if (len > maxToShow) {
      maxToShow <- maxToShow-1
      bot <- ceiling(maxToShow/2)
      top <- len-(maxToShow-bot-1)
      nms <- obj[c(1:bot, top:len)]
      c(as.character(nms[1:bot]), "...", as.character(nms[-c(1:bot)]))
  }
  else if (is.factor(obj))
      as.character(obj)
  else obj
}

setMethod("selectSomeIndex",
          signature(object="data.frame"),
          function(object, maxToShow=5, byrow=TRUE, ...) {
              len <-
                if (byrow) dim(object)[[1]]
                else dim(object)[[2]]
              if (maxToShow < 3) maxToShow <- 3
              if (len > maxToShow) {
                  maxToShow <- maxToShow - 1
                  bot <- ceiling(maxToShow/2)
                  top <- len-(maxToShow-bot-1)
                  list(1:bot, "...", top:len)
              } else if (len >= 1) list(1:len, NULL, NULL)
              else list(NULL, NULL, NULL)
          })


.wrapcat <-
    function(lbl, nms, total, ..., indent=2, exdent=4)
{
    lbl <- sprintf("%s:", lbl)
    txt <- paste(c(lbl,  nms), collapse=" ")
    ext <-
        if (length(nms) < total) sprintf("(%d total)", total)
        else character()
    txt <- paste(c(lbl,  nms, ext), collapse=" ")
    cat(strwrap(txt, ..., indent=indent, exdent=exdent), sep="\n")
}

.showAnnotatedDataFrame <-
    function(object, labels=list(0)) 
{
    lbls <- list(object=paste0("An object of class '", class(object), "'"),
                 sampleNames=dimLabels(object)[[1]],
                 varMetadata="varMetadata",
                 varLabels="varLabels")
    lbls[names(labels)] <- labels
    if (ncol(object) == 0) {            # early exit for empty objects
        cat(lbls[["object"]], ": none\n", sep="")
        return()
    }
    ## create a simplified object for extracting names
    idx <- selectSomeIndex(pData(object), maxToShow=4)
    idy <- selectSomeIndex(pData(object), byrow=FALSE, maxToShow=4)
    pData <- pData(object)[c(idx[[1]], idx[[3]]), c(idy[[1]], idy[[3]]),
                           drop=FALSE]
    rnms <- rownames(pData)
    nms <- c(rnms[idx[[1]]], idx[[2]],
             if (!is.null(idx[[1]])) rnms[-idx[[1]]] else NULL)

    cat(lbls$object, "\n", sep="")
    .wrapcat(lbls$sampleNames, nms, nrow(object))

    cnms <- colnames(pData)
    if (length(cnms) > 0) {
        vars <- c(cnms[idy[[1]]], idy[[2]], cnms[-idy[[1]]])
        .wrapcat(lbls$varLabels, vars, ncol(object))

        mnms <- selectSome(colnames(varMetadata(object)), maxToShow=4)
        .wrapcat(lbls$varMetadata, mnms, length(mnms))
    } else cat("\n  ", lbls$varLabels, ": none", sep="")
}

setMethod("show",
          signature=signature(object="AnnotatedDataFrame"),
          function(object) .showAnnotatedDataFrame(object))

setMethod("combine",
          signature(x="AnnotatedDataFrame", y="AnnotatedDataFrame"),
          function(x, y) {
              if (class(x) != class(y)) {
                  fmt <- "'%s' objects have diffrenent classes '%s', '%s'"
                  txt0 <- "combine,AnnotatedDataFrame,AnnotatedDataFrame-method"
                  stop(sprintf(fmt, txt0, class(x), class(y)))
              }
              if (!identical(dimLabels(x),dimLabels(y))) {
                  fmt <- paste("AnnotatedDataFrame dimLabels differ:\n",
                               "    %s\n",
                               "    %s\n  try 'updateObject'?")
                  stop(sprintf(fmt, paste(dimLabels(x), collapse=", "),
                               paste(dimLabels(y), collapse=", ")))
              }

              pDataX <- pData(x)
              pDataY <- pData(y)
              pData <- combine(pDataX, pDataY)

              varMetadataX <- varMetadata(x)
              varMetadataY <- varMetadata(y)
              ## labelDescription is required, likely a factor with
              ## conflicting levels
              if (is.factor(varMetadataX$labelDescription) &&
                  is.factor(varMetadataY$labelDescription)) {
                  f <- factor(c(as.character(varMetadataX$labelDescription),
                                as.character(varMetadataY$labelDescription)))
                  varMetadataX$labelDescription <-
                    factor(as.character(varMetadataX$labelDescription), levels=levels(f))
                  varMetadataY$labelDescription <-
                    factor(as.character(varMetadataY$labelDescription), levels=levels(f))
                }
              vM <- combine(varMetadataX, varMetadataY)

              initialize(x, data=pData, varMetadata=vM)
          })


read.AnnotatedDataFrame <-
    function(filename, path, sep = "\t", header = TRUE, quote = "",
             stringsAsFactors = FALSE, row.names = 1L,
             varMetadata.char="#", widget =
             getOption("BioC")$Base$use.widgets, sampleNames =
             character(0), ...)
{
    
    if(!(is.character(varMetadata.char) &&
         (identical(nchar(varMetadata.char), 1L))))
        stop("Invalid  'varMetadata.char'")

    ## For backward (or forward?) compatibility:
    if(widget)
        stop("Sorry: tkWidgets is not available for read.AnnotatedDataFrame")

    if(length(sampleNames)>0)
        stop("'sampleNames' argument is not supported, provide the sample",
             "names in the input file and use the option 'row.names'.")

    if(!missing(path))
        filename = file.path(path, filename)
    pData = read.table(filename, sep=sep, header=header, quote=quote,
      stringsAsFactors=stringsAsFactors, 
      row.names=row.names, comment.char=varMetadata.char, ...)
    
    ## read varMetadata section (the lines with leading "#")
    vmd = grep(paste0("^",  varMetadata.char),
      readLines(filename), value=TRUE)
    svmd = strsplit(vmd, ": *")
    varNames = sub("^# *", "", sapply(svmd, "[", 1L))
    varMetad = sapply(svmd, "[", 2L)

    ## link varMetadata names with pData colnames
    mt = match(colnames(pData), varNames)
    varMetad = ifelse(!is.na(mt), varMetad[mt], "")

    vmd = data.frame(labelDescription=varMetad, row.names=colnames(pData))

    ## add provenance information. Alapping it on as an attribute is a
    ## bit tacky, if Martin likes the idea at all, maybe this can be
    ## made a proper slot...
    provenance = sprintf("Read from file %s on %s at %s.",
      filename, Sys.info()["nodename"], date())
    attr(vmd, "provenance") = provenance
    
    AnnotatedDataFrame(data=pData, varMetadata=vmd)
    
}

write.AnnotatedDataFrame <-
    function(x, file="", varMetadata.char="#", ..., append=FALSE,
             fileEncoding="")
{
    ## file handling from write.table
    if (file == "") 
        file <- stdout()
    else if (is.character(file)) {
        file <- if (nzchar(fileEncoding)) 
            file(file, ifelse(append, "a", "w"), encoding = fileEncoding)
        else file(file, ifelse(append, "a", "w"))
        on.exit(close(file))
    } else if (!isOpen(file, "w")) {
        open(file, "w")
        on.exit(close(file))
    }
    if (!inherits(file, "connection")) 
        stop("'file' must be a character string or connection")

    writeLines(sprintf("%s %s: %s", varMetadata.char, varLabels(x),
                       varMetadata(x)$labelDescription),
               file)
    write.table(pData(x), file, append=append, fileEncoding=fileEncoding,
                ...)
}

setMethod("AnnotatedDataFrame",
          signature(data="missing", varMetadata="missing"),

    function(data, varMetadata, dimLabels=c("rowNames", "columnNames"), ...)
{
    .AnnotatedDataFrame(data=data.frame(), varMetadata=data.frame(),
                        dimLabels=dimLabels, ...)
})

setMethod("AnnotatedDataFrame",
          signature(data="data.frame", varMetadata="missing"),
    function(data, varMetadata,
             dimLabels=c("rowNames", "columnNames"), ...)
{
    varMetadata <- data.frame(
        labelDescription = rep.int(NA_character_, ncol(data)),
        stringsAsFactors = FALSE
    )
    row.names(varMetadata) <- names(data)
    .AnnotatedDataFrame(data=data, varMetadata=varMetadata,
                        dimLabels=dimLabels, ...)
})

setMethod("AnnotatedDataFrame",
           signature(data="data.frame", varMetadata="data.frame"),
    function(data, varMetadata,
             dimLabels=c("rowNames", "columnNames"), ...)
{
    if (!"labelDescription" %in% colnames(varMetadata))
        varMetadata[["labelDescription"]] <-
            rep.int(NA_character_, nrow(varMetadata))
    row.names(varMetadata) <- names(data)
    varMetadata[["labelDescription"]] <-
        as.character(varMetadata[["labelDescription"]])
    .AnnotatedDataFrame(data=data, varMetadata=varMetadata,
                        dimLabels=dimLabels, ...)
})

setMethod("initialize",
          signature(.Object="aggregator"),
          function(.Object, aggenv=new.env(hash=TRUE), ...) {
              callNextMethod(.Object, aggenv=aggenv, ...)
          })
# ==========================================================================
setMethod("aggenv", "aggregator", function(object) object@aggenv)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
setMethod("initfun", "aggregator", function(object) object@initfun)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
setMethod("aggfun", "aggregator", function(object) object@aggfun)
# ==========================================================================
Aggregate <- function(x, agg) {
   if( !is(agg, "aggregator") )
      stop("second argument must be an aggregator")
   if( is.null(x) || length(x) == 0 )
      return()
   if(is.character(x)) {
      for( i in 1:length(x) ) {
         nm <- x[i]
         if( !exists(nm, envir=aggenv(agg), inherits=FALSE) )
            assign(nm, envir=aggenv(agg), initfun(agg)(nm, x))
         else {
            v1 <- get(nm, envir=aggenv(agg))
            assign(nm, aggfun(agg)(nm, v1), envir=aggenv(agg))
         }
      }
   }
   else
      if(is.list(x)) {
         nms <- names(x)
         for( i in 1:length(x) ) {
            nm <- nms[i]
            if( !exists(nm, envir=aggenv(agg), inherits=FALSE) )
               assign(nm, envir=aggenv(agg), initfun(agg)(nm, x[[i]]))
            else {
               v1 <- get(nm, envir=aggenv(agg))
               assign(nm, envir=aggenv(agg), aggfun(agg)(nm, v1, x[[i]]))
            }
         }
      }
      else
         stop("bad type for Aggregate")
}
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

## ==========================================================================
## Versions: version string information
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## methods and class defined together so available for prototypes elsewhere

.Versions <- setClass("Versions", contains="list")

setMethod("initialize", signature(.Object="Versions"),
          function(.Object, ...) callNextMethod(.Object, .asValidVersions(list(...))))

.isValidVersion <- function(versions) {
    tryCatch(all(as.integer(versions)==versions) &&
             all(versions >= 0) &&
             length(versions) > 1,
             error=function(err) FALSE,
             warning=function(warn) {})
}

.asValidVersions <- function(versions) {
    res <- list()
    for (i in seq(along.with=versions))
      res[i] <-
        if (!is.character(versions[[i]]) &&
            .isValidVersion(versions[[i]]))
            versions[i]
        else
            unclass(numeric_version(versions[[i]]))
    names(res) <- names(versions)
    res
}

## update

setMethod("updateObject", signature(object="Versions"),
          function(object, ..., verbose=FALSE) {
              if (verbose) message("updateObject(object = 'Versions')")
              if (!isS4(object)) do.call(new, c("Versions", object))
              else object
      })

## access

setMethod("[",
          signature=signature(x="Versions"),
          function(x, i, j, ..., drop = FALSE) {
              ## 'dispatch' on i to avoid S4 complaint about j 'missing'
              if (is(i, "character") &&
                  !all(i %in% names(x))) {
                  bad <- unique(i[!i %in% names(x)])
                  cl <- deparse(match.call()[[2]])
                  stop(sprintf("'[' indices '%s' not found in '%s'",
                               paste(bad, collapse="', '"),
                               cl))
              }
              as(callNextMethod(), "Versions")
          })

## assign

setReplaceMethod("[", signature(x="Versions"),
                 function(x, i, j, value) {
                     lst <- x@.Data
                     names(lst) <- names(x)
                     lst[i] <- .asValidVersions(value)
                     x@.Data <- lst
                     names(x) <- names(lst)
                     x
                 })

setReplaceMethod("[[", signature(x="Versions"),
                 function(x, i, j, value) {
                     lst <- x@.Data
                     names(lst) <- names(x)
                     lst[[i]] <- unlist(.asValidVersions(value))
                     x@.Data <- lst
                     names(x) <- names(lst)
                     x
                 })

setReplaceMethod("$", signature(x="Versions"),
                 function(x, name, value) { x[[name]] <- value; x })

## Compare

.as.numeric_version <- function(x)
    numeric_version(as(x, "character"))
    
.canVersionCompare <- function(e1, e2) {
    if (length(e1) != length(e2))
        stop(sprintf("cannot compare versions with length '%d', '%d'",
                     length(e1), length(e2)))
    if (length(e1)>1 &&
        (!all(names(e1) %in% names(e2)) ||
         !all(names(e2) %in% names(e1))))
        stop("cannot compare versions with different names")
    TRUE
}

setMethod("Compare",
          signature=signature(
            e1="Versions",
            e2="Versions"),
          function(e1, e2) {
              .canVersionCompare(e1, e2)
              e2 <- e2[names(e1)]
              e1 <- .as.numeric_version(e1)
              e2 <- .as.numeric_version(e2)
              callNextMethod(e1, e2)
          })

setMethod("Compare",
          signature=signature(
            e1="Versions",
            e2="character"),
          function(e1, e2) {
              .canVersionCompare(e1, e2)
              if (length(e2) > 1)
                  e2 <- e2[names(e1)]
              e1 <- .as.numeric_version(e1)
              e2 <- numeric_version(e2)
              callNextMethod(e1, e2)
          })

setMethod("Compare",
          signature=signature(
            e1="character",
            e2="Versions"),
          function(e1, e2) callGeneric(e2,e1))

## show

setAs("Versions", "character",
      function(from) {
          if (length(from)) sapply(from, paste, collapse=".")
          else "Versioned; no version string"
      })

setMethod("show", signature(object="Versions"),
          function(object) print(as(object, "character")))

setGeneric("rowMedians", function(x, na.rm=FALSE, ...) {
  # Backward compatibility for rowMedians(imat=...)
  if (missing(x)) {
    args <- list(...);
    if (is.element("imat", names(args))) {
      x <- args$imat;
      .Deprecated(msg="The name of the matrix argument for Biobase::rowMedians() has been changed from 'imat' to 'x'.");
    }
  }
  standardGeneric("rowMedians")
})


setMethod("rowMedians", signature(x="matrix"), function(x, na.rm=FALSE, ...) {
  na.rm <- as.logical(na.rm);
  hasNAs <- TRUE;  # Add as an argument? /2007-08-24
  .Call("rowMedians", x, na.rm, hasNAs, TRUE, PACKAGE="Biobase");
})


setMethod("rowMedians", signature(x="ExpressionSet"), function(x, na.rm=FALSE, ...) {
  rowMedians(exprs(x), na.rm=na.rm, ...);
})


setGeneric("rowQ", function(imat, which) standardGeneric("rowQ"))


setMethod("rowQ", signature(imat="matrix", which="numeric"),
          function(imat, which) {
              if (any(is.na(imat)))
                stop("cannot handle missing values.")
              if (length(which) != 1 || !is.finite(which))
                stop("'which' must be length one and finite numeric")
              if(is.integer(imat))
                  imat <- structure(as.numeric(imat), dim=dim(imat))
              .Call("rowQ", imat, which, PACKAGE="Biobase")
          })


setMethod("rowQ", signature(imat="ExpressionSet", which="numeric"),
          function(imat, which) rowQ(exprs(imat), which))


rowMin <- function(imat)
   rowQ(imat, 1)


rowMax <- function(imat)
   rowQ(imat, ncol(imat))

## ==========================================================================
## Versioned: mix-in class to add version information
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

## initialize -- see VersionedClasses

setMethod("initialize", signature(.Object="Versioned"),
          function(.Object, versions = list(), ...) {
              .Object <- callNextMethod(.Object, ...)
              classVersion(.Object)[names(versions)] <- versions
              .Object
          })

## validity

setValidity("Versioned", function(object) {
    msg <- NULL
    if (!isVersioned(object))
      msg <- validMsg(msg, "missing version string")
    if (is.null(msg)) TRUE else msg
})

isValidVersion <- function(object, nm) {# utility
    msg <- NULL
    if (!isS4(object))
      msg <- validMsg(msg, "not an S4 object")
    if (isVersioned(object) && !all(isCurrent(object)[nm])) {
        vers <- isCurrent(object)[nm]
        vers[is.na(vers)] <- FALSE
        names(vers) <- nm
        bad <- names(vers[vers==FALSE])
        msg <- validMsg(msg, paste0("out-of-date class version '", bad, "'"))
    }
    msg
}

##  isVersioned

setMethod("isVersioned", signature(object="ANY"),
          function(object) FALSE)

setMethod("isVersioned", signature(object="character"),
          function(object) {
              ## need to check getNamespace("Biobase") during Biobase installation
              length(object) > 0 && nchar(object)>0 &&
              (isClass(object) ||
               isClass(object, where=getNamespace("Biobase"))) &&
              extends(getClass(object), "Versioned")
      })

setMethod("isVersioned", signature(object="Versioned"),
          function(object) ".__classVersion__" %in% names(attributes(object)))

## classVersion

setMethod("classVersion", signature(object="ANY"),
          function(object) .VersionsNull())

setMethod("classVersion", signature(object="character"),
          function(object) {
              if (isVersioned(object))
                attr(getClass(object)@prototype, ".__classVersion__")
              else callNextMethod()
          })

setMethod("classVersion", signature(object="Versioned"),
          function(object) {
              if (isVersioned(object)) {
                  if (isS4(object@.__classVersion__))
                      object@.__classVersion__
                  else
                      ## force update to S4 instance
                      ## user needs to recognize need for update
                      updateObject(object@.__classVersion__)
              }
              else callNextMethod()
          })

setReplaceMethod("classVersion", signature(object="Versioned", value="Versions"),
                 function(object, value) {
                     object@.__classVersion__ <- value
                     object
                 })
## isCurrent

setMethod("isCurrent", signature(object="ANY"), function(object, value) NA)

setMethod("isCurrent", signature(object="Versioned", value="missing"),
          function(object, value) isCurrent(object, class(object)))

setMethod("isCurrent", signature(object="Versioned", value="character"),
          function(object, value) {
             # vers <- classVersion(value)
             # if(!all(names(vers) %in% names(classVersion(object)))) {
             #     res <- FALSE
             #     names(res) <- value 
             #     return(res)
             # }
              vers <- classVersion(value)
              if (extends(class(object),value) && 
                          isVersioned(object) &&
                          all(names(vers) %in% names(classVersion(object)))) {
                  res <- classVersion(object)[names(vers)] == vers
                  names(res) <- names(vers)
              } else {
                  res <- FALSE
                  names(res) <- value
              }
              res <- c(S4=isS4(object), res)
              res
          })

## show

setMethod("show", signature(object="Versioned"),
          function(object) callNextMethod())

mkScalar <- function(obj) {
    switch(typeof(obj),
           character=.ScalarCharacter(obj),
           logical=.ScalarLogical(obj),
           integer=.ScalarInteger(obj),
           double=.ScalarNumeric(obj),
           stop("no scalar class implemented for type: ", typeof(obj)))
}

setMethod("show", "ScalarObject",
          function(object) {
              cat(object, "\n")
          })

setMethod("show", "ScalarCharacter",
          function(object) {
              if (is.na(object))
                  cat(NA, "\n")
              else
                  cat(sprintf('"%s"\n', object))
          })

NChannelSet <- .NChannelSet

.init_NChannelSet <-              # copy constructor, validation
    selectMethod(initialize, "ANY")

setMethod("initialize", "NChannelSet",
    function(.Object, assayData, phenoData, ...)
{
    mySlots <- slotNames(.Object)
    dotArgs <- list(...)
    isSlot <- names(dotArgs) %in% mySlots
    if (missing(assayData)) {
        assayData <- do.call(assayDataNew, dotArgs[!isSlot],
                             envir=parent.frame())
    }
    if (missing(phenoData)) {
        phenoData <- annotatedDataFrameFrom(assayData, byrow=FALSE)
    }
    if (is.null(varMetadata(phenoData)[["channel"]])) {
        varMetadata(phenoData)[["channel"]] <- 
            factor(rep("_ALL_", nrow(varMetadata(phenoData))),
                   levels=c(assayDataElementNames(assayData), "_ALL_"))
    }
    ## ensure sample names OK -- all assayData with names;
    ## phenoData with correct names from assayData
    nms <- if (storageMode(assayData) == "list")
        names(assayData)
    else
        ls(assayData)
    assaySampleNames <- vector("list", length(nms))
    names(assaySampleNames) <- nms
    for (nm in nms) {
        cnames <- colnames(assayData[[nm]])
        assaySampleNames[[nm]] <- if (is.null(cnames)) {
            sampleNames(phenoData)
        } else cnames
    }

    sampleNames(assayData) <- assaySampleNames
    sampleNames(phenoData) <- sampleNames(assayData)
    do.call(callNextMethod,
            c(.Object,
              assayData = assayData, phenoData = phenoData,
              dotArgs[isSlot]))
})

.invalid_NChannelAssayNames <- function(object)
{
    phenoChannels <- levels(varMetadata(object)[["channel"]])
    assayChannels <- c("_ALL_", assayDataElementNames(object))
    setdiff(union(assayChannels, phenoChannels),
            intersect(assayChannels, phenoChannels))
}

setValidity("NChannelSet",
    function(object) 
{
    msg <- validMsg(NULL, isValidVersion(object, "NChannelSet"))
    if (!"channel" %in% names(varMetadata(object))) {
        txt <- "\n  'NChannelSet' varMetadata must have a 'channel' column"
        msg <- validMsg(msg, txt)
    } else {
        channel <-
            varMetadata(object)[["channel"]]
        if (!is(channel, "factor")) {
            txt <- paste("\n  'NChannelSet' varMetadata column 'channel'",
                         "must be class 'factor'")
            msg <- validMsg(msg, txt)
        } else if (0 < length(levels(channel))) {
            if (length(.invalid_NChannelAssayNames(object))) {
                txt <- 'NChannelSet levels(varMetadata(object)$channel) /
                        assayDataElementNames() mismatch; see
                        ?"channelNames<-,NChannelSet,character-method"'
                txt <- paste(strwrap(c("\n", txt), exdent=2), collapse="\n  ")
                msg <- validMsg(msg, txt)
            }
        }
        if (!("_ALL_" %in% levels(channel))) {
            txt <- paste("\n  'NChannelSet' varMetadata 'channel'",
                         "requires '_ALL_' as a level")
            msg <- validMsg(msg, txt)
        }
    }
    if (is.null(msg)) TRUE else msg
})

.assayDataGets_NChannelSet <-
    function(object, value)
{
    phenoData <- phenoData(object)
    ## update channel names, making some attempt to preserve order
    from <- channelNames(object)
    to <- assayDataElementNames(value)
    lvls <- c(from[from %in% to], to[!to %in% from], "_ALL_")
    varMetadata(phenoData)$channel <- 
        factor(as.character(varMetadata(phenoData)$channel), levels=lvls)

    .init_NChannelSet(object, assayData=value, phenoData=phenoData)
}

setReplaceMethod("assayData", c("NChannelSet", "environment"),
    .assayDataGets_NChannelSet)

setReplaceMethod("assayData", c("NChannelSet", "list"),
    .assayDataGets_NChannelSet)

setMethod("channelNames", "NChannelSet", function(object, ...) {
    nms <- assayDataElementNames(object)
    lvls <- levels(varMetadata(object)$channel)
    if (all(nms %in% lvls))
        ## FIXME: this accomodates invalid (previous) NChannelSet instances
        ## order to match channelNames
        nms <- lvls[lvls %in% nms]
    nms
})

setGeneric("channelNames<-",
    function(object, ..., value) standardGeneric("channelNames<-"))

setReplaceMethod("channelNames", c("NChannelSet", "character"),
    function(object, ..., value)
{
    if (!is.null(names(value))) {
        ## re-name & re-order
        channelNames(object) <- as.list(value)
    } else {
        ## re-order
        if (!all(sort(value) == sort(channelNames(object))))
            stop("'value' elements must include all channelNames()")
        varMetadata(object)$channel <-
            factor(varMetadata(object)$channel, levels=c(value, "_ALL_"))
        validObject(object)
    }
    object
})

setReplaceMethod("channelNames", c("NChannelSet", "list"),
    function(object, ..., value)
{
    from <- unlist(value, use.names=FALSE)
    if (!all(sort(from) == sort(channelNames(object))))
       stop("'value' elements must include all channelNames()")
    to <- names(value)
    if (any(duplicated(to)))
        stop("duplicated channelNames are not allowed")

    assayData <- assayData(object)
    levels(varMetadata(object)$channel) <- c(value, list("_ALL_" = "_ALL"))
    if (is.list(assayData)) {
        idx <- match(from, names(assayData))
        names(assayData)[idx] <- to
    } else {
        env <- new.env(parent=emptyenv())
        for (i in seq_along(value))
            env[[ to[i] ]] = assayData[[ from[i] ]]
        if (storageMode(object) == "lockedEnvironment")
            assayDataEnvLock(env)
        assayData <- env
    }
    assayData(object) <- assayData
    object
})

setMethod("channel",
          signature = signature(
            object = "NChannelSet",
            name = "character"),
          function(object, name, ...) {
              if (length(name) != 1)
                  stop("\n  'NChannelSet' channel 'name' must be one element",
                       "\n    was: '", paste0(name, collapse="', '"), "'")
              obj <- selectChannels(object, name) # subset phenoData appropriately
              sampleNames(phenoData(obj)) <- sampleNames(assayData(obj))
              ExpressionSet(assayData(obj)[[name]],
                  phenoData = phenoData(obj),
                  featureData = featureData(obj),
                  experimentData = experimentData(obj),
                  annotation=annotation(obj),
                  protocolData=protocolData(obj),
                  ...)
          })

setMethod("selectChannels",
          signature = signature(
            object = "NChannelSet",
            names="character"),
          function(object, names, ...) {
              if (any(duplicated(names)))
                stop("NChannelSet' channels 'names' must be unique")
              channelNames <- channelNames(object)
              badNames <- !names %in% channelNames
              if (any(badNames))
                stop("NChannelSet' channels 'names' must be channels")
              dropChannels <- channelNames[!channelNames %in% names]
              if (0 == length(dropChannels))
                return(object)
              ## assayData
              assayData <-
                assayDataSubsetElements(assayData(object), names)
              ## phenoData -- drop unneeded info
              metadata <- varMetadata(object)[["channel"]]
              okMetadata <- !metadata %in% dropChannels
              phenoData <- phenoData(object)[,okMetadata]
              ## reduce factor levels
              varMetadata(phenoData)[["channel"]] <-
                factor(metadata[okMetadata], levels=unique(c(names, "_ALL_")))
              initialize(object,
                         assayData = assayData,
                         phenoData = phenoData,
                         featureData = featureData(object),
                         experimentData=experimentData(object),
                         annotation=annotation(object),
                         protocolData=protocolData(object),
                         ...)
          })

setMethod("sampleNames",
          signature=signature(object="NChannelSet"),
          function(object) {
              assayData <- assayData(object)
              nms <- if (storageMode(object) == "list")
                  names(assayData)
              else
                  ls(assayData)
              res <- vector("list", length(nms))
              names(res) <- nms
              for (nm in nms)
                  res[[nm]] <- colnames(assayData[[nm]])
              ident <- sapply(res[-1], function(elt, ref) all(elt==ref),
                              res[[1]])
              if (all(ident)) res[[1]]
              else res
          })

setReplaceMethod("sampleNames", c("NChannelSet", "list"),
    function(object, value)
{
    assayData <- assayData(object)
    sampleNames(assayData) <- value
    phenoData <- phenoData(object)
    sampleNames(phenoData) <- sampleNames(assayData)
    protocolData <- protocolData(object)
    sampleNames(protocolData) <- sampleNames(assayData)

    .init_NChannelSet(object, assayData=assayData,
                      phenoData=phenoData, protocolData=protocolData)
})

# ==========================================================================
# Functions to deal with strings:
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# strbreak
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
strbreak <- function(x, width=getOption("width"), exdent=2, collapse="\n") {
   width <- as.integer(width)
   if(is.na(width) || width<=1)
      stop("invalid argument 'width'")
   exdent <- as.integer(exdent)
   if(is.na(exdent) || exdent>width)
      stop("invalid argument 'exdent'")
   ww <- width-exdent
   lb <- paste0(collapse, paste(rep(" ", exdent), collapse=""))
   rv <- character(length(x))
   for(i in seq(along.with=x)) {
      first <- 1
      last  <- width
      if(nchar(x[i])>width) {
         f  <- seq(width+1, nchar(x[i]), ww)
         first <- c(first, f)
         last  <- c(last, f+ww-1)
      }
      rv[i] <-  paste(substring(x[i], first=first, last=last), collapse=lb)
   }
   return(rv)
}
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

lcSuffix <- function(x, ignore.case = FALSE) {
    x <- as.character(x)
    if( ignore.case )   
       x <- toupper(x)

    nc <- nchar(x, type="char")
    for(i in 1:min(nc)) {
        ## The +1 and +2 are because substr is funny
       ss = substr(x, nc - i + 1, nc)
       if( any(ss != ss[1] )) {
           if (i == 1L)                 # trailing char mismatch
             return("")
           return(substr(x[1], nc - i + 2, nc))
       }
    }
    return(substr(x[1], nc - i + 1, nc))
 }


lcPrefix <- function(x, ignore.case=FALSE) {
    x <- as.character(x)
    if (ignore.case)
      x <- toupper(x)
    nc <- nchar(x, type="char")
    for (i in 1:min(nc)) {
        ss <- substr(x, 1, i)
        if (any(ss != ss[1])) {
            return(substr(x[1], 1, i-1))
        }
    }
    substr(x[1], 1, i)
}


lcPrefixC <- function(x, ignore.case=FALSE) {
    .Call("lc_prefix", x, ignore.case)
}

## Functions to detect and open vignettes:
## uses tools.R

getPkgVigs = function(package=NULL) {
  pkgs <- .packages()
  if( !is.null(package) ) {
    if( !is.character(package) )
      stop("`package' must be a character vector of package names")
    rows <- match(package, pkgs)
    if( all(is.na(rows)) )
        stop("packages '", paste(package, collapse="', '"),
             "' are not loaded")
    if( any(is.na(rows)) )
        warning("packages '",
                paste(package[is.na(rows)], collapse="', '"),
                "' are not loaded")
    pkgs <- pkgs[rows[!is.na(rows)]]
  }
  vigrds = file.path(find.package(pkgs), "Meta", "vignette.rds")
  
  ## construct data frame with: package, path, title
  pkgVigs = vector(mode="list", length=length(vigrds))
  for(j in seq(along.with=vigrds)) {
    if (file.exists(vigrds[j])) {
      v = readRDS(vigrds[j])
      f = v[, "PDF"]
      f = ifelse(f=="",
        as.character(NA),
        file.path(dirname(dirname(vigrds[j])), "doc", f))
      tit = v[, "Title"]
      tit[tit==""] = as.character(NA)
      rv= data.frame(package  = pkgs[j],
                     filename = f,
                     title    = tit,
                     stringsAsFactors=FALSE)
      pkgVigs[[j]] = rv
    }
  } ## for j
  do.call(rbind, args=pkgVigs)
}

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
openVignette = function(package=NULL) {
  vig = getPkgVigs(package)
  if (is.null(vig)) {
      txt <- ""
      if (!is.null(package)) {
          ss <- if (length(package)==1) "" else "s"
          pkgs <- paste(package, collapse=", ")
          txt <- sprintf(" for package%s %s", ss, pkgs)
      }
      warning("no vignettes found", txt)
  } else {
    hasnofile = is.na(vig$filename)
    vig$title[hasnofile] = paste(vig$title[hasnofile], "[-]")
    vig = vig[order(hasnofile, tolower(vig$package), tolower(vig$title)), ]
    index = menu(paste(vig$package, "-", vig$tit),
      title = paste("Please select a vignette:",
        if(any(hasnofile))
          "(entries marked by '[-]' have no PDF file)"
        else
          ""
        ))

    if (index>0) {
      vif = vig$filename[index]
      if(!is.na(vif)) {
        openPDF(vif)
        cat("Opening", vif, "\n")
        ## browseURL(paste0("file://", vig[index]))
      } else {
        stop("Sorry, no PDF file could be found for this vignette.\n",
             "Please reinstall the package with built vignettes.")
      }
    }
  }
}

#-----------------------------------------------------------
# add package vignettes to the menu bar of the Windows Rgui
##----------------------------------------------------------
addVigs2WinMenu = function(pkgName) {
  if ((.Platform$OS.type == "windows") &&
      (.Platform$GUI == "Rgui") &&
      interactive()) {
      
    vigFile = system.file("Meta", "vignette.rds", package=pkgName)
    if (!file.exists(vigFile)) {
      warning(sprintf("%s contains no vignette, nothing is added to the menu bar", pkgName))
    } else {
      vigMtrx = readRDS(vigFile)
      vigs = file.path(find.package(pkgName), "doc", vigMtrx[, "PDF"])
      names(vigs) = vigMtrx[,"Title"]

      if (!"Vignettes" %in% winMenuNames())
        winMenuAdd("Vignettes")
      
      pkgMenu = paste("Vignettes", pkgName, sep="/")
      winMenuAdd(pkgMenu)

      for (i in seq(along.with=vigs))
        winMenuAddItem(pkgMenu, names(vigs)[i],
                       paste0("shell.exec(\"", vigs[i], "\")"))

    } ## else
    ans = TRUE

  } else {
    ans = FALSE
  } ## else
  ans
}

setMethod("initialize", "ExpressionSet",
    function(.Object, assayData, phenoData, featureData,
             exprs=new("matrix"), ... )
{
    if (missing(assayData)) {
        if (missing(phenoData))
            phenoData <- annotatedDataFrameFrom(exprs, byrow=FALSE)
        if (missing(featureData))
            featureData <- annotatedDataFrameFrom(exprs, byrow=TRUE)
        .Object <- callNextMethod(.Object,
                                  phenoData = phenoData,
                                  featureData = featureData,
                                  exprs = exprs,
                                  ...)
    } else if (missing(exprs)) {
        if (missing(phenoData))
            phenoData <- annotatedDataFrameFrom(assayData, byrow=FALSE)
        if (missing(featureData))
            featureData <- annotatedDataFrameFrom(assayData, byrow=TRUE)
        .Object <- callNextMethod(.Object,
                                  assayData = assayData,
                                  phenoData = phenoData,
                                  featureData = featureData,
                                  ...)
    } else stop("provide at most one of 'assayData' or 'exprs' to initialize ExpressionSet",
                call.=FALSE)
    .harmonizeDimnames(.Object)
})

.harmonizeDimnames <- function(object) {
    err <- function(conflicts)
        stop("assayData element dimnames conflict: ",
             paste(names(conflicts), collapse=", "))
    okNames <- list(featureNames(featureData(object)),
                    sampleNames(phenoData(object)))
    dimNames <- .assayDataDimnames(assayData(object))
    dimConflict <- function(dimNames, okNames, dim) {
        nm <- lapply(dimNames, "[[", dim)
        isConflict <- !sapply(nm, function(x, y) {
            is.null(x) || isTRUE(all.equal(x, y, check.attr=FALSE))
        }, okNames[[dim]])
        isNamed <- sapply(lapply(nm, names), length) > 0
        isNull <- sapply(nm, is.null)
        if (all(!isConflict & !isNamed & !isNull))
            return (FALSE)
        if (any(isConflict & !isNull))
            err(isConflict[!isNull])
        TRUE
    }
    if (dimConflict(dimNames, okNames, 1))
        featureNames(assayData(object)) <- okNames[[1]]
    if (dimConflict(dimNames, okNames, 2))
        sampleNames(assayData(object)) <- okNames[[2]]
    object
}

setAs("exprSet", "ExpressionSet", function(from) {
  from <- asS4(from)
  desc <- from@description
  desc <- 
    if (class(desc)!="MIAME") {
        txt <- "missing or mis-formed MIAME 'description' in original object;
                creating new, empty description"
        warning(paste0(strwrap(txt, indent=2), collapse="\n  "))
        MIAME()
    } else updateObject(desc)
  exprs <- from@exprs
  phenoData <- as(from@phenoData, "AnnotatedDataFrame")
  annotation <- from@annotation
  dims <- dim(exprs)
  if (all(dim(from@se.exprs) == dims)) {
    se.exprs <- from@se.exprs
    colnames(se.exprs) <- colnames(exprs)
    .ExpressionSet(phenoData=phenoData, experimentData=desc,
        annotation=annotation, exprs=exprs, se.exprs=se.exprs)
  } else {
    txt <- "missing or mis-formed 'se.exprs' in original object;
            creating ExpressionSet without se.exprs"
    warning(paste0(strwrap(txt, indent=2), collapse="\n  "))
    .ExpressionSet(phenoData=phenoData, experimentData=desc,
                   annotation=annotation, exprs=exprs)
  }
})

setValidity("ExpressionSet", function(object) {
    msg <- validMsg(NULL, isValidVersion(object, "ExpressionSet"))
    msg <- validMsg(msg, assayDataValidMembers(assayData(object), c("exprs")))
    if(class(experimentData(object)) != "MIAME")
        msg <- validMsg(msg, 
               "experimentData slot in ExpressionSet must be 'MIAME' object")
    if (is.null(msg)) TRUE else msg
})

setAs("ExpressionSet", "data.frame",
      function (from) data.frame(t(exprs(from)), pData(from)))

as.data.frame.ExpressionSet <- function(x, row.names=NULL, optional=FALSE, ...)
  as(x, "data.frame")

setMethod("exprs", signature(object="ExpressionSet"),
          function(object) assayDataElement(object,"exprs"))

setReplaceMethod("exprs", signature(object="ExpressionSet",value="matrix"),
                 function(object, value) assayDataElementReplace(object, "exprs", value))


.esApply <- function(X, MARGIN, FUN, ...) {
    parent <- environment(FUN)
    if (is.null(parent))
        parent <- emptyenv()
    e1 <- new.env(parent=parent)
    multiassign(names(pData(X)), pData(X), envir=e1)
    environment(FUN) <- e1
    apply(exprs(X), MARGIN, FUN, ...)
}

setMethod("esApply",
          signature=signature(X="ExpressionSet"),
          .esApply)

setMethod("makeDataPackage",
          signature(object="ExpressionSet"),
          function(object, author, email,
                   packageName, packageVersion, license, biocViews, filePath,
                   description=paste(abstract(object), collapse="\n\n"), ...) {
              if( missing(email) || !(is.character(email) && (length(email) == 1)
                                      && grep("@", email) == 1 ) )
                stop("invalid email address")

              sym = list(
                AUTHOR = author,
                VERSION=as.character(package_version(packageVersion)),
                LICENSE=license,
                TITLE = paste("Experimental Data Package:",packageName),
                MAINTAINER = paste0(author, ", <", email, ">"),
                BVIEWS = biocViews,
                DESCRIPTION = description,
                FORMAT = pD2Rd(phenoData(object)))

              res = createPackage(packageName, destinationDir=filePath,
                originDir = system.file("ExpressionSet", package="Biobase"),
                symbolValues = sym, unlink=TRUE)

              ##save the data file
              datadir = file.path(res$pkgdir, "data")
              dir.create(datadir, showWarnings=FALSE)
              outfile = file.path(datadir, paste0(packageName, ".rda"))
              assign(packageName, object)
              save(list=packageName, file = outfile)

              return(res)
          })

setMethod("write.exprs",
          signature(x="ExpressionSet"),
          function(x, file="tmp.txt", quote=FALSE,
                   sep="\t", col.names=NA, ...){
            write.table(exprs(x), file=file, quote=quote, sep=sep,
                        col.names=col.names, ...)
          })

readExpressionSet <- function(exprsFile,
                              phenoDataFile,
                              experimentDataFile,
                              notesFile,
                              path,
                              annotation,
                              ## arguments to read.* methods 
                              exprsArgs=list(sep=sep, header=header, row.names=row.names, quote=quote, ...),
                              phenoDataArgs=list(sep=sep, header=header, row.names=row.names, quote=quote, stringsAsFactors=stringsAsFactors, ...),
                              experimentDataArgs=list(sep=sep, header=header, row.names=row.names, quote=quote, stringsAsFactors=stringsAsFactors, ...),
                              sep = "\t", header = TRUE, quote = "", stringsAsFactors = FALSE, row.names = 1L,
                              ## widget
                              widget = getOption("BioC")$Base$use.widgets,
                              ...) {
    if (!missing(widget) && widget != FALSE)
        stop("sorry, widgets not yet available")

    ## exprs
    if (missing(exprsFile))
        stop("exprs can not be missing!")
    exprsArgs$file=exprsFile
    ex = as.matrix(do.call(read.table, exprsArgs))

    ## phenoData
    if (!missing(phenoDataFile)) {
        phenoDataArgs$file=phenoDataFile
        pd = do.call(read.AnnotatedDataFrame, phenoDataArgs)
        if (!identical(sampleNames(pd), colnames(ex)))
            stop("Column names of expression matrix must be identical to\n",
                 "the sample names of the phenodata table.\n",
                 "You could use 'options(error=recover)' to compare the",
                 "values of 'sampleNames(pd)' and 'colnames(ex)'.\n")
    } else {
        pd = annotatedDataFrameFrom(ex, byrow=FALSE)
    }

    obj = ExpressionSet(ex, phenoData=pd)


    ## FIXME: these should probably added to obj before, or simultaneously to, exprs;
    ##   as is this can provoke a lot of copying
    ## experimentData
    if (!missing(experimentDataFile))
        experimentDataArgs$file=experimentDataFile
    if (!is.null(experimentDataArgs$file))
        experimentData(obj) <- do.call(read.MIAME, experimentDataArgs)
    ## annotation
    if (!missing(annotation))
        annotation(obj) <- annotation
    ## notes
    if (!missing(notesFile))
        notes(obj) <- readLines(notesFile)

    validObject(obj)
    obj
}

setMethod(ExpressionSet, "missing",
    function(assayData,
             phenoData=AnnotatedDataFrame(),
             featureData=AnnotatedDataFrame(),
             experimentData=MIAME(), annotation=character(),
             protocolData=AnnotatedDataFrame(),
             ...)
{
    .ExpressionSet(
        assayData=assayDataNew(exprs=new("matrix")),
        phenoData=phenoData,
        featureData=featureData, experimentData=experimentData,
        annotation=annotation, protocolData=protocolData, ...)
})

setMethod(ExpressionSet, "environment",
    function(assayData,
             phenoData=annotatedDataFrameFrom(assayData, byrow=FALSE),
             featureData=annotatedDataFrameFrom(assayData, byrow=TRUE),
             experimentData=MIAME(), annotation=character(),
             protocolData=annotatedDataFrameFrom(assayData, byrow=FALSE),
             ...)
{
    .ExpressionSet(assayData=assayData, phenoData=phenoData,
        featureData=featureData, experimentData=experimentData,
        annotation=annotation, protocolData=protocolData, ...)
})


setMethod(ExpressionSet, "matrix",
    function(assayData,
             phenoData=annotatedDataFrameFrom(assayData, byrow=FALSE),
             featureData=annotatedDataFrameFrom(assayData, byrow=TRUE),
             experimentData=MIAME(), annotation=character(),
             protocolData=annotatedDataFrameFrom(assayData, byrow=FALSE),
             ...)
{
    assayData <- assayDataNew(exprs=assayData)
    .ExpressionSet(assayData=assayData, phenoData=phenoData,
        featureData=featureData, experimentData=experimentData,
        annotation=annotation, protocolData=protocolData, ...)
})

.DollarNames.ExpressionSet <- .DollarNames.eSet

setMethod("initialize", "SnpSet",
          function(.Object,
                   assayData = assayDataNew(call = call,
                                            callProbability = callProbability, ...),
                   phenoData = annotatedDataFrameFrom(assayData, byrow=FALSE),
                   featureData = annotatedDataFrameFrom(assayData, byrow=TRUE),
                   experimentData = MIAME(),
                   annotation = character(),
                   protocolData = phenoData[,integer(0)],
                   call = new("matrix"),
                   callProbability = matrix(numeric(),
                                            nrow=nrow(call), ncol=ncol(call),
                                            dimnames=dimnames(call)),
                   ...) {
            callNextMethod(.Object,
                           assayData = assayData,
                           phenoData = phenoData,
                           featureData = featureData,
                           experimentData = experimentData,
                           annotation = annotation,
                           protocolData = protocolData)
          })

setValidity("SnpSet", function(object) {
  assayDataValidMembers(assayData(object), c("call", "callProbability"))
})

setMethod("exprs", c("SnpSet"), function(object) assayDataElement(object, "call"))

setReplaceMethod("exprs", c("SnpSet", "matrix"), function(object, value) {
  assayDataElementReplace(object, "call", value)
})

setMethod(snpCall, "SnpSet", function(object, ...) {
    assayDataElement(object, "call")
})

setMethod(snpCallProbability, "SnpSet", function(object, ...) {
    assayDataElement(object, "callProbability")
})

setReplaceMethod("snpCall", c("SnpSet", "matrix"),
                 function(object, ..., value)
{
    assayDataElementReplace(object, "call", value)
})

setReplaceMethod("snpCallProbability", c("SnpSet", "matrix"),
                 function(object, ..., value)
{
    assayDataElementReplace(object, "callProbability", value)
})

# ==========================================================================
# aggregator: a simple aggregator (R. Gentleman, 2001)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Data are aggregated in the environment env if they are not there then the
# get assigned with initfun, if they are there they get aggregated with agfun
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
.aggregator <- setClass("aggregator",
   representation(
      aggenv  = "environment",
      initfun = "function",
      aggfun  = "function"
   ),
   prototype = list(
      initfun = function(name, val) 1,
      aggfun  = function(name, current, val) current + 1
   )
)
# ==========================================================================
# container: lists containing objects of specified class (R. Gentleman, 2001)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
.container <- setClass("container",
   representation(
      x       = "list",
      content = "character",
      locked  = "logical"
   ),
   prototype = list(
      x       = vector("list", 0),
      content = "object",
      locked  = FALSE
   )
)
# ==========================================================================
# phenoData (DEFUNCT)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
setClass("phenoData",
   representation(
      pData       = "data.frame",
      varLabels   = "list",
      varMetadata = "data.frame"
   ),
   contains="Versioned",
   validity = function(object) {
       paste("class phenoData is defunct,",
             "convert using as(<<object>>, \"AnnotatedDataFrame\")")
   }
)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
setOldClass("data.frame")
setClassUnion("data.frameOrNULL", c("data.frame", "NULL"))


# ==========================================================================
# MIAxE: a VIRTUAL class for experiment meta-data 
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
.MIAxe <- setClass("MIAxE",
    representation("VIRTUAL"),
    contains="Versioned",
    prototype = prototype(.Versioned(versions=c(MIAxE="1.0.0")))
    )
 

# MIAME: a class for microarray data - MIAME information (Rafael A. Irizarry)
# More info: http://www.mged.org/Workgroups/MIAME/miame_1.1.html
.MIAME <- setClass("MIAME",
   representation(
      name           = "character",
      lab            = "character",
      contact        = "character",
      title          = "character",
      abstract       = "character",
      url            = "character",
      pubMedIds      = "character",
      samples        = "list",
      hybridizations = "list",
      normControls   = "list",
      preprocessing  = "list",
      other          = "list"
   ),
   contains=c("MIAxE"),
   prototype = prototype(
      .Versioned(versions=c(classVersion("MIAxE"), MIAME="1.1.0")),
      name           = "",
      lab            = "",
      contact        = "",
      title          = "",
      abstract       = "",
      url            = "",
      pubMedIds      = "",
      samples        = list(),
      hybridizations = list(),
      normControls   = list(),
      preprocessing  = list(),
      other          = list()
   )
)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# trick so that Plobs works
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
setClassUnion("characterORMIAME", c("MIAME", "character"))
# ==========================================================================
# annotatedDataset (DEFUNCT)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
setClass("annotatedDataset",
   representation(
      reporterInfo = "data.frameOrNULL",
      phenoData    = "phenoData",
      "VIRTUAL"
   ),
   contains=c("VersionedBiobase"))
# ==========================================================================
# AnnotatedDataFrame: A data.frame, with annotations about columns named
# in the data slot contained in the metadata slot. The data slot has
# columns identifying different entities (e.g., genes, samples) and
# the columns contain attributes of those entities (e.g., control or
# spike-in information for genes, age or sex for samples). The number
# of columns in the data slot equals the number of rows in the
# metadata slot.
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
.AnnotatedDataFrame <- setClass("AnnotatedDataFrame",
         representation(varMetadata = "data.frame",
                        data = "data.frame",
                        dimLabels = "character"),
         contains=c("Versioned"),
         prototype = prototype(
           .Versioned(versions=list(AnnotatedDataFrame="1.1.0")),
           varMetadata = new( "data.frame" ),
           data = new( "data.frame" ),
           dimLabels=c("rowNames", "columnNames")))
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
setClassUnion("AssayData", c("list", "environment"))
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# eSet: A VIRTUAL class containing assay data (typically, one or many
# different sets of results obtained from one or many samples in a
# single experiment), phenotypic data (describing the samples involved
# in the experiment), experimental data (describing the methods and
# protocols used), and an annotation (linking to separately maintained
# chip annotation information).
#
# When assayData contains several sets of results, each set must have
# the same dimension (e.g., columns representing genes, rows
# representing samples, all assayData members providing information
# for the same number of genes and samples).
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
.eSet <- setClass("eSet",
         representation(assayData = "AssayData",
                        phenoData = "AnnotatedDataFrame",
                        featureData = "AnnotatedDataFrame",
                        experimentData = "MIAxE",
                        annotation = "character",
                        protocolData="AnnotatedDataFrame",
                        "VIRTUAL"),
         contains="VersionedBiobase",
         prototype = prototype(
           .VersionedBiobase(versions=c(eSet="1.3.0")),
               assayData = list(), # use initialize to set as env, so
                                   # different instances have
                                   # different envs
               phenoData = .AnnotatedDataFrame(
                 dimLabels=c("sampleNames", "sampleColumns")),
               featureData = .AnnotatedDataFrame(
                 dimLabels=c("featureNames", "featureColumns")),
               annotation = character(),
               protocolData = .AnnotatedDataFrame(
                 dimLabels=c("sampleNames", "sampleColumns"))))
.ExpressionSet <- setClass("ExpressionSet",
         representation(experimentData="MIAME"),
         contains = "eSet",
         prototype = prototype(
           .VersionedBiobase(
               versions=c(classVersion("eSet"), ExpressionSet="1.0.0")),
               experimentData=.MIAME()))
.NChannelSet <- setClass("NChannelSet",
         contains = "eSet",
         prototype = prototype(
           .VersionedBiobase(
               versions=c(classVersion("eSet"), NChannelSet="1.0.0")),
           phenoData = .AnnotatedDataFrame(
             data=data.frame(),
             varMetadata=data.frame(
               labelDescription=character(0),
               channelDescription=factor()))))
.MultiSet <- setClass("MultiSet",      # any element in assayData slot
         contains = "eSet",
         prototype = prototype(
           .VersionedBiobase(
               versions=c(classVersion("eSet"), MultiSet="1.0.0"))))
.SnpSet <- setClass("SnpSet",                      # call, callProbability
         contains = "eSet",
         prototype = prototype(
           .VersionedBiobase(
               versions=c(classVersion("eSet"), SnpSet="1.0.0"))))
# ==========================================================================
# exprSet (DEFUNCT)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
setClass("exprSet",
   representation(
      exprs       = "matrix",
      se.exprs    = "matrix",
      description = "characterORMIAME",
      annotation  = "character",
      notes       = "character"
   ),
   contains = c("annotatedDataset"), # contains VersionedBiobase implicitly
   validity = function(object)
         paste("class exprSet is defunct,",
               "convert using as(<<object>>, \"ExpressionSet\")")
)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

.ScalarObject <- setClass("ScalarObject", contains="VIRTUAL",
         validity=function(object) {
             if (length(object) != 1L)
               paste(class(object), "must have length one")
             else
               TRUE
         })

.ScalarLogical <- setClass("ScalarLogical",
    contains=c("ScalarObject", "logical"),
    prototype=NA)

.ScalarCharacter <- setClass("ScalarCharacter",
    contains=c("ScalarObject", "character"),
    prototype="")

.ScalarInteger <- setClass("ScalarInteger",
    contains=c("ScalarObject", "integer"),
    prototype=NA_integer_)

.ScalarNumeric <- setClass("ScalarNumeric",
    contains=c("ScalarObject", "numeric"),
    prototype=NA_real_)

setMethod("updateObjectTo", signature(object="ANY", template="ANY"),
          function(object, template, ..., verbose=FALSE) {
              if (verbose)
                  message("updateObject(object = 'ANY', template = 'ANY') default for object = '",
                          class(object), "' template = ", class(template), "'")
              if (class(object)==class(template))
                  object
              else {
                  tryCatch(as(object, class(template)),
                           error=function(err) {
                               stop("\nupdateObjectTo:\n    ",
                                    "cannot convert object of class '", class(object), "' ",
                                    "to template class '", class(template), "'")})
              }
          })

setGeneric("abstract",        function(object) standardGeneric("abstract"))
setGeneric("aggenv",          function(object) standardGeneric("aggenv"))
setGeneric("aggfun",          function(object) standardGeneric("aggfun"))
setGeneric("annotatedDataFrameFrom", function(object, byrow, ...) standardGeneric("annotatedDataFrameFrom"))
setGeneric("assayData",       function(object)standardGeneric("assayData"))
setGeneric("assayData<-",     function(object, value) standardGeneric("assayData<-"))
setGeneric("channelNames",    function(object, ...) standardGeneric("channelNames"))
setGeneric("channel",         function(object, name, ...) standardGeneric("channel"))
setGeneric("content",         function(object) standardGeneric("content"))
setGeneric("description",     function(object, ...)
           standardGeneric("description"))
setGeneric("description<-",   function(object, value) standardGeneric("description<-"))
setGeneric("dimnames")
setGeneric("dimnames<-")
setGeneric("dimLabels",       function(object) standardGeneric("dimLabels"))
setGeneric("dimLabels<-",     function(object, value) standardGeneric("dimLabels<-"))
setGeneric("esApply",          function(X, MARGIN, FUN, ...) standardGeneric("esApply"),
           signature=c("X"))
setGeneric("experimentData",  function(object) standardGeneric("experimentData"))
setGeneric("experimentData<-",function(object, value) standardGeneric("experimentData<-"))
setGeneric("expinfo",         function(object) standardGeneric("expinfo"))
setGeneric("exprs",           function(object) standardGeneric("exprs"))
setGeneric("exprs<-",         function(object, value) standardGeneric("exprs<-"))
setGeneric("featureNames",    function(object) standardGeneric("featureNames"))
setGeneric("featureNames<-",  function(object, value) standardGeneric("featureNames<-"))
setGeneric("featureData",     function(object) standardGeneric("featureData"))
setGeneric("featureData<-",   function(object, value) standardGeneric("featureData<-"))
setGeneric("fData",           function(object) standardGeneric("fData"))
setGeneric("fData<-",         function(object, value) standardGeneric("fData<-"))
setGeneric("fvarLabels",      function(object) standardGeneric("fvarLabels"))
setGeneric("fvarLabels<-",    function(object, value) standardGeneric("fvarLabels<-"))
setGeneric("fvarMetadata",    function(object) standardGeneric("fvarMetadata"))
setGeneric("fvarMetadata<-",  function(object, value) standardGeneric("fvarMetadata<-"))
setGeneric("hybridizations",  function(object) standardGeneric("hybridizations"))
setGeneric("initfun",         function(object) standardGeneric("initfun"))
setGeneric("locked",          function(object) standardGeneric("locked"))
setGeneric("makeDataPackage", function(object, author, email,
                                       packageName=deparse(substitute(object)),
                                       packageVersion=package_version("1.0.0"),
                                       license="Artistic-2.0",
                                       biocViews="ExperimentData",
                                       filePath=tempdir(), ...) standardGeneric("makeDataPackage"),
           signature="object")
setGeneric("normControls",    function(object) standardGeneric("normControls"))
setGeneric("notes",           function(object) standardGeneric("notes"))
setGeneric("notes<-",         function(object, value) standardGeneric("notes<-"))
setGeneric("otherInfo",       function(object) standardGeneric("otherInfo"))
setGeneric("pData",           function(object) standardGeneric("pData"))
setGeneric("pData<-",         function(object, value) standardGeneric("pData<-"))
setGeneric("phenoData",       function(object) standardGeneric("phenoData"))
setGeneric("phenoData<-",     function(object, value) standardGeneric("phenoData<-"))
setGeneric("preproc",         function(object) standardGeneric("preproc"))
setGeneric("preproc<-",       function(object, value) standardGeneric("preproc<-"))
setGeneric("protocolData",    function(object) standardGeneric("protocolData"))
setGeneric("protocolData<-",  function(object, value) standardGeneric("protocolData<-"))
setGeneric("pubMedIds",       function(object) standardGeneric("pubMedIds"))
setGeneric("pubMedIds<-",     function(object, value) standardGeneric("pubMedIds<-"))
setGeneric("sampleNames",     function(object) standardGeneric("sampleNames"))
setGeneric("sampleNames<-",   function(object, value) standardGeneric("sampleNames<-"))
setGeneric("samples",         function(object) standardGeneric("samples"))
setGeneric("se.exprs",        function(object) standardGeneric("se.exprs"))
setGeneric("se.exprs<-",      function(object, value) standardGeneric("se.exprs<-"))
setGeneric("selectChannels",  function(object, names, ...) standardGeneric("selectChannels"))
setGeneric("selectSomeIndex", function(object, ...) standardGeneric("selectSomeIndex"))
setGeneric("snpCall",        function(object, ...) standardGeneric("snpCall"))
setGeneric("snpCall<-",      function(object, ..., value) standardGeneric("snpCall<-"))
setGeneric("snpCallProbability",   function(object, ...) standardGeneric("snpCallProbability"))
setGeneric("snpCallProbability<-", function(object, ..., value) standardGeneric("snpCallProbability<-"))
setGeneric("storageMode",     function(object) standardGeneric("storageMode"))
setGeneric("storageMode<-",   function(object, value) standardGeneric("storageMode<-"))
setGeneric("varLabels",       function(object) standardGeneric("varLabels"))
setGeneric("varLabels<-",     function(object, value) standardGeneric("varLabels<-"))
setGeneric("varMetadata",     function(object) standardGeneric("varMetadata"))
setGeneric("varMetadata<-",   function(object, value) standardGeneric("varMetadata<-"))
setGeneric("write.exprs",     function(x,...) standardGeneric("write.exprs"))
## Version-related generics
setGeneric("classVersion",    function(object) standardGeneric("classVersion"))
setGeneric("classVersion<-",  function(object, value) standardGeneric("classVersion<-"))
setGeneric("isCurrent",       function(object, value) standardGeneric("isCurrent"))
setGeneric("isVersioned",     function(object) standardGeneric("isVersioned"))
## updateObjectTo
setGeneric("updateObjectTo",
           function(object, template, ..., verbose=FALSE) {
               result <- standardGeneric("updateObjectTo")
               if (!is(result, class(template))) # or strict equality?
                 stop("updateObjectTo returned class '", class(result), "' ",
                      "expected class '", class(template), "'")
               validObject(result)
               result
           })



## Generics for Constructors: AnnotatedDataFrame and ExpresssionSet

setGeneric("AnnotatedDataFrame", function(data, varMetadata, ...)
           standardGeneric("AnnotatedDataFrame"))


setGeneric("ExpressionSet",
           function(assayData,
                    phenoData=annotatedDataFrameFrom(assayData, byrow=FALSE),
                    featureData=annotatedDataFrameFrom(assayData, byrow=TRUE),
                    experimentData=MIAME(),
                    annotation=character(),
                    protocolData=annotatedDataFrameFrom(assayData, byrow=FALSE),
                    ...)
           standardGeneric("ExpressionSet"),
           signature="assayData")

# ==========================================================================
# Functions to operate with packages:
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# createPackage; package.version; dumpPackTxt
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# uses strings.R
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
createPackage <- function(pkgname, destinationDir, originDir, symbolValues,
                          unlink=FALSE, quiet=FALSE) {
   ## check arguments
   for (a in c("pkgname", "destinationDir", "originDir"))
      if (!is.character(get(a)) || length(get(a))!=1)
         stop("'", a, "' must be character(1)")
   ## check whether destinationDir, originDir exist and are directories
   for (a in c("destinationDir", "originDir"))
      if(!file.exists(get(a)) || !file.info(get(a))$isdir)
         stop("'", a, "' must be a directory (", get(a), ")")
   ## locate / remove / create destination directory
   pkgdir = file.path(destinationDir, pkgname)
   if (!quiet)
      cat("Creating package in", pkgdir, "\n")
   if (file.exists(pkgdir)) {
      if (unlink) {
         unlink(pkgdir, recursive=TRUE)
         if (file.exists(pkgdir)) {
            stop("directory '", pkgdir, "' exists and could not be removed; ",
                 "remove it manually or choose another destination directory")
         }
         else {
            if(!quiet)
               cat("existing", pkgdir, "was removed.\n")
         }
      }
      else
         stop("directory '", pkgdir, "' exists; use unlink=TRUE ",
              "to remove it, or choose another destination directory")
   } ## if (file.exists)
   ## predefined symbols
   symbolValues = append(symbolValues, list(TODAY=date(), PKGNAME=pkgname))
   ## copy (from strings.R)
   copySubstitute(dir(originDir, full.names=TRUE), pkgdir, symbolValues, recursive=TRUE)
   return(list(pkgdir=pkgdir))
}
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
package.version <- function(pkg, lib.loc = NULL) {
   curWarn <- getOption("warn")
   on.exit(options(warn=curWarn),add=TRUE)
   options(warn=-1)
   desc <- packageDescription(pkg, lib.loc, "Version")
   if (is.na(desc))
      stop("package '", pkg, "' does not exist")
   desc
}
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
dumpPackTxt <- function (package) {
   # stolen from "library" to get descriptive info out on stdout
   pkgpath <- find.package(package)
#   outFile <- tempfile("Rlibrary")
#   outConn <- file(outFile, open = "w")
   docFiles <- file.path(pkgpath, c("TITLE", "DESCRIPTION", "INDEX"))
   headers <- c("", "Description:\n\n", "Index:\n\n")
   footers <- c("\n", "\n", "")
   for (i in which(file.exists(docFiles))) {
      writeLines(headers[i], sep = "")
      writeLines(readLines(docFiles[i]) )
      writeLines(footers[i], sep = "")
   }
#   close(outConn)
#   file.show(outFile, delete.file = TRUE)
}
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

 ##strictly internal, not for export
 ##take an AnnotatedDataFrame object and create a valid format
 ## section for a man page
 pD2Rd <- function(pD) {
   if(!inherits(pD, "AnnotatedDataFrame") )
     stop("only works for AnnotatedDataFrames")

   fmt = "\\format{\n  The format is:\n  An \\code{ExpressionSetObject} with covariates:\n"
   covs = "\\itemize{"
   vMD = varMetadata(pD)
   vL = varLabels(pD)
   for(i in 1:length(vL) ) {
     item = paste0("\\item \\code{", vL[i], "}: ", vMD[i,1])
     covs = paste(covs, item, sep="\n")
   }
   paste0(fmt, covs, "\n}\n}\n")
 }

# ==========================================================================
# eSet Class Validator
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
setMethod("initialize", signature(.Object="eSet"),
    function(.Object, assayData,
        phenoData=annotatedDataFrameFrom(assayData, byrow=FALSE),
        featureData=annotatedDataFrameFrom(assayData, byrow=TRUE),
        experimentData=MIAME(), annotation=character(0),
        protocolData=phenoData[,integer(0)], ...)
{
    ## NB: Arguments provided in '...' are used to initialize
    ## slots if possible (when called from some subclass).
    ## Otherwise, extra args in '...' are added as elements
    ## to assayData.  We do this to allow subclasses to
    ## rely on default contructor behavior for initializing
    ## slots.
    ##
    ## NB2: Extra args to the assayData constructor will
    ## be passed along as long as current class doesn't
    ## have a slot with a matching name.
    mySlots <- slotNames(.Object)
    dotArgs <- list(...)
    isSlot <- names(dotArgs) %in% mySlots
    if (missing(assayData))
        assayData <- do.call(assayDataNew, dotArgs[!isSlot], envir=parent.frame())
    else {
        checkClass(assayData, "AssayData", class(.Object))
        nms <-
            if (storageMode(assayData)=="list") names(assayData)
            else ls(assayData)
        dupNames <- nms %in% names(dotArgs[!isSlot])
        if (any(dupNames))
            warning("initialize argument(s) '",
                    paste(nms[dupNames], collapse="' '"),
                    "' also present in 'assayData'; argument(s) ignored")
    }
    if (!missing(phenoData))
        checkClass(phenoData, "AnnotatedDataFrame", class(.Object))
    dimLabels(phenoData) <- c("sampleNames", "sampleColumns")
    if (!missing(featureData))
        checkClass(featureData, "AnnotatedDataFrame", class(.Object))
    dimLabels(featureData) <- c("featureNames", "featureColumns")
    ## create the protocolData, if necessary
    if (!missing(protocolData)) {
        checkClass(protocolData, "AnnotatedDataFrame", class(.Object))
        dimLabels(protocolData) <- c("sampleNames", "sampleColumns")
    }
    ## coordinate sample names
    adSampleNames <- sampleNames(assayData)
    if (all(sapply(adSampleNames, is.null)))
        sampleNames(assayData) <- sampleNames(phenoData)
    pdSampleNames <- sampleNames(protocolData)
    if (all(sapply(pdSampleNames, is.null)))
        sampleNames(protocolData) <- sampleNames(phenoData)
    ## where do feature names come from? assayData or featureData
    adFeatureNames <- featureNames(assayData)
    if (all(sapply(adFeatureNames, is.null)))
        featureNames(assayData) <- featureNames(featureData)
    ## create new instance from 'extra' dotArgs, and from instance
    for (s in names(dotArgs)[isSlot])
        slot(.Object, s) <- dotArgs[[s]]
    callNextMethod(.Object, assayData=assayData, phenoData=phenoData,
                   featureData=featureData, experimentData=experimentData,
                   annotation=annotation, protocolData=protocolData)
})

updateOldESet <- function(from, toClass, ...) {  # to MultiExpressionSet
  from <- asS4(from)
  ophenoData <- asS4(phenoData(from))
  metadata <- ophenoData@varMetadata
  if (all(dim(metadata)==0)) {
    warning("replacing apparently empty varMetadata")
    metadata <- data.frame(numeric(ncol(ophenoData@pData)))[,FALSE]
  }
  if (!is.null(metadata[["varName"]])) {
    row.names(metadata) <- metadata[["varName"]]
    metadata[["varName"]] <- NULL
  } else if (!is.null(names(ophenoData@pData))) {
    row.names(metadata) <- names(ophenoData@pData)
  }
  if (!is.null(metadata[["varLabels"]])) {
    names(metadata)[names(metadata)=="varLabels"] <- "labelDescription"
    metadata[["labelDescription"]] <- as.character(metadata[["labelDescription"]])
  }
  ## phenoData
  pData <- ophenoData@pData
  phenoData <- AnnotatedDataFrame(data=pData, varMetadata=metadata)
  ## sampleNames
  if (any(sampleNames(assayData(from))!=sampleNames(phenoData))) {
    warning("creating assayData colnames from phenoData sampleNames")
    sampleNames(assayData(from)) <- sampleNames(phenoData)
  }
  ## reporterNames
  if (length(from@reporterNames) == dim(from)[[1]]) {
      if (any(sapply(assayData(from),rownames)!=from@reporterNames))
        warning("creating assayData featureNames from reporterNames")
      featureNames(assayData(from)) <- from@reporterNames
  } else {
      warning("creating numeric assayData featureNames")
      featureNames(assayData(from)) <- 1:dim(from)[[1]]
  }
  if (sum(dups <- duplicated(featureNames(assayData(from))))>0) {
      warning("removing ", sum(dups), " duplicated featureNames")
      from@assayData <- lapply(from@assayData, function(elt) elt[!dups,])
  }
  ## description
  description <- from@description
  if (is(description,"MIAME")) {
    if (length(from@notes)!=0) {
      warning("addding 'notes' to 'description'")
      description@other <- c(description@other,from@notes)
    }
    if (length(from@history)!=0) {
      warning("adding 'history' to 'description'")
      description@other <- c(description@other,from@history)
    }
  } else {
    warning("'description' is not of class MIAME; ignored")
    description <- NULL
  }
  ## reporterInfo
  if (any(dim(from@reporterInfo)!=0))
    warning("reporterInfo data not transfered to '",toClass, "' object")
  ## new object
  object <- new(toClass,
                assayData = from@assayData,
                phenoData = phenoData,
                featureData = annotatedDataFrameFrom(from@assayData, byrow=TRUE),
                experimentData = updateObject(description),
                annotation = from@annotation)
  validObject(object)
  object
}

setAs("eSet", "ExpressionSet", function(from, to) updateOldESet(from, "ExpressionSet"))
setAs("eSet", "MultiSet", function(from, to) updateOldESet(from, "MultiSet"))

updateESetTo <- function(object, template, ..., verbose=FALSE) {
    if (verbose) message("updateESetTo(object = 'eSet' template = '", class(template), "')")
    ## cannot instantiate a 'virtual' class, so use accessor functions
    ## to update class components. Better than direct slot access?
    funcs <- c("assayData", "phenoData", "experimentData", "annotation")
    eval(parse(text=paste(funcs,"(template)<-",
                 "updateObject(", funcs, "(object), ..., verbose=verbose)")))
    result <- try(featureData(template) <- featureData(object), silent=TRUE)
    if (inherits(result, "try-error"))
      featureData(template) <- annotatedDataFrameFrom(assayData(object), byrow=TRUE)
    vers <- classVersion("eSet")
    classVersion(template)[names(vers)] <- vers # current class version, eSet & 'below' only
    template
}

setMethod("updateObject", signature(object="eSet"),
          function(object, ..., verbose=FALSE) {
              if (verbose) message("updateObject(object = 'eSet')")
              object <- asS4(object)
              if (isVersioned(object) && isCurrent(object)["eSet"])
                return(callNextMethod())
              ## storage.mode likely to be useful to update versioned classes, too
              storage.mode.final <- storageMode(object)
              storage.mode <-
                if (storage.mode.final == "lockedEnvironment") "environment"
                else storage.mode.final
              additionalSlots <- setdiff(slotNames(class(object)), slotNames("eSet"))
              names(additionalSlots) <- additionalSlots
              if (!isVersioned(object)) {
                object <- updateESetTo(object, new(class(object), storage.mode=storage.mode), ..., verbose=verbose)
                storageMode(object) <- storage.mode.final
              } else if (classVersion(object)["eSet"]=="1.0.0") {
                ## added featureData slot; need to update phenoData
                object <-
                  do.call(new,
                          c(list(class(object),
                                 assayData = updateObject(assayData(object), ..., verbose=verbose),
                                 phenoData = AnnotatedDataFrame(data=pData(object),
                                                 varMetadata=varMetadata(object)),
                                 featureData = annotatedDataFrameFrom(assayData(object), byrow=TRUE),
                                 experimentData = updateObject(experimentData(object), ..., verbose=verbose),
                                 annotation = annotation(object)),
                            lapply(additionalSlots, function(x) slot(object, x))))
              } else if (classVersion(object)["eSet"]=="1.1.0") {
                ## added scanDates slot
                object <-
                  do.call(new,
                          c(list(class(object),
                                 assayData = updateObject(assayData(object)),
                                 phenoData = updateObject(phenoData(object)),
                                 featureData = updateObject(featureData(object)),
                                 experimentData = updateObject(experimentData(object)),
                                 annotation = annotation(object)),
                            lapply(additionalSlots, function(x) slot(object, x))))
              } else if (classVersion(object)["eSet"]=="1.2.0") {
                ## added protocolData slot, removed scanDates slot
                scanDates <- object@scanDates
                protocolData <- phenoData(object)[,integer(0)]
                if (length(scanDates) > 0) {
                  protocolData[["ScanDate"]] <- scanDates
                }
                object <-
                  do.call(new,
                          c(list(class(object),
                                 assayData = updateObject(assayData(object)),
                                 phenoData = updateObject(phenoData(object)),
                                 featureData = updateObject(featureData(object)),
                                 experimentData = updateObject(experimentData(object)),
                                 annotation = annotation(object),
                                 protocolData = protocolData),
                            lapply(additionalSlots,
                                   function(x) updateObject(slot(object, x)))))
              } else {
                stop("cannot update object of class '", class(object),
                     "', claiming to be eSet version '",
                     as(classVersion(object)["eSet"], "character"), "'")
              }
              object
          })

setMethod("updateObjectTo", signature(object="eSet", template="eSet"), updateESetTo)

setValidity("eSet", function(object) {
    msg <- validMsg(NULL, isValidVersion(object, "eSet"))
    dims <- dims(object)
    if (ncol(dims) > 0) {
        ## assayData
        msg <- validMsg(msg, assayDataValidMembers(assayData(object)))
        if (any(dims[1,] != dims[1,1]))
          msg <- validMsg(msg, "row numbers differ for assayData members")
        if (any(dims[2,] != dims[2,1]))
          msg <- validMsg(msg, "sample numbers differ for assayData members")
        ## featureData
        if (dims[1,1] != dim( featureData(object))[[1]])
          msg <- validMsg(msg, "feature numbers differ between assayData and featureData")
        if (!identical(featureNames(assayData(object)), featureNames(featureData(object))))
          msg <- validMsg(msg, "featureNames differ between assayData and featureData")
        ## phenoData
        if (dims[2,1] != dim(phenoData(object))[[1]])
          msg <- validMsg(msg, "sample numbers differ between assayData and phenoData")
        if (!identical(sampleNames(assayData(object)), sampleNames(phenoData(object))))
          msg <- validMsg(msg, "sampleNames differ between assayData and phenoData")
        ## protocolData
        if (dim(phenoData(object))[[1]] != dim(protocolData(object))[[1]])
          msg <- validMsg(msg, "sample numbers differ between phenoData and protocolData")
        if (!identical(sampleNames(phenoData(object)), sampleNames(protocolData(object))))
          msg <- validMsg(msg, "sampleNames differ between phenoData and protocolData")
    }
    if (is.null(msg)) TRUE else msg
})

setMethod("preproc", "eSet", function(object) preproc(experimentData(object)))

setReplaceMethod("preproc",
                 signature=signature(object="eSet"),
                 function(object, value) {
                     ed <- experimentData(object)
                     preproc(ed) <- value
                     object@experimentData <- ed
                     object
                 })

setMethod("show",
          signature=signature(object="eSet"),
          function(object) {
              cat(class(object), " (storageMode: ",
                  storageMode(object), ")\n", sep="")
              adim <- dim(object)
              if (length(adim)>1)
                  cat("assayData:",
                      if (length(adim)>1)
                      paste(adim[[1]], "features,",
                            adim[[2]], "samples") else NULL,
                      "\n")
              cat("  element names:",
                  paste(assayDataElementNames(object), collapse=", "), "\n")
              .showAnnotatedDataFrame(protocolData(object),
                                      labels=list(object="protocolData"))
              .showAnnotatedDataFrame(phenoData(object),
                                      labels=list(object="phenoData"))
              .showAnnotatedDataFrame(featureData(object),
                                      labels=list(
                                        object="featureData",
                                        sampleNames="featureNames",
                                        varLabels="fvarLabels",
                                        varMetadata="fvarMetadata"))
              cat("experimentData: use 'experimentData(object)'\n")
              pmids <- pubMedIds(object)
              if (length(pmids) > 0 && all(pmids != ""))
                  cat("  pubMedIds:", paste(pmids, sep=", "), "\n")
              cat("Annotation:", annotation(object), "\n")
          })

setMethod("storageMode", "eSet", function(object) storageMode(assayData(object)))

setReplaceMethod("storageMode",
                 signature=signature(
                   object="eSet", value="character"),
                 function(object, value) {
                     ad <- assayData(object)
                     storageMode(ad) <- value
                     object@assayData <- ad
                     object
                 })

setMethod("sampleNames",
          signature(object="eSet"),
          function(object) sampleNames(phenoData(object)))

setReplaceMethod("sampleNames",
                 signature=signature(object="eSet", value="ANY"),
                 function(object, value) {
                     pd <- phenoData(object)
                     sampleNames(pd) <- value
                     ad <- assayData(object)
                     sampleNames(ad) <- value
                     prd <- protocolData(object)
                     if (nrow(prd) == 0) {
                         prd <- pd[,integer(0)]
                     } else {
                         sampleNames(prd) <- value
                     }
                     object@phenoData <- pd
                     object@protocolData <- prd
                     unsafeSetSlot(object, "assayData", ad)
                 })

setMethod("featureNames",
          signature=signature(object="eSet"),
          function(object) featureNames(assayData(object)))

setReplaceMethod("featureNames",
                 signature=signature(object="eSet", value="ANY"),
                 function(object, value) {
                     fd <- featureData(object)
                     featureNames(fd) <- value
                     ad <- assayData(object)
                     featureNames(ad) <- value
                     object@featureData <- fd
                     unsafeSetSlot(object, "assayData", ad)
                 })

setMethod("dimnames", "eSet", function(x) {
    list(featureNames(x), sampleNames(x))
})

setReplaceMethod("dimnames", "eSet", function(x, value) {
    featureNames(x) <- value[[1]]
    sampleNames(x) <- value[[2]]
    x
})

setMethod("dim", "eSet", function(x) assayDataDim(assayData(x)))

setMethod("dims", "eSet", function(x) assayDataDims(assayData(x)))

setMethod("[", "eSet", function(x, i, j, ..., drop = FALSE) {
  if (missing(drop))
    drop <- FALSE
  if (missing(i) && missing(j)) {
      if (!missing(...))
        stop("specify genes or samples to subset; use '",
             substitute(x), "$", names(list(...))[[1]],
             "' to access phenoData variables")
      return(x)
  }
  if (!isVersioned(x) || !isCurrent(x)["eSet"])
    x <- updateObject(x)
  if (!missing(j)) {
    phenoData(x) <- phenoData(x)[j,, ..., drop = drop]
    protocolData(x) <- protocolData(x)[j,, ..., drop = drop]
  }
  if (!missing(i))
    featureData(x) <- featureData(x)[i,,..., drop=drop]
  ## assayData; implemented here to avoid function call
  orig <- assayData(x)
  storage.mode <- assayDataStorageMode(orig)
  assayData(x) <-
    switch(storage.mode,
           environment =,
           lockedEnvironment = {
             aData <- new.env(parent=emptyenv())
             if (missing(i))                     # j must be present
               for(nm in ls(orig)) aData[[nm]] <- orig[[nm]][, j, ..., drop = drop]
             else {                              # j may or may not be present
               if (missing(j))
                 for(nm in ls(orig)) aData[[nm]] <- orig[[nm]][i,, ..., drop = drop]
               else
                 for(nm in ls(orig)) aData[[nm]] <- orig[[nm]][i, j, ..., drop = drop]
             }
             if ("lockedEnvironment" == storage.mode) assayDataEnvLock(aData)
             aData
           },
           list = {
             if (missing(i))                     # j must be present
               lapply(orig, function(obj) obj[, j, ..., drop = drop])
             else {                              # j may or may not be present
               if (missing(j))
                 lapply(orig, function(obj) obj[i,, ..., drop = drop])
               else
                 lapply(orig, function(obj) obj[i, j, ..., drop = drop])
             }
           })
  x
})

## $ stops dispatching ?!
##setMethod("$", "eSet", function(x, name) `$`(phenoData(x), name))
setMethod("$", "eSet", function(x, name) {
    eval(substitute(phenoData(x)$NAME_ARG, list(NAME_ARG=name)))
})

.DollarNames.eSet <- function(x, pattern = "")
    grep(pattern, names(pData(x)), value=TRUE)

setReplaceMethod("$", "eSet", function(x, name, value) {
  phenoData(x)[[name]] = value
  x
})

setMethod("[[", "eSet", function(x, i, j, ...) phenoData(x)[[i]])

setReplaceMethod("[[", "eSet",
                 function(x, i, j, ..., value) {
                     phenoData(x)[[i, ...]] <- value
                     x
                 })

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
setMethod("assayData", "eSet", function(object) object@assayData)

setReplaceMethod("assayData",
                 signature=signature(
                   object="eSet",
                   value="AssayData"),
                 function(object, value) {
                     object@assayData <- value
                     object
                 })

assayDataElementNames <- function(object) {
    if (storageMode(object) == "list") names(assayData(object))
    else ls(assayData(object))
}

assayDataElement <- function(object, elt) assayData(object)[[elt]]

.validate_assayDataElementReplace <- function(obj, value) {
    if (!is.null(value)) {
        dimvalue <- dim(value)
        dimobj <- dim(obj)[seq_along(dimvalue)]
        if (!isTRUE(all.equal(unname(dimvalue), unname(dimobj))))
            stop("object and replacement value have different dimensions")
    }
    
    if (!is.null(value)) {
        if (!is.null(dimnames(value))) {
            ## validate and harmonize dimnames
            vd <- Map(function(od, vd) {
                if (is.null(vd))
                    ## update vd to contain indexes into matrix
                    od <- seq_along(od)
                else if (!setequal(od, vd))
                    stop("object and replacement value dimnames differ")
                od
            }, dimnames(obj), dimnames(value))
            ## re-arrange value to have dimnames in same order as obj
            value <- do.call(`[`, c(list(value), vd, drop=FALSE))
        }
        dimnames(value) <- dimnames(obj)
    }
    value
}

assayDataElementReplace <- function(obj, elt, value, validate=TRUE) {
    ## 'validate' added later, needs to be last for position matching
    if (validate)
        value <- .validate_assayDataElementReplace(obj, value)

    storage.mode <- storageMode(obj)
    switch(storageMode(obj),
           "lockedEnvironment" = {
               aData <- copyEnv(assayData(obj))
               if (is.null(value)) rm(list=elt, envir=aData)
               else aData[[elt]] <- value
               assayDataEnvLock(aData)
               assayData(obj) <- aData
           },
           "environment" = {
               if (is.null(value)) rm(list=elt, envir=assayData(obj))
               else assayData(obj)[[elt]] <- value
           },
           list = assayData(obj)[[elt]] <- value)
    obj
}

`assayDataElement<-` <- function(obj, elt, ..., value)
    ## 'value' is always the last argument, but needs to be 3rd for
    ## assayDataElementReplace
    assayDataElementReplace(obj, elt, value, ...)

setMethod("phenoData", "eSet", function(object) object@phenoData)

setReplaceMethod("phenoData",
                 signature=signature(
                   object="eSet",
                   value="AnnotatedDataFrame"),
                 function(object, value) {
                     object@phenoData <- value
                     if (nrow(protocolData(object)) == 0) {
                         protocolData(object) <- value[,integer(0)]
                     }
                     object
                 })

setMethod("pData", "eSet", function(object) pData(phenoData(object)))

setReplaceMethod("pData",
                 signature=signature(
                   object="eSet",
                   value="data.frame"),
                 function(object, value) {
                     pd <- phenoData(object)
                     pData(pd) <- value
                     phenoData(object) <- pd
                     object
                 })

setMethod("varMetadata",
          signature=signature(object="eSet"),
          function(object) varMetadata(phenoData(object)))

setReplaceMethod("varMetadata",
                 signature=signature(
                   object="eSet",
                   value="data.frame"),
                 function(object, value) {
                     pd <- phenoData(object)
                     varMetadata(pd) <- value
                     object@phenoData <- pd
                     object
                 })

setMethod("varLabels",
          signature=signature(object="eSet"),
          function(object) varLabels(phenoData(object)))

setReplaceMethod("varLabels",
                 signature=signature(
                   object="eSet",
                   value="ANY"),
                 function(object, value) {
                     pd <- phenoData(object)
                     varLabels(pd) <- value
                     object@phenoData <- pd
                     object
                 })

setMethod("featureData",
          signature(object="eSet"),
          function(object) object@featureData)

setReplaceMethod("featureData",
                 signature=signature(
                   object="eSet",
                   value="AnnotatedDataFrame"),
                 function(object, value) {
                     object@featureData <- value
                     object
                 })

setMethod("fData",
          signature=signature(object="eSet"),
          function(object) pData(featureData(object)))

setReplaceMethod("fData",
                 signature=signature(
                   object="eSet",
                   value="data.frame"),
                 function(object, value) {
                     fd <- featureData(object)
                     pData(fd) <- value
                     object@featureData <- fd
                     object
                 })

setMethod("fvarMetadata",
          signature=signature(object="eSet"),
          function(object) varMetadata(featureData(object)))

setReplaceMethod("fvarMetadata",
                 signature=signature(
                   object="eSet",
                   value="data.frame"),
                 function(object, value) {
                     fd <- featureData(object)
                     varMetadata(fd) <- value
                     object@featureData <- fd
                     object
                 })

setMethod("fvarLabels",
          signature=signature(object="eSet"),
          function(object) varLabels(featureData(object)))

setReplaceMethod("fvarLabels",
                 signature=signature(
                   object="eSet",
                   value="ANY"),
                 function(object, value) {
                     pd <- featureData(object)
                     varLabels(pd) <- value
                     object@featureData <- pd
                     object
                 })

setMethod("experimentData", signature(object="eSet"), function(object) object@experimentData)

setReplaceMethod("experimentData",
                 signature=signature(
                   object="eSet",
                   value="MIAME"),
                 function(object, value) {
                     object@experimentData <- value
                     object
                 })

setMethod("description", signature(object="eSet"),
          function(object, ...) {
              experimentData(object)
          })

setReplaceMethod("description",
                 signature=signature(
                   object="eSet",
                   value="MIAME"),
                 function(object, value) {
                     object@experimentData <- value
                     object
                 })

setMethod("notes", signature(object="eSet"),
          function(object) otherInfo(experimentData(object)))

setReplaceMethod("notes",
                 signature=signature(
                   object="eSet",
                   value="ANY"),
                 function(object, value) {
                     ed <- experimentData(object)
                     notes(ed) <- value
                     object@experimentData <- ed
                     object
                 })

setMethod("pubMedIds", signature(object="eSet"),
          function(object) pubMedIds(experimentData(object)))

setReplaceMethod("pubMedIds",
                 signature=signature(
                   object="eSet",
                   value="character"),
                 function(object, value) {
                     ed <- experimentData(object)
                     pubMedIds(ed) <- value
                     object@experimentData <- ed
                     object
                 })

setMethod("abstract", "eSet", function(object) abstract(experimentData(object)))

setMethod("annotation", "eSet", definition = function(object) object@annotation)

setReplaceMethod("annotation",
                 signature=signature(
                   object="eSet",
                   value="character"),
                 function(object, value) {
                     object@annotation <- value
                     object
                 })

setMethod("protocolData", "eSet",
          function(object) {
              tryCatch(object@protocolData,
                       error = function(x) {
                         phenoData(object)[,integer(0)]
                       })
          })

setReplaceMethod("protocolData",
                 signature=signature(
                   object="eSet",
                   value="AnnotatedDataFrame"),
                 function(object, value) {
                     test <- try(object@protocolData, silent = TRUE)
                     if (inherits(test, "try-error"))
                       object <- updateObject(object)
                     object@protocolData <- value
                     object
                 })

setMethod("combine",
          signature=signature(
            x="eSet", y="eSet"),
          function(x, y, ...) {
              if (class(x) != class(y))
                stop("objects must be the same class, but are '",
                     class(x), "', '", class(y), "'")
              if (any(annotation(x) != annotation(y)))
                stop("objects have different annotations: ",
                     annotation(x), ", ", annotation(y))
              if (!isCurrent(x)[["eSet"]])
                  x <- updateObject(x)
              assayData(x) <- combine(assayData(x), assayData(y))
              phenoData(x) <- combine(phenoData(x), phenoData(y))
              featureData(x) <- combine(featureData(x), featureData(y))
              experimentData(x) <- combine(experimentData(x),experimentData(y))
              protocolData(x) <- combine(protocolData(x), protocolData(y))
              ## annotation -- constant
              x
          })

## Versions previously defined
.VersionsNull <- setClass("VersionsNull", contains="Versions")
.Versioned <- setClass("Versioned",
    representation(.__classVersion__ = "Versions"))
.VersionedBiobase <- setClass("VersionedBiobase",
    contains="Versioned",
    prototype=prototype(
      .__classVersion__ = .Versions(
        R = getRversion(),
        Biobase = package_version(packageDescription("Biobase", NULL, "Version")))))

# ==========================================================================
# Functions to operate with the environment:
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# .initContents; .buildBiobaseOpts;
# multiassign; copyEnv
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
.initContents <- function() {
   makeG = TRUE
   if( isGeneric("contents", where = .GlobalEnv ) )
       if( identical(names(formals(contents)), c("object", "all.names")) )
            makeG = FALSE
   if(makeG)
     setGeneric("contents", function(object, all.names)
                         standardGeneric("contents"))


   setMethod("contents", "environment",
      function(object, all.names) {
         if (missing(all.names))
            all.names <- FALSE
         as.list(object, all.names=all.names)
     }
   )
}
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
.buildBiobaseOpts <- function() {
    BioC <- getOption("BioC")
    if (is.null(BioC)) {
        BioC <- list()
        class(BioC) <- "BioCOptions"
    }
    Base <- BioC$Base
    if (is.null(Base)) {
        Base <- list()
        class(Base) <- "BioCPkg"
    }
    if (is.null(Base$urls))
        Base$urls <- list( bioc = "http://bioconductor.org")
    ##RI: I added this to make my life easier. Should it be TRUE?
    ##AJR: NO.  I've run across a few cases when it would completely
    ##     break functionality, i.e. when tcltk isn't part of the R
    ##     package (on weird, and development-based machines
    if (is.null(Base$use.widgets))
        Base$use.widgets <- FALSE
    BioC$Base <- Base
    options("BioC"=BioC)
}
# ==========================================================================
# RG:
# multiput and multiget
# ideally these will be internalized at some point
# FIXME: I think Luke's Dynamic variables should be used rather than
# the on.exit kludge
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
multiassign <- function (x, value, envir = parent.frame(), inherits = FALSE) {
   if( ! is.environment(envir) )
      stop("envir argument is not an environment")
   if( missing(value) ) {
      nx <- names(x)
      if( any(nchar(nx) == 0) )
         stop("value is missing and x does not have named components")
      value <- x
      x <- nx
   }
   lenx <- length(x)
   for(i in 1:lenx) {
      i2 <- (i-1)%%lenx+1
      if( is.list(x) ) {
         if( is.list(value) )
            assign(x[[i]], value[[i2]], envir=envir, inherits=inherits)
         else
            assign(x[[i]], value[i2], envir=envir, inherits=inherits)
      }
      else {
         if( is.list(value) )
            assign(x[i], value[[i2]], envir=envir, inherits=inherits)
         else
            assign(x[i], value[i2], envir=envir, inherits=inherits)
      }
   }
}



#### Functions for lists and environments

listLen <- function(x)
    lengths(x)


.new_env_size <- function(n) {
    ## helper function returns suggested size for new environments that
    ## will be used as hashtables given expected number of elements 'n'.
    max(29L, as.integer(n * 1.20))
}

copyEnv <- function(oldEnv, newEnv, all.names=FALSE) {
    if (missing(newEnv))
      newEnv <- new.env(hash=TRUE,
                        parent=parent.env(oldEnv),
                        size=.new_env_size(length(oldEnv)))
    nms <- ls(oldEnv, all.names = all.names)
    for (nm in nms)
        newEnv[[nm]] <- oldEnv[[nm]]

    newEnv
}


## Deprecated in v 2.11.2
l2e <- function(vals, envir) {
    .Defunct("list2env", package="base")
}

## Unversioned
##

setMethod("initialize", signature(.Object="VersionsNull"),
          function(.Object, ...) {
              if (!missing(...))
                warning("ignoring arguments to '.VersionsNull()')")
              .Object
          })

setMethod("show", signature(object="VersionsNull"),
          function(object) print("No version"))

setMethod("isCurrent", signature(object="MIAME", value="missing"),
          function(object, value) {
              cver <- callNextMethod()
              MIAMEres <- all(c(cver, "pubMedIds" %in% names(getObjectSlots(object))))
              if("MIAxE" %in% names(cver)) {
                  res <- c(cver["MIAxE"], MIAMEres) 
                  names(res) <- c("MIAxE", "MIAME")
              } else {res <- MIAMEres; names(res) <- "MIAME"}
              res
      })

setMethod("updateObject", signature(object="MIAME"),
          function(object, ..., verbose=FALSE) {
              if (verbose) message("updateObject(object = 'MIAME')")
              object <- asS4(object)
              if (isVersioned(object) && isCurrent(object)["MIAME"])
                callNextMethod()
              else
                object <- updateObjectFromSlots(object, ..., verbose=verbose)
                classVersion(object) <- classVersion(class(object))
                object
          })

# ==========================================================================
setMethod("show", "MIAME",
   function(object) {
      tmp <- c("samples","hybridizations","normalization controls","preprocessing")
      Index <-c(length(object@samples) > 0,
                length(object@hybridizations) > 0,
                length(object@normControls) > 0,
                length(object@preprocessing) > 0)
      cat("Experiment data\n")
      cat("  Experimenter name:",object@name,"\n")
      cat("  Laboratory:",object@lab,"\n")
      cat("  Contact information:",object@contact,"\n")
      cat("  Title:",object@title,"\n")
      cat("  URL:",object@url,"\n")
# deal with legacy MIAME objects!
      pmids = try( pubMedIds(object), silent=TRUE )
      if (!inherits(pmids, "try-error")) cat("  PMIDs:",pmids,"\n")
# end of dealing!
      if(length(object@abstract) > 0 && all(object@abstract!=""))
         cat("\n  Abstract: A",length(strsplit(object@abstract," ")[[1]]),
             "word abstract is available. Use 'abstract' method.\n")
      else
         cat("  No abstract available.\n")
      if(any(Index))
         cat("  Information is available on:", paste(tmp[Index],collapse=", "),"\n")
      nO = notes(object)
      if (length(nO) > 0) {
        cat("  notes:\n" )
        if( is.list(nO) ) {
           nms = names(nO)
           ##a print width for the values, so we stay inside the margins
           pw = options("width")[[1]] - 6
           for(i in 1:length(nO) ) {
              cat("   ", nms[i], ":", sep="")
              cat("     ", strbreak(nO[[i]], width=pw, exdent=0), sep="\n      ")
           }
        }
      }
}
)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
setMethod("abstract","MIAME",function(object) object@abstract)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
setMethod("samples","MIAME",function(object) object@samples)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
setMethod("hybridizations","MIAME",function(object) object@hybridizations)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
setMethod("normControls","MIAME",function(object) object@normControls)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
setMethod("preproc","MIAME",function(object) object@preprocessing)
setReplaceMethod("preproc", "MIAME", function(object, value) {
    object@preprocessing <- value
    object
})
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
setMethod("pubMedIds","MIAME",function(object) object@pubMedIds)

setReplaceMethod("pubMedIds","MIAME",function(object,value){
   object@pubMedIds = value
   object
})
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
setMethod("otherInfo","MIAME",function(object) object@other)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
setMethod("expinfo","MIAME",
   function(object) {
      tmp <- c(object@name, object@lab, object@contact, object@title, object@url)
    names(tmp) <- c("name","lab","contact","title","url")
    return(tmp)
   }
)
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
setMethod("notes", signature(object="MIAME"),
          function(object) object@other)

setReplaceMethod("notes", signature(object="MIAME", value="list"),
                 function(object, value) {
                     object@other <- value
                     object
                 })

setReplaceMethod("notes", signature(object="MIAME", value="character"),
                 function(object, value) {
                     object@other <- append(object@other, value)
                     object
                 })
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
MIAME <- 
    function(name = "", lab = "", contact = "",
             title = "", abstract = "", url = "",
             pubMedIds = "", samples = list(),
             hybridizations = list(), normControls = list(),
             preprocessing = list(), other = list()) {
        .MIAME(name=name, lab=lab, contact=contact, title=title,
               abstract=abstract, url=url, pubMedIds=pubMedIds,
               samples=samples, hybridizations=hybridizations,
               normControls=normControls, preprocessing=preprocessing,
               other=other)
    }


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
read.MIAME <- function(filename=NULL,widget=getOption("BioC")$Base$use.widgets,...) {
   if(!is.null(filename)) {
      miame <- scan(filename,what="c",quiet=TRUE,sep="\n",...)
      MIAME(name=miame[1], lab=miame[2], contact=miame[3],
            title=miame[4], abstract=miame[5], url=miame[6])
   }
   else
      if(widget) {
         requireNamespace("tkWidgets", quietly=TRUE) ||
             stop("Requires tkWidgets")
         tmp <- tkWidgets::tkMIAME()
         MIAME(name=tmp$ExperimentName, lab=tmp$LabName,
               contact=tmp$ContactInfo, title=tmp$ExperimentTitle,
               abstract=tmp$Description, url=tmp$URL)
      }
      else
         MIAME()
}
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
setMethod("combine", c("MIAME", "MIAME"), function(x, y, ...) {
  if (identical(x,y)) return (x)
  for (sl in names(getSlots(class(x)))) {
    if (identical(slot(x,sl),slot(y,sl)))
      next
    slot(x,sl) <- 
      switch(sl,
             ## multiple elements possible
             name=,
             lab=,
             contact=,
             title=,
             url=,
             pubMedIds=,
             samples=,
             hybridizations=,
             normControls=,
             preprocessing=,
             other=
             {
               c(slot(x,sl),slot(y,sl))
             },
             ## just a single entry
             abstract= {
               paste(slot(x,sl), slot(y,sl), collapse="\n")
             },
             .__classVersion__= {
                 stop("'MIAME' objects have different class version strings")
             },
             ## unknown
             {
                 warning("\n  unknown or conflicting information in MIAME field '", sl,"'; using information from object 'x'")
                 slot(x,sl)
             })

  }
  x
})

---
title: "*Biobase* development and the new `eSet`"
author:
- name: "Martin T. Morgan"
- name: "H. Khan"
  affiliation: "Vignette translation from Sweave to Rmarkdown / HTML"
date:  "`r format(Sys.time(), '%d %B, %Y')`"
package: Biobase
vignette: >
  %\VignetteIndexEntry{Notes for eSet developers}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
output:
  BiocStyle::html_document
---

Revised 4 September, 2006 -- `featureData` slot. Revised 20 April 2007 -- minor wording
changes; `verbose` and other arguments passed through `updateObject` example; introduce
a second variant of `initialize` illustrating its use as a copy constructor. Revised 4
November, 2010 -- `experimentData` slot as *MIAxE* class. *MIAME* class is now subclass
of *MIAxE*.

# Introduction

These notes help *developers* who are interested in using and extending the `eSet` class hierarchy, and using features in *Biobase*. The information here is not useful to regular users of *Biobase*.

This document illustrates the *Biobase* structures and approaches that make it it easy for developers to creatively use and extend the `eSet` class hierarchy.

The document starts with a brief description of the motivation for change, and a comparison of the old (before August, 2006) and new `eSet`s and related functionality (e.g.,the *Versioned* class and `updateObject` methods). We then illustrate how `eSet` can be extended to handle additional types of data, and how new methods can exploit the `eSet` class hierarchy. We conclude with a brief summary of lessons learned, useful developer-related side-effects of efforts to revise `eSet`, and possible directions for future development.

# Comparing old and new

What is an `eSet`?

-   Coordinate high through-put (e.g., gene expression) and phenotype data.
-   Provide common data container for diverse Bioconductor packages.

Motivation for change (August, 2006).

-   What was broken? Complex data structure. Inconsistent object validity. No straight-forward way to extend `eSet` to new data types.
-   What forward-looking design goals did we have? Flexible storage model. Class hierarchy to promote code reuse and facilitate extension to new data objects. Methods for updating serialized instances.

Key features in the redesign.

-   Simplified data content.
-   Structured class hierarchy.
-   Alternative storage modes.
-   More validity checking.
-   Conversion of example data in *Biobase*, and many other data sets elsewhere in Bioconductor, to *ExpressionSet*.
-   *Versioned* class information (in the development branch).
-   `updateObject` methods (in the development branch).

# A quick tour

```{r echo=FALSE, message=FALSE}
library(Biobase)
```

## The `eSet` object: high-throughput experiments

Purpose.

-   Coordinate and contain high-throughput genomic data.

Structure: virtual base class.

```{r}
getClass("eSet")
```

-   `assayData`: high-throughput data.
-   `phenoData`: sample covariates.
-   `featureData`: feature covariates.
-   `experimentData`: experimental description.
-   `annotation`: assay description.
-   See below, and `?"eSet-class"`

### `assayData`: high-throughput data

Purpose.

-   Efficiently and flexibly contain high-volume data.

Structure: *list*, *environment*, or *lockEnvironment* class union.

-   Each element of *list* / *environment* / *lockEnvironment* is a matrix
-   Rows: *features*, e.g., gene names.
-   Columns: *samples* represented on each chip.
-   All matrices must have the same dimensions, row names, and column names.
-   Subclasses determine which matrices *must* be present.
-   See `?"AssayData-class"`

### `phenoData`: sample covariates

Purpose.

-   Contain and document sample covariates.

Structure: *AnnotatedDataFrame*.

-   `data`: *data.frame*.
    -   Rows: sample identifiers.
    -   Columns: measured covariates.
-   `varMetadata`: *data.frame*.
    -   Rows: measured covariate labels.
    -   Columns: covariate descriptors.
-   See `?"AnnotatedDataFrame-class"`

### `featureData`: feature covariates

Purpose.

-   Contain and document feature covariates specific to the experiment; use the `annotation` slot for chip-level descriptions.

Structure: *AnnotatedDataFrame*.

-   `data`: *data.frame*.
    -   Rows: feature identifiers. These match row names of `assayData`.
    -   Columns: measured covariates.
-   `varMetadata`: *data.frame*.
    -   Rows: measured covariate labels.
    -   Columns: covariate descriptors.
-   See `?"AnnotatedDataFrame-class"`

### `experimentData`: experiment description

Purpose.

-   Summarize where and how the experiment was performed.

Structure: *MIAxE* virtual class

In Biobase version 2.11 the *MIAxE* virtual class was introduced as a general container for experiment meta-data. The *MIAME* class is now a subclass of *MIAxE*. See `?"MIAxE-class"`. The *MIAME* class structure is as follows

-   `title`: experiment title.
-   `name`: experimenter name(s).
-   `preprocessing: list` of pre-processing steps.
-   Additional slots.
-   See `?"MIAME-class"`.

### `annotation`: assay description

Purpose.

-   Link experiment to annotation package.

Structure: *character*

-   Label identifying annotation package.

## Important `eSet` methods

Initialization.

-   `eSet` is `VIRTUAL`, initialize via subclass `callNextMethod`

Accessors (get, set).

-   `assayData(obj); assayData(obj) <- value`: access or assign `assayData`
-   `phenoData(obj); phenoData(obj) <- value`: access or assign `phenoData`
-   `experimentData(obj); experimentData(obj) <- value`: access or assign `experimentData`
-   `annotation(obj); annotation(obj) <- value`: access or assign `annotation`

Subsetting.

-   `obj[i, j]`: select genes $i$ and samples $j$.
-   `obj$name; obj$name <- value`: retrieve or assign covariate `name` in `phenoData`

### Additional `eSet` methods

-   `show`.
-   `storageMode`: influence how `assayData` is stored.
-   `updateObject`: update `eSet` objects to their current version.
-   `validObject`: ensure that `eSet` is valid.

The `validObject` method is particularly important to `eSet`, ensuring that `eSet` contains consistent structure to data.

```{r}
getValidity(getClass("eSet"))
```

The validity methods for `eSet` reflect our design goals. All `assayData` members must have identical row and column dimensions and `featureNames`. The names and numbers of samples must be the same in `assayData` and `phenoData` slots. Validity methods are defined for the classes underlying each slot as well. For instance, the validity methods for `AnnotatedDataFrame` check that variables used in `pData` are at least minimally described in `varMetadata`.

## Subclasses of `eSet`

*Biobase* defines three classes that extend `eSet`. `ExpressionSet` (discussed further below) is meant to contain microarray gene expression data. *SnpSet* is a preliminary class to contain SNP data; other classes in development (e.g., in *oligo*) may provide alternative implementations for SNP data. *MultiSet* is an `ExpressionSet`-like class, but without restriction on the names (though not structure) of elements in the `assayData` slot.

### `ExpressionSet`

Purpose:

-   Contain gene expression data.

Required `assayData` members.

-   `exprs`, a matrix of expression values.

Important methods.

-   Initialization (additional details below):
    ```{r eval=FALSE}
    obj <- new("ExpressionSet",
               phenoData = new("AnnotatedDataFrame"),
               experimentData = new("MIAME"), annotation = character(),
               exprs = new("matrix"))
    ```

-   `exprs(obj), exprs(obj) <- value`: get or set `exprs`; methods defined for *ExpressionSet*, *AssayData*.

### *MultiSet* and *SnpSet*

*MultiSet*.

-   Purpose: flexibly contain a collection of expression data matricies.
-   Required `assayData` members: none.

*SnpSet*.

-   Purpose: contain genomic SNP calls.
-   Required `assayData` members: `call`, `callProbability`.

# Comments on `assayData`: high-throughput data storage

The `assayData` slot is meant to store high-throughput data. The idea is that the slot contains identically sized matrices containing expression or other data. All matrices in the slot must have the same dimension, and are structured so that rows represent 'features' and columns represent 'samples'. Validity methods enforce that row and column names of slot elements are identical.

For technical reasons, creating instance of *AssayData* is slightly different from the way this is usually done in [R]{.sans-serif}. Normally, one creates an instance of a class with an expression like `new("ExpressionSet", ...)`, with the ... representing additional arguments. *AssayData* objects are created with

```{r eval=FALSE}
assayDataNew("environment", elt)
```

where `elt` might be a matrix of expression values. For the curious, the reason for this setup stems from our desire to have a class that `is` a list or environment, rather than a class that has a slot that contains a list or environment. The `is` relationship is desirable to avoid unnecessary function calls to access slots, and requires that a class `contain` the base type (e.g., *environment*). Until recently an [R]{.sans-serif} object could not `contain` an *environment*.

The `assayData` slot of `ExpressionSet` objects must contain a matrix named `exprs`. Nonetheless, the `ExpressionSet` validity method tries to be liberal -- it guarantees that the object has an `exprs` element, but allows for other elements too. The prudent developer wanting consistent additional data elements should derive a class from `ExpressionSet` that enforces the presence of their desired elements.

The *AssayData* class allows for data elements to be stored in three different ways (see `?storageMode` and `?"storageMode<-"` for details): as a `list`, `environment`, or `lockedEnvironment`. Developers are probably familiar with `list` objects; a drawback is that `exprs` elements may be large, and some operations on lists in [R]{.sans-serif} may trigger creation of many copies of the the `exprs` element. This can be expensive in both space and time. Environments are nearly unique in [R]{.sans-serif}, in that they are passed by reference rather than value. This eliminates some copying, but has the unfortunate consequence that side-effects occur -- modifications to an environment inside a function influence the value of elements outside the function. For these reasons, environments can be useful as 'read only' arguments to functions, but can have unexpected consequences when functions modify their arguments. Locked environments implemented in *Biobase* try to strike a happy medium, allowing pass by reference for most operations but triggering (whole-environment) copying when elements in the environment are modified. The locking mechanism is enforced by only allowing known 'safe' operations to occur, usually by channeling user actions through the accessor methods:

```{r warning=FALSE}
data(sample.ExpressionSet)
storageMode(sample.ExpressionSet) 
tryCatch(assayData(sample.ExpressionSet)$exprs <- log(exprs(sample.ExpressionSet)), 
    error=function(err) cat(conditionMessage(err))) 
```

```{r eval=FALSE}
exprs(sample.ExpressionSet) <- log(exprs(sample.ExpressionSet))`
```

The `setReplaceMethod` for `exprs` (and `assayData`) succeeds by performing a deep copy of the entire environment. Because this is very inefficient, the recommended paradigm to update an element in a `lockedEnvironment` is to extract it, make many changes, and then reassign it. Developers can study `assayData` methods to learn more about how to lock and unlock environment bindings. *Biobase* allows the experienced user to employ (and run the risks of) environments, but the expectation is that most user objects are constructed with the default `lockedEnvironment` or `list`.

A longer term consideration in designing *AssayData* was to allow more flexible methods of data storage, e.g., through database-hosted arrays. This is facilitated by using generic functions such as `exprs()` for data access, so that classes derived from *AssayData* can provide implementations appropriate for their underlying storage mode.

# Extending `eSet`

A designer wanting to implement `eSet` for a particular type of data creates a class that 'contains' `eSet`. The steps for doing this are described below. One example of such a class is `ExpressionSet`, designed to hold a matrix of gene expression values in the `assayData` slot.

```{r}
getClass("ExpressionSet") 
getValidity(getClass("ExpressionSet")) 
```

The data structure of an `ExpressionSet` is identical to that of `eSet`, and in fact is inherited (without additional slot creation) from `eSet`. The main difference is that the validity methods of `eSet` are augmented by a method to check that the `assayData` slot contains an entity named `"exprs"`. A valid `ExpressionSet` object must also satisfy all the validity requirements of `eSet`, but the developer does not explicitly invoke validity checking of the parts of the data structure inherited from `eSet`.

## Implementing a new class: a *SwirlSet* example

We want the *Swirl* data set (see the `SW` two color data set that motivates this class) to contain four elements in the `assayData` slot: `R, G, Rb, Gb`. To derive a class from `eSet` for this data, we create a class, and provide initialization and validation methods.

We create a class as follows:

```{r}
setClass("SwirlSet", contains="eSet") 
```

Notice that there are no new data elements in *SwirlSet* compared with `eSet`. The `initialize` method is written as

```{r message=FALSE}
setMethod("initialize", "SwirlSet",
          function(.Object,
                   R = new("matrix"),
                   G = new("matrix"),
                   Rb = new("matrix"),
                   Gb = new("matrix"),
                   ...) {
            callNextMethod(.Object,
                           R=R, G=G, Rb=Rb, Gb=Gb,
                           ...) 
            }) 
```

A slightly different `initialize` method allows the user to specify either the `assayData` or the `assayData` content. In advanced use, this has the advantage that `initialize` can be used as a 'copy constructor' to update several slots simultaneously.

```{r}
setMethod("initialize", "SwirlSet",
          function(.Object,
                   assayData=assayDataNew(
                   R=R, G=G, Rb=Rb, Gb=Gb),
                   R = new("matrix"),
                   G = new("matrix"),
                   Rb = new("matrix"),
                   Gb = new("matrix"),
                   ...) {
              if (!missing(assayData) &&
                  any(!missing(R), !missing(G), !missing(Rb), !missing(Gb))) {
                  warning("using 'assayData'; ignoring 'R', 'G', 'Rb', 'Gb'")
              }
              callNextMethod(.Object, assayData=assayData, ...)
          })
```

The structure of the `initialize` method is a bit different from those often seen in [R]{.sans-serif}. Often, `initialize` has only `.Object` as a named argument, or, if there are other named arguments, they correspond to slot names. Here our initialize method accepts four arguments, named after the `assayData` elements. Inside the `initialize` method, the named arguments are passed to the next initialization method in the hierarchy (i.e., `initialize` defined for `eSet`). The `eSet` `initialize` method then uses these arguments to populate the data slots in `.Object`. In particular, `eSet` places all arguments other `phenoData`, `experimentData`, and `annotation` into the `assayData` slot. The `eSet` `initialize` method then returns the result to the `initialize` method of *SwirlSet*, which returns a *SwirlSet* object to the user:

```{r eval=FALSE}
new("SwirlSet")
```

General programming guidelines emerge from experience with the `initialize` method of `eSet` and derived classes. First, an appropriate strategy is to name only those data elements that will be manipulated directly by the `initialize` method. For instance, the definition above did *not* name `phenoData` and other `eSet` slots by name. To do so is not incorrect, but would require that they be explicitly named (e.g., `phenoData=phenoData`) in the `callNextMethod` code. Second, the arguments `R, G, Rb, Rg` are present in the `initialize` method to provide defaults consistent with object construction; the 'full' form of `callNextMethod`, replicating the named arguments, is required in the version of [R]{.sans-serif} in which this class was developed. Third, named arguments can be manipulated before `callNextMethod` is invoked. Fourth, the return value of `callNextMethod` can be captured...

```{r eval=FALSE}
setMethod("initialize", "MySet",
          function(.Object, ...) {
              .Object <- callNextMethod(.Object, ...)
          })
```

and manipulated before being returned to the user. Finally, it is the responsibility of the developer to ensure that a valid object is created; `callNextMethod` is a useful way to exploit correctly designed `initialize` methods for classes that the object extends, but the developer is free to use other techniques to create valid versions of their class.

A validity method might complete our new class. A validity method is essential to ensure that the unique features of *SwirlSet* -- our reason for designing the new class -- are indeed present. We define our validity method to ensure that the `assayData` slot contains our four types of expression elements:

```{r}
setValidity("SwirlSet", function(object) {
    assayDataValidMembers(assayData(object), c("R", "G", "Rb", "Gb"))
})
```

Notice that we do not have to explicitly request that the validity of other parts of the *SwirlSet* object are valid; this is done for us automatically. Objects are checked for validity when they are created, but not when modified. This is partly for efficiency reasons, and partly because object updates might transiently make them invalid. So a good programing practice is to ensure validity after modification, e.g.,

```{r eval=FALSE}
myFancyFunction <- function(obj) {
    assayData(obj) <- fancyAssaydData # obj invalid...
    phenoData(obj) <- justAsFancyPhenoData # but now valid
    validObject(obj)
    (obj)
}
```

Assigning `fancyAssaydData` might invalidate the object, but `justAsFancyPhenoData` restores validity.

# *Versioned*

One problem encountered in the Bioconductor project is that data objects stored to disk become invalid as the underlying class definition changes. For instance, earlier releases of *Biobase* contain a sample *eSet* object. But under the changes discussed here, `eSet` is virtual and the stored object is no longer valid. The challenge is to easily identify invalid objects, and to provide a mechanism for updating old objects to their new representation.

*Biobase* introduces the *Versioned* and *VersionedBiobase* classes to facilitate this. These classes are incorporated into key *Biobase*class definitions.*Biobase* also defines `updateObject` methods (the `updateObject` generic function is defined in the `r Biocpkg("BiocGenerics")` package) for conveniently updating old objects to their new representation.

```{r}
data(sample.ExpressionSet) 
classVersion(sample.ExpressionSet) 
obj <- updateObject(sample.ExpressionSet)
```

The version information for this object is a named list. The first two elements indicate the version of R and Biobase used to create the object. The latter two elements are contained in the class prototype, and the class prototype is consulted to see if the instance of an object is 'current'. These lists can be subsetted in the usual way, e.g.,

```{r}
isCurrent(sample.ExpressionSet)[c("eSet", "ExpressionSet")]
```

Versioned classes, `updateObject` and related methods simplify the long-term maintenance of data objects. Take the fictious *MySet* as an example.

```{r}
setClass("MySet",
         contains = "eSet",
         prototype = prototype(new("VersionedBiobase",
                               versions=c(classVersion("eSet"), MySet="1.0.0"))))
obj <- new("MySet")
classVersion(obj)
```

This is a new class, and might undergo changes in its structure at some point in the future. When these changes are introduced, the developer will change the version number of the class in its prototype (the last line, below):

```{r}
 setClass("MySet",
          contains = "eSet",
          prototype = prototype( 
              new("VersionedBiobase",
                  versions=c(classVersion("eSet"), MySet="1.0.1"))))
isCurrent(obj)
```

and add code to update to the new version

```{r}
setMethod("updateObject", signature(object="MySet"),
          function(object, ..., verbose=FALSE) {
              if (verbose) message("updateObject(object = 'MySet')")
                  object <- callNextMethod()
              if (isCurrent(object) ["MySet"]) return(object)
              ## Create an updated instance.
              if (!isVersioned(object))
                  ## Radical surgery – create a new, up-to-date instance
                  new("MySet",
                      assayData = updateObject(assayData(object),
                          ..., verbose=verbose),
                      phenoData = updateObject(phenoData(object),
                          ..., verbose=verbose),
                      experimentData = updateObject(experimentData(object),
                          ..., verbose=verbose),
                      annotation = updateObject(annotation(object),
                          ..., verbose=verbose))
              else {
                  ## Make minor changes, and update version by consulting class definition
                  classVersion(object)["MySet"]<-
                  classVersion("MySet")["MySet"]
                  object
              }
          })
```

The code after `if(!isVersioned)` illustrates one way of performing 'radical surgery, creating a new up-to-date instance by updating all slots. The `else` clause represents more modest changes, using methods to update stale information. `updateObject` then returns a new, enhanced object:

```{r}
classVersion(updateObject(obj))
```

As in the example, versioning helps in choosing which modifications to perform -- minor changes for a slightly out-of-date object, radical surgery for something more ancient. Version information might also be used in methods, where changing class representation might facilitate more efficient routines.

## *Versioned* versus *VersionedBiobase*

The information on [R]{.sans-serif} and *Biobase* versions is present in `eSet` derived classes because `eSet` contains *VersionedBiobase*. On the other hand, *AnnotatedDataFrame* contains *Versioned*, and has only information about its own class version.

```{r}
classVersion(new("AnnotatedDataFrame"))
```

The rationale for this is that *AnnotatedDataFrame* is and will likely remain relatively simple, and details about [R]{.sans-serif} and *Biobase* are probably irrelevant to its use. On the other hand, some aspects of `eSet` and the algorithms that operate on them are more cutting edge and subject to changes in [R]{.sans-serif} or *Biobase*. Knowing the version of [R]{.sans-serif} and *Biobase* used to create an instance might provide valuable debugging information.

## Adding *Versioned* information to your own classes

The key to versioning your own classes is to define your class to `contain` *Versioned* or *VersionedBiobase*, and to add the version information in the prototype. For instance, to add a class-specific version stamp to *SwirlSet* we would modify the class definition to

```{r}
setClass("SwirlSet", contains = "eSet",
         prototype = prototype(
             new("VersionedBiobase",
                 versions=c(classVersion("eSet"), SwirlSet="1.0.0"))))
classVersion(new("SwirlSet"))
```

See additional examples in the *Versioned* help page.

It is also possible to add arbitrary information to particular instances.

```{r}
obj <- new("SwirlSet")
classVersion(obj)["MyID"] <- "0.0.1"
classVersion(obj)
```

```{r}
 classVersion(updateObject(obj))
```

There is additional documentation about these classes and methods in *Biobase*.

# Summary

This document summarizes *Biobase*, outlining strategies that developers using *Biobase* may find useful. The main points are to introduce the `eSet` class hierarchy, to illustrate how developers can effectively extend this class, and to introduce class versions as a way of tracking and easily updating objects. It is anticipated that `eSet`-derived classes will play an increasingly important role in *Biobase* development.

# Session Information

The version number of [R]{.sans-serif} and packages loaded for generating the vignette were:

```{r}
sessionInfo()
```

\name{MultiSet}
\docType{class}
\alias{class:MultiSet}
\alias{MultiSet}

\alias{MultiSet-class}
\alias{initialize,MultiSet-method}
\alias{coerce,eSet,MultiSet-method}

\title{
  Class to Contain and Describe High-Throughput Expression Level Assays.
}

\description{
  Container for high-throughput assays and experimental
  metadata. \code{MutliSet} is derived from
  \code{\link{eSet-class}}. \code{MultiSet} differs from
  \code{\link{ExpressionSet-class}} because \code{MultiSet} can contain
  any element(s) in \code{assayData} (\code{ExpressionSet} must have an
  element named \code{exprs}).
}
\section{Extends}{
   Directly extends class \code{\link{eSet}}.
}
\section{Creating Objects}{

  \code{new('MultiSet',
    phenoData = [AnnotatedDataFrame],
    experimentData = [MIAME],
    annotation = [character],
    protocolData = [AnnotatedDataFrame],
    ...)
  }

  \code{updateOldESet(oldESet,"MultiSet")}

  \code{MultiSet} instances are usually created through
  \code{new("MultiSet", ...)}. The \code{...} arguments to \code{new}
  are matrices of expression data (with features
  corresponding to rows and samples to columns), \code{phenoData},
  \code{experimentData}, \code{annotation}, and \code{protocolData}. 
  \code{phenoData}, \code{experimentData}, \code{annotation}, and
  \code{protocolData} can be missing, in which case they are assigned
  default values.

  \code{\link{updateOldESet}} will take a serialized instance (e.g., saved to a disk
  file with \code{save} object created with earlier definitions of
  the \code{eSet-class}, and update the object to
  \code{MultiSet}. Warnings are issued when direct translation is not
  possible; incorrectly created \code{oldESet} instances may not be updated.
}
\section{Slots}{
  Inherited from \code{eSet}:
   \describe{
      \item{\code{assayData}:}{Contains zero or more matrices with equal
	dimensions, and with column number equal to
	\code{nrow(phenoData)}. Each matrix in \code{assayData} has rows
	representing features (e.g., reporters) and columns representing
	samples. Class:\code{\link{AssayData-class}}}
      \item{\code{phenoData}:}{See \code{\link{eSet-class}}}
      \item{\code{experimentData}:}{See \code{\link{eSet-class}}}
      \item{\code{annotation}:}{See \code{\link{eSet-class}}}
      \item{\code{protocolData}:}{See \code{\link{eSet-class}}}
  }
}
\section{Methods}{

   Class-specific methods: none

   Derived from \code{\link{eSet-class}}:
   \describe{
     \item{\code{updateObject(object, ..., verbose=FALSE)}}{Update instance to current version, if necessary. See \code{\link{updateObject}} and \code{\link{eSet}}}
     \item{\code{isCurrent(object)}}{Determine whether version of object is current. See \code{\link{isCurrent}}}
     \item{\code{isVersioned(object)}}{Determine whether object contains a 'version' string describing its structure . See \code{\link{isVersioned}}}
     \item{\code{sampleNames(MultiSet)} and \code{sampleNames(MultiSet)<-}:}{See \code{\link{eSet-class}}}
     \item{\code{featureNames(MultiSet)}, \code{featureNames(MultiSet, value)<-}:}{See \code{\link{eSet-class}}}
     \item{\code{dims(MultiSet)}:}{See \code{\link{eSet-class}}}
     \item{\code{phenoData(MultiSet)}, \code{phenoData(MultiSet,value)<-}:}{See \code{\link{eSet-class}}}
     \item{\code{varLabels(MultiSet)}, \code{varLabels(MultiSet, value)<-}:}{See \code{\link{eSet-class}}}
     \item{\code{varMetadata(MultiSet)}, \code{varMetadata(MultiSet,value)<-}:}{See \code{\link{eSet-class}}}
     \item{\code{pData(MultiSet)}, \code{pData(MultiSet,value)<-}:}{See \code{\link{eSet-class}}}
     \item{\code{varMetadata(MultiSet)}, \code{varMetadata(MultiSet,value)}}{See \code{\link{eSet-class}}}
     \item{\code{experimentData(MultiSet)},\code{experimentData(MultiSet,value)<-}:}{See \code{\link{eSet-class}}}
     \item{\code{pubMedIds(MultiSet)}, \code{pubMedIds(MultiSet,value)}}{See \code{\link{eSet-class}}}
     \item{\code{abstract(MultiSet)}:}{See \code{\link{eSet-class}}}
     \item{\code{annotation(MultiSet)}, \code{annotation(MultiSet,value)<-}}{See \code{\link{eSet-class}}}
     \item{\code{protocolData(MultiSet)}, \code{protocolData(MultiSet,value)<-}}{See \code{\link{eSet-class}}}
     \item{\code{combine(MultiSet,MultiSet)}:}{See \code{\link{eSet-class}}}
     \item{\code{storageMode(eSet)}, \code{storageMode(eSet,character)<-}:}{See \code{\link{eSet-class}}}
  }

  Standard generic methods:
  \describe{
     \item{\code{initialize(MultiSet)}:}{Object instantiation, used by \code{new}; not to be called directly by the user.}
     \item{\code{validObject(MultiSet)}:}{Validity-checking method, ensuring that all elements of \code{assayData} are matricies with equal dimensions.}
     \item{\code{as(eSet,MultiSet)}:}{Coerce the \code{eSet} portion of an object to \code{MultiSet}.}
     \item{\code{show(MultiSet)}}{See \code{\link{eSet-class}}}
     \item{\code{dim(MultiSet)}, \code{ncol}}{See \code{\link{eSet-class}}}
     \item{\code{MultiSet[(index)}:}{See \code{\link{eSet-class}}}
     \item{\code{MultiSet$}, \code{MultiSet$<-}}{See \code{\link{eSet-class}}}
  }
}

\author{Biocore team}

\seealso{
  \code{\link{eSet-class}}, \code{\link{ExpressionSet-class}}
}

\examples{
# create an instance of ExpressionSet
new("MultiSet")
}

\keyword{classes}

\name{storageMode}
\alias{storageMode}
\alias{storageMode<-}

\title{Retrieve or set storage mode for eSets.}
\description{
  These generic functions report or change the storage mode used for \code{assayData}.
}
\usage{
storageMode(object)
storageMode(object) <- value
}
\arguments{
  \item{object}{Object, derived from class \code{eSet}}
  \item{value}{Character vector containing
    \code{"lockedEnvironment"},\code{"environment"}, or
    \code{"list"}. See \code{AssayData-class} for details.}
}
\value{
  \code{storageMode} returns a length-1 character vector
}
\author{Biocore}

\seealso{\code{\link{AssayData-class}}, \code{\link{eSet-class}} \code{\link{ExpressionSet-class}}, \code{\link{SnpSet-class}}}

\keyword{manip}

\name{Versioned}
\docType{class}
\alias{Versioned-class}
\alias{Versioned}

\alias{initialize,Versioned-method}
\alias{isVersioned,Versioned-method}
\alias{classVersion,Versioned-method}
\alias{classVersion<-,Versioned,Versions-method}
\alias{isCurrent,Versioned,missing-method}
\alias{isCurrent,Versioned,character-method}
\alias{show,Versioned-method}

\title{Class "Versioned"}

\description{

  Use this class as a `superclass' for classes requiring information
  about versions.

}

\section{Methods}{

  The following are defined; package developers may write additional methods.
  \describe{
    \item{\code{new("Versioned", ..., versions=list())}}{Create a new \code{Versioned-class} instance,
      perhaps with additional named version elements (the contents of
      \code{versions}) added. Named elements of \code{versions} are
      character strings that can be coerced using \code{\link{package_version}}, or \code{package_version} instances.}
    \item{\code{classVersion(object)}}{Obtain version information about instance \code{object}. See \code{\link{classVersion}}.}
    \item{\code{classVersion(object) <- value}}{Set version information on instance \code{object} to \code{value}; useful when \code{object} is an instance of a class that contains \code{VersionClass}. See \code{\link{classVersion}}.}
    \item{\code{classVersion(object)["id"] <- value}}{Create or update version information \code{"id"} on instance \code{object} to \code{value}; useful when \code{object} is an instance of a class that contains \code{VersionClass}. See \code{\link{classVersion}}.}
    \item{\code{show(object)}}{Default method returns \code{invisible},
      to avoid printing confusing information when your own class does
      not have a \code{show} method defined. Use
      \code{classVersion(object)} to get or set version information.}
  }
}

\author{Biocore}

\seealso{
  \code{\link{Versions-class}}
}

\examples{

obj <- new("Versioned", versions=list(A="1.0.0"))
obj
classVersion(obj)

A <- setClass("A", contains="Versioned")

classVersion("A")
a <- A()
a # 'show' nothing by default
classVersion(a)

B <- setClass("B", contains="Versioned",
         prototype=prototype(new("Versioned",versions=list(B="1.0.0"))))

classVersion("B")
b <- B()
classVersion(b)

classVersion(b)["B"] <- "1.0.1"
classVersion(b)
classVersion("B")

classVersion("B") < classVersion(b)
classVersion(b) == "1.0.1"

C <- setClass("C",
         representation(x="numeric"),
         contains=("VersionedBiobase"),
         prototype=prototype(new("VersionedBiobase", versions=c(C="1.0.1"))))

setMethod("show", signature(object="C"),
          function(object) print(object@x))

c <- C(x=1:10)
c

classVersion(c)

}

\keyword{classes}

\name{data:sample.ExpressionSet}
\alias{data:sample.ExpressionSet}
\alias{sample.ExpressionSet}
\docType{data}
\title{Dataset of class 'ExpressionSet'}
\usage{data(sample.ExpressionSet)}
\format{
  The data for 26 cases, labeled A to Z and 500 genes.
  Each case has three covariates: sex (male/female); type
  (case/control); and score (testing score). 
}
\description{
The expression data are real but anonymized. The data are from an
experiment that used Affymetrix U95v2 chips. The data were processed by
dChip and then exported to R for analysis.

The data illustrate \code{\link{ExpressionSet-class}}, with
\code{assayData} containing the required matrix element \code{exprs} and
an additional matrix \code{se.exprs}. \code{se.exprs} has the same
dimensions as \code{exprs}.

The phenoData and standard error estimates (se.exprs) are made up.  
The information in the "description" slot is fake.  
}
\examples{
data(sample.ExpressionSet)
}
\keyword{datasets}

\name{annotatedDataFrameFrom-methods}
\docType{methods}
\alias{annotatedDataFrameFrom}
\alias{annotatedDataFrameFrom,AssayData-method}
\alias{annotatedDataFrameFrom,matrix-method}
\alias{annotatedDataFrameFrom,NULL-method}

\title{Methods for Function annotatedDataFrameFrom in Package `Biobase'}
\description{
  \code{annotatedDataFrameFrom} is a convenience for creating
  \code{\link{AnnotatedDataFrame}} objects.
}
\section{Methods}{
  Use the method with \code{annotatedDataFrameFrom(object, byrow=FALSE,
    ...)}; the argument \code{byrow} \emph{must} be specified.
\describe{
  \item{\code{signature(object="assayData")}}{This method creates an
    \code{AnnotatedDataFrame} using sample (when \code{byrow=FALSE}) or
    feature (\code{byrow=TRUE}) names and dimensions of an
    \code{\link{AssayData}} object as a template.}
  \item{\code{signature(object="matrix")}}{This method creates an
    \code{AnnotatedDataFrame} using column (when \code{byrow=FALSE}) or
    row (\code{byrow=TRUE}) names and dimensions of a
    \code{\link{matrix}} object as a template.}
  \item{\code{signature(object="NULL")}}{This method (called with 'NULL'
    as the object) creates an empty \code{AnnotatedDataFrame}; provides
    \code{dimLabels} based on value of \code{byrow}.}
}}

\author{Biocore team}

\keyword{methods} 

\name{VersionedBiobase}
\docType{class}
\alias{VersionedBiobase-class}
\alias{VersionedBiobase}

\title{Class "VersionedBiobase"}

\description{

  Use this class as a `superclass' for classes requiring information
  about versions. By default, the class contains versions for R and
  Biobase. See \code{\link{Versioned-class}} for additional details.

}

\section{Methods}{

  set \code{\link{Versioned-class}} for methods.

}

\author{Biocore}

\seealso{
  \code{\link{Versioned-class}}
}

\examples{

obj <- new("VersionedBiobase")
classVersion(obj)

obj <- new("VersionedBiobase", versions=list(A="1.0.0"))
classVersion(obj)

A <- setClass("A", contains="VersionedBiobase")

classVersion("A")
a <- A()
classVersion(a)

obj <- new("VersionedBiobase", versions=c(MyVersion="1.0.0"))
classVersion(obj)

B <- setClass("B", contains="VersionedBiobase",
         prototype=prototype(new("VersionedBiobase",versions=list(B="1.0.0"))))

classVersion("B")
b <- B()
classVersion(b)

removeClass("A")
removeClass("B")

}

\keyword{classes}

\name{ScalarObject-class}
\docType{class}
\alias{ScalarObject-class}
\alias{ScalarCharacter-class}
\alias{ScalarLogical-class}
\alias{ScalarInteger-class}
\alias{ScalarNumeric-class}
\alias{mkScalar}

\alias{show,ScalarObject-method}
\alias{show,ScalarCharacter-method}

\title{Utility classes for length one (scalar) objects}

\usage{
mkScalar(obj)
}

\arguments{
  \item{obj}{An object of type \code{character}, \code{logical},
    \code{integer}, or \code{double}}
}

\description{
  These classes represent scalar quantities, such as a string or a
  number and are useful because they provide their own validity
  checking.  The classes \code{ScalarCharacter}, \code{ScalarLogical}, 
  \code{ScalarInteger}, and \code{ScalarNumeric} all extend their
  respective base vector types and can be used interchangeably (except
  they should always have length one).

  The \code{mkScalar} factory function provides a convenient way of
  creating \code{Scalar<type>} objects (see the examples section below).

}

\author{Seth Falcon}
\examples{
v <- list(mkScalar("a single string"),
          mkScalar(1),
          mkScalar(1L),
          mkScalar(TRUE))
sapply(v, class)
sapply(v, length)
}
\keyword{classes}

\name{Biobase-package}
\alias{Biobase-package}
\alias{Biobase}
\docType{package}
\title{Biobase Package Overview}
\description{
   Biobase Package Overview
}
\details{
  Important data classes: \code{\link{ExpressionSet}},
  \code{\link{AnnotatedDataFrame}}
  \code{\link{MIAME}}. Full help on methods and
  associated functions is available from within class help
  pages.

  Additional data classes: \code{\link{eSet}}, \code{\link{MIAxE}},
  \code{\link{MultiSet}}. Additional manipulation and data structuring
  classes: \code{\link{Versioned}}, \code{\link{VersionedBiobase}},
  \code{\link{aggregator}}, \code{\link{container}}.

  Vignette routines: \code{\link{openVignette}},
  \code{\link{getPkgVigs}}, \code{\link{openPDF}}.

  Package manipulation functions: \code{\link{createPackage}} and
  \code{\link{package.version}}

  Data sets: \code{\link{aaMap}}, \code{\link{sample.ExpressionSet}},
  \code{\link{geneData}}.

  Introductory information is available from vignettes, type
  \code{openVignette()}.

  Full listing of documented articles is available in HTML view by
  typing \code{help.start()} and selecting \code{Biobase} package from the
  \code{Packages} menu or via \code{library(help="Biobase")}.
}
\author{
   O. Sklyar
}
\keyword{package}

\name{abstract}
\alias{abstract}
\alias{pubMedIds}
\alias{pubMedIds<-}
\alias{experimentData}
\alias{experimentData<-}

\title{Retrieve Meta-data from eSets and ExpressionSets.}

\description{
  These generic functions access generic data, abstracts, PubMed IDs
 and experiment data from instances of the 
  \code{\link{eSet-class}} or \code{\link{ExpressionSet-class}}.
}

\usage{
abstract(object)
pubMedIds(object)
pubMedIds(object) <- value
experimentData(object)
experimentData(object) <- value
}
\arguments{
  \item{object}{Object, possibly derived from \code{eSet-class} or 
    \code{MIAME-class}}
  \item{value}{Value to be assigned; see class of \code{object} (e.g.,
    \code{\link{eSet-class}}) for specifics.}
}
\value{
  \code{abstract} returns a character vector containing the abstract
  (as in a published paper) associated with \code{object}.

  \code{pubMedIds} returns a character vector of PUBMED IDs associated
  with the experiment.

  \code{experimentData} returns an object representing the description
  of an experiment, e.g., an object of \code{\link{MIAME-class}}
}
\author{Biocore}

\seealso{\code{\link{ExpressionSet-class}}, \code{\link{eSet-class}}, 
   \code{\link{MIAME-class}}}

\keyword{manip}

\name{anyMissing}
\alias{anyMissing}


\title{Checks if there are any missing values in an object or not}

\description{
  IMPORTANT NOTE: \code{anyMissing()} was deprecated in \pkg{Biobase} 2.69.1.
  Please use \code{anyNA()} instead.

  Checks if there are any missing values in an object or not.
}

\usage{anyMissing(x=NULL)}

\arguments{
 \item{x}{A \code{\link[base]{vector}}.}
}

\value{
  Returns \code{\link[base:logical]{TRUE}} if a missing value was detected, otherwise \code{\link[base:logical]{FALSE}}.
}

\details{
  The implementation of this method is optimized for both speed and memory.
}

\author{Henrik Bengtsson (\url{http://www.braju.com/R/})}

\examples{
## IMPORTANT NOTE: anyMissing() was deprecated in Biobase 2.69.1.
## Please use anyNA() instead.
\dontrun{
x <- rnorm(n=1000)
x[seq(300,length(x),by=100)] <- NA
stopifnot(anyMissing(x) == any(is.na(x)))
}
}

\keyword{iteration}
\keyword{logic}

\name{Deprecated and Defunct}
\title{Biobase Deprecated and Defunct}

\alias{class:annotatedDataset}
\alias{annotatedDataset}
\alias{annotatedDataset-class}
\alias{initialize,annotatedDataset-method}

\alias{class:exprList}
\alias{exprList}
\alias{exprList-class}

\alias{class:exprMatrix}
\alias{exprMatrix}
\alias{exprMatrix-class}

\alias{class:exprSet}
\alias{exprSet}
\alias{exprSet-class}
\alias{initialize,exprSet-method}

\alias{class:phenoData}
\alias{phenoData-class}
\alias{initialize,phenoData-method}

\alias{data:sample.eSet}
\alias{sample.eSet}

\alias{data:sample.exprSet.1}
\alias{sample.exprSet.1}

\alias{data:sample.exprSet}
\alias{sample.exprSet}

\alias{df2pD}
\alias{read.pD}
\alias{read.exprSet}
\alias{read.phenoData}

\alias{geneNames}
\alias{geneNames,ExpressionSet-method}
\alias{geneNames<-}
\alias{geneNames<-,ExpressionSet,character-method}

\alias{getExpData}
\alias{getExpData,eSet,character-method}

\alias{eList}
\alias{eList,eSet-method}
\alias{eList<-}
\alias{eList<-,eSet,AssayData-method}

\alias{reporterNames}
\alias{reporterNames,eSet-method}
\alias{reporterNames<-}
\alias{reporterNames<-,eSet,character-method}

\alias{updateOldMiame}

\alias{l2e}

\alias{biocReposList}

\description{
   The function, class, or data object you have asked for has been deprecated or made defunct. 
}

\keyword{internal}

\name{ExpressionSet}
\docType{class}
\alias{class:ExpressionSet}
\alias{ExpressionSet}
\alias{ExpressionSet-class}
\alias{ExpressionSet,missing-method}
\alias{ExpressionSet,environment-method}
\alias{ExpressionSet,matrix-method}

\alias{exprs,ExpressionSet-method}
\alias{exprs<-,ExpressionSet,matrix-method}

\alias{initialize,ExpressionSet-method}
\alias{coerce,exprSet,ExpressionSet-method}
\alias{coerce,eSet,ExpressionSet-method}
\alias{coerce,ExpressionSet,data.frame-method}
\alias{esApply,ExpressionSet-method}
\alias{updateObject,ExpressionSet-method}
\alias{makeDataPackage,ExpressionSet-method}
\alias{as.data.frame.ExpressionSet}
\alias{write.exprs}
\alias{write.exprs,ExpressionSet-method}

\title{
  Class to Contain and Describe High-Throughput Expression Level Assays.
}

\description{
  Container for high-throughput assays and experimental
  metadata. \code{ExpressionSet} class is derived from
  \code{\link{eSet}}, and requires a matrix named \code{exprs} as
  assayData member.
}

\usage{
## Instance creation
ExpressionSet(assayData,
    phenoData=annotatedDataFrameFrom(assayData, byrow=FALSE),
    featureData=annotatedDataFrameFrom(assayData, byrow=TRUE),
    experimentData=MIAME(), annotation=character(),
    protocolData=annotatedDataFrameFrom(assayData, byrow=FALSE),
    ...)

## Additional methods documented below
}

\arguments{

  \item{assayData}{A \code{matrix} of expression values, or an
    \code{environment}.

    When \code{assayData} is a \code{matrix}, the rows represent probe
    sets (\sQuote{features} in \code{ExpressionSet} parlance).  Columns
    represent samples. When present, row names identify features and
    column names identify samples. Row and column names must be unique,
    and consistent with row names of \code{featureData} and
    \code{phenoData}, respectively. The assay data can be retrieved with
    \code{exprs()}.

    When \code{assayData} is an environment, it contains identically
    dimensioned matrices like that described in the previous
    paragraph. One of the elements of the environment must be named
    \sQuote{exprs}; this element is returned with \code{exprs()}.

  }

  \item{phenoData}{An optional \code{AnnotatedDataFrame} containing
    information about each sample. The number of rows in
    \code{phenoData} must match the number of columns in
    \code{assayData}. Row names of \code{phenoData} must match column
    names of the matrix / matricies in \code{assayData}.}

  \item{featureData}{An optional \code{AnnotatedDataFrame} containing
    information about each feature. The number of rows in
    \code{featureData} must match the number of rows in
    \code{assayData}. Row names of \code{featureData} must match row
    names of the matrix / matricies in \code{assayData}.}

  \item{experimentData}{An optional \code{MIAME} instance with meta-data
    (e.g., the lab and resulting publications from the analysis) about
    the experiment.}

  \item{annotation}{A \code{character} describing the platform on which
    the samples were assayed. This is often the name of a Bioconductor
    chip annotation package, which facilitated down-stream analysis.}

  \item{protocolData}{An optional \code{AnnotatedDataFrame} containing
    equipment-generated information about protocols. The number of rows
    and row names of \code{protocolData} must agree with the dimension
    and column names of \code{assayData}.}

  \item{\dots}{Additional arguments, passed to
    \code{new("ExpressionSet", ...)} and available for classes that extend
    \code{ExpressionSet}.
  }

}

\section{Extends}{
   Directly extends class \code{\link{eSet}}.
}
\section{Creating Objects}{

  \code{ExpressionSet} instances are usually created through
  \code{ExpressionSet()}.

}
\section{Slots}{
  Inherited from \code{eSet}:
   \describe{
      \item{\code{assayData}:}{Contains matrices with equal
	dimensions, and with column number equal to
	\code{nrow(phenoData)}. \code{assayData} must contain a matrix
	\code{exprs} with rows representing features (e.g., probe sets)
	and columns representing samples. Additional matrices of
	identical size (e.g., representing measurement errors) may
	also be included in \code{assayData}. Class:\code{\link{AssayData-class}}}
      \item{\code{phenoData}:}{See \code{\link{eSet}}}
      \item{\code{featureData}:}{See \code{\link{eSet}}}
      \item{\code{experimentData}:}{See \code{\link{eSet}}}
      \item{\code{annotation}:}{See \code{\link{eSet}}}
      \item{\code{protocolData}:}{See \code{\link{eSet}}}
  }
}
\section{Methods}{

  Class-specific methods.
  \describe{
    \item{\code{as(exprSet,"ExpressionSet")}}{Coerce objects of
      \code{\link{exprSet-class}} to \code{ExpressionSet}}
    \item{\code{as(object,"data.frame")}}{Coerce objects of
      \code{\link{ExpressionSet-class}} to \code{data.frame} by
      transposing the expression matrix and concatenating \code{phenoData}}
     \item{\code{exprs(ExpressionSet)}, \code{exprs(ExpressionSet,matrix)<-}}{Access and
       set elements named \code{exprs} in the \code{AssayData-class}
       slot.}
     \item{\code{esApply(ExpressionSet, MARGIN, FUN,
         ...)}}{'apply'-like function to conveniently operate on
       \code{ExpressionSet} objects. See \code{\link{esApply}}.}
     \item{\code{write.exprs(ExpressionSet)}}{Write expression values to
	 a text file. It takes the same arguments as
	 \code{write.table}}
    }

   Derived from \code{\link{eSet}}:
   \describe{
     \item{\code{updateObject(object, ..., verbose=FALSE)}}{Update instance to current version, if necessary. See \code{\link{updateObject}} and \code{\link{eSet}}}
     \item{\code{isCurrent(object)}}{Determine whether version of object is current. See \code{\link{isCurrent}}}
     \item{\code{isVersioned(object)}}{Determine whether object contains a 'version' string describing its structure . See \code{\link{isVersioned}}}
     \item{\code{assayData(ExpressionSet)}:}{See \code{\link{eSet}}}
     \item{\code{sampleNames(ExpressionSet)} and \code{sampleNames(ExpressionSet)<-}:}{See \code{\link{eSet}}}
     \item{\code{featureNames(ExpressionSet)}, \code{featureNames(ExpressionSet, value)<-}:}{See \code{\link{eSet}}}
     \item{\code{dims(ExpressionSet)}:}{See \code{\link{eSet}}}
     \item{\code{phenoData(ExpressionSet)}, \code{phenoData(ExpressionSet,value)<-}:}{See \code{\link{eSet}}}
     \item{\code{varLabels(ExpressionSet)}, \code{varLabels(ExpressionSet, value)<-}:}{See \code{\link{eSet}}}
     \item{\code{varMetadata(ExpressionSet)}, \code{varMetadata(ExpressionSet,value)<-}:}{See \code{\link{eSet}}}
     \item{\code{pData(ExpressionSet)}, \code{pData(ExpressionSet,value)<-}:}{See \code{\link{eSet}}}
     \item{\code{varMetadata(ExpressionSet)}, \code{varMetadata(ExpressionSet,value)}}{See \code{\link{eSet}}}
     \item{\code{experimentData(ExpressionSet)},\code{experimentData(ExpressionSet,value)<-}:}{See \code{\link{eSet}}}
     \item{\code{pubMedIds(ExpressionSet)}, \code{pubMedIds(ExpressionSet,value)}}{See \code{\link{eSet}}}
     \item{\code{abstract(ExpressionSet)}:}{See \code{\link{eSet}}}
     \item{\code{annotation(ExpressionSet)}, \code{annotation(ExpressionSet,value)<-}}{See \code{\link{eSet}}}
     \item{\code{protocolData(ExpressionSet)}, \code{protocolData(ExpressionSet,value)<-}}{See \code{\link{eSet}}}
     \item{\code{combine(ExpressionSet,ExpressionSet)}:}{See \code{\link{eSet}}}
     \item{\code{storageMode(ExpressionSet)}, \code{storageMode(ExpressionSet,character)<-}:}{See \code{\link{eSet}}}
  }

  Standard generic methods:
  \describe{
    \item{\code{initialize(ExpressionSet)}:}{Object instantiation, used
      by \code{new}; not to be called directly by the user.}
    \item{\code{updateObject(ExpressionSet)}:}{Update outdated versions
      of \code{ExpressionSet} to their current definition. See
      \code{\link{updateObject}}, \code{\link{Versions-class}}.}
    \item{\code{validObject(ExpressionSet)}:}{Validity-checking method, ensuring
      that \code{exprs} is a member of
      \code{assayData}. \code{checkValidity(ExpressionSet)} imposes this
      validity check, and the validity checks of \code{eSet}.}
    \item{\code{makeDataPackage(object, author, email, packageName, packageVersion, license, biocViews, filePath, description=paste(abstract(object), collapse="\n\n"), ...)}}{
      Create a data package based on an ExpressionSet object. See
      \code{\link{makeDataPackage}}.}
     \item{\code{as(exprSet,ExpressionSet)}:}{Coerce \code{exprSet} to \code{ExpressionSet}.}
     \item{\code{as(eSet,ExpressionSet)}:}{Coerce the \code{eSet} portion of an object to \code{ExpressionSet}.}
     \item{\code{show(ExpressionSet)}}{See \code{\link{eSet}}}
     \item{\code{dim(ExpressionSet)}, \code{ncol}}{See \code{\link{eSet}}}
     \item{\code{ExpressionSet[(index)}:}{See \code{\link{eSet}}}
     \item{\code{ExpressionSet$}, \code{ExpressionSet$<-}}{See \code{\link{eSet}}}
     \item{\code{ExpressionSet[[i]]}, \code{ExpressionSet[[i]]<-}}{See \code{\link{eSet}}}
  }
}

\author{Biocore team}

\seealso{
  \code{\link{eSet-class}}, \code{\link{ExpressionSet-class}}.
}

\examples{
# create an instance of ExpressionSet
ExpressionSet()

ExpressionSet(assayData=matrix(runif(1000), nrow=100, ncol=10))

# update an existing ExpressionSet
data(sample.ExpressionSet)
updateObject(sample.ExpressionSet)

# information about assay and sample data
featureNames(sample.ExpressionSet)[1:10]
sampleNames(sample.ExpressionSet)[1:5]
experimentData(sample.ExpressionSet)

# subset: first 10 genes, samples 2, 4, and 10
expressionSet <- sample.ExpressionSet[1:10,c(2,4,10)]

# named features and their expression levels
subset <- expressionSet[c("AFFX-BioC-3_at","AFFX-BioDn-5_at"),]
exprs(subset)

# samples with above-average 'score' in phenoData
highScores <- expressionSet$score > mean(expressionSet$score)
expressionSet[,highScores]

# (automatically) coerce to data.frame
lm(score~AFFX.BioDn.5_at + AFFX.BioC.3_at, data=subset)
}

\keyword{classes}

\name{matchpt}
\alias{matchpt}
\docType{methods}

\title{Nearest neighbor search.}
\description{
    Find the nearest neighbors of a set of query points in the same
    or another set of points in an
    n-dimensional real vector space, using the Euclidean distance.
}

\usage{
    matchpt(x, y)
}
\arguments{
  \item{x}{A matrix (or vector) of coordinates.
    Each row represents a point in an \code{ncol(x)}-dimensional real
    vector space.}
  \item{y}{Optional, matrix (or vector) with the same number of columns
    as \code{x}.}
}

\details{
  If \code{y} is provided, the function searches
  for each point in \code{x} its nearest neighbor in \code{y}.
  If \code{y} is missing, it searches
  for each point in \code{x} its nearest neighbor in \code{x},
  excluding that point itself.
  In the case of ties, only the neighbor with the smaller index is given.

  The implementation is simple and of complexity \code{nrow(x)} times
  \code{nrow(y)}. For larger problems, please consider one of the many
  more efficient nearest neighbor search algorithms.
 }
 
\value{
  A \code{data.frame} with two columns and \code{nrow(x)} rows.
  The first column is the index of the nearest neighbor,
  the second column the distance to the nearest neighbor.
  If \code{y} was given, the index is a row number in \code{y},
  otherwise, in \code{x}. The row names of the result are those of \code{x}.
}

\author{
    Oleg Sklyar \email{osklyar@ebi.ac.uk}
}

\examples{
    a <- matrix(c(2,2,3,5,1,8,-1,4,5,6), ncol=2L, nrow=5L)
    rownames(a) = LETTERS[seq_len(nrow(a))]
    matchpt(a)
    b <- c(1,2,4,5,6)
    d <- c(5.3, 3.2, 8.9, 1.3, 5.6, -6, 4.45, 3.32)
    matchpt(b, d)
    matchpt(d, b)
}

\keyword{manip}
\keyword{array}

\name{channel}
\alias{channel}

\title{Create a new ExpressionSet instance by selecting a specific channel}
\description{
  This generic function extracts a specific element from an 
  object, returning a instance of the ExpressionSet class.
}
\usage{
channel(object, name, ...)
}
\arguments{
  \item{object}{An S4 object, typically derived from class
    \code{\link{eSet}}}
  \item{name}{The name of the channel, a (length one) character vector.}
  \item{...}{Additional arguments.}
}
\value{
  An instance of class \code{\link{ExpressionSet}}.
}
\author{Biocore}

\examples{
obj <- NChannelSet(
           R=matrix(runif(100), 20, 5),
           G=matrix(runif(100), 20, 5))
## G channel as ExpressionSet
channel(obj, "G")
}
\keyword{manip}

\name{readExpressionSet}
\alias{readExpressionSet}
\concept{ExpressionSet}

\title{Read 'ExpressionSet'}

\description{
  Create an instance of class ExpressionSet by reading data from files.
  \sQuote{widget} functionality is not implemented for readExpressionSet.
}

\usage{
readExpressionSet(exprsFile,
      phenoDataFile,
      experimentDataFile,
      notesFile,
      path,
      annotation,
      ## arguments to read.* methods 
      exprsArgs=list(sep=sep, header=header, row.names=row.names,
        quote=quote, ...),
      phenoDataArgs=list(sep=sep, header=header, row.names=row.names,
        quote=quote, stringsAsFactors=stringsAsFactors, ...),
      experimentDataArgs=list(sep=sep, header=header,
        row.names=row.names, quote=quote,
        stringsAsFactors=stringsAsFactors, ...),
      sep = "\t", header = TRUE, quote = "", stringsAsFactors = FALSE,
      row.names = 1L,
      ## widget
      widget = getOption("BioC")$Base$use.widgets,
      ...)
}

\arguments{
  \item{exprsFile}{(character) File or connection from which to read expression
    values. The file should contain a matrix with rows as features and
    columns as samples. \code{\link{read.table}} is called with this
    as its \code{file} argument and further arguments given by \code{exprsArgs}.}
  \item{phenoDataFile}{(character) File or connection from which to read
    phenotypic data. \code{\link{read.AnnotatedDataFrame}} is called
    with this as its \code{file} argument and further arguments given by
    \code{phenoDataArgs}.}
  \item{experimentDataFile}{(character) File or connection from which to read
    experiment data. \code{\link{read.MIAME}} is called with this
    as its \code{file} argument and further arguments given by
    \code{experimentDataArgs}.}
  \item{notesFile}{(character) File or connection from which to read notes;
    \code{\link{readLines}} is used to input the file.}
  \item{path}{(optional) directory in which to find all the above files.}
  \item{annotation}{(character) A single character string indicating the
    annotation associated with this ExpressionSet.}
  \item{exprsArgs}{A list of arguments to be used with
    \code{\link{read.table}} when reading in the expression matrix.}
  \item{phenoDataArgs}{A list of arguments to be used (with
    \code{\link{read.AnnotatedDataFrame}}) when reading
    the phenotypic data.}
  \item{experimentDataArgs}{A list of arguments to be used (with
    \code{\link{read.MIAME}}) when reading the experiment data.}
  \item{sep, header, quote, stringsAsFactors, row.names}{arguments used
    by the \code{\link{read.table}}-like functions.}
  \item{widget}{A boolean value indicating whether widgets can be
    used. Widgets are NOT yet implemented for
    \code{read.AnnotatedDataFrame}.}
  \item{\dots}{Further arguments that can be passed on to the
    \code{\link{read.table}}-like functions.}
}
\details{
  Expression values are read using the \code{\link{read.table}}
  function. Phenotypic data are read using the
  \code{\link{read.AnnotatedDataFrame}} function. Experiment data are
  read using the \code{\link{read.MIAME}} function. Notes are read using
  the \code{\link{readLines}} function. The return value must be a valid
  \code{ExpressionSet}. Only the \code{exprsFile} argument is required.
}
  

\value{
  An instance of the \code{\linkS4class{ExpressionSet}} class.
}

\author{Martin Morgan <mtmorgan@fhcrc.org>}

\seealso{\code{\link{ExpressionSet}} for additional methods.}

\examples{

exprsFile = system.file("extdata", "exprsData.txt", package="Biobase")
phenoFile = system.file("extdata", "pData.txt", package="Biobase")

## Read ExpressionSet with appropriate parameters
obj = readExpressionSet(exprsFile, phenoFile, sep = "\t", header=TRUE)
obj

}
\keyword{file}
\keyword{manip}

\name{description}
\alias{description}
\alias{description<-}

\title{Retrieve and set overall experimental information eSet-like classes.}
\description{
  These generic functions access experimental information
  associated with \code{\link{eSet-class}}. 
}
\usage{
description(object, \dots)
description(object) <- value
}
\arguments{
  \item{object}{Object, possibly derived from class \code{\link{eSet-class}}.}
  \item{value}{Structured information describing the experiment, e.g.,
    of \code{\link{MIAME-class}}.}
  \item{\dots}{Further arguments to be used by other methods. } 
}
\value{
  \code{description} returns an object of \code{\link{MIAME-class}}.
}
\author{Biocore}

\seealso{\code{\link{eSet-class}}, \code{\link{MIAME-class}}}

\keyword{manip}

\name{cache}
\alias{cache}
\docType{methods}

\title{Evaluate an expression if its value is not already cached.}
\description{
  Cache the evaluation of an expression in the file system.
}

\usage{
    cache(expr, dir=".", prefix="tmp_R_cache_")
}
\arguments{
    \item{expr}{An expression of the form \code{LHS <- RHS}, Where
      \code{LHS} is a variable name, \code{RHS} is any valid expression,
      and \code{<-} must be used (\code{=} will not work).}

    \item{dir}{A string specifying the directory into which cache files
      should be written (also where to go searching for an appropriate
      cache file).}

    \item{prefix}{A string giving the prefix to use when naming and
      searching for cache files.  The default is \code{"tmp_R_cache_"}}

}

\details{
  This function can be useful during the development of computationally
  intensive workflows, for example in vignettes or scripts.  The
  function uses a cache file in \code{dir} which defaults to the current
  working directory whose name is obtained by \code{paste(prefix, name,
  ".RData", sep="")}.
  
  When \code{cache} is called and the cache file exists, it is loaded
  and the object whose name is given on the left of \code{<-} in
  \code{expr} is returned.  In this case, \code{expr} is \emph{not}
  evaluted.

  When \code{cache} is called and the cache file does not exist,
  \code{expr} is evaluted, its value is saved into a cache file, and
  then its value is returned.

  The \code{expr} argument must be of the form of \code{someVar <-
    {expressions}}.  That is, the left hand side must be a single symbol
    name and the next syntactic token must be \code{<-}.
  
  To flush the cache and force recomputation, simply remove the cache
  files.  You can use \code{\link{file.remove}} to do this.

}

\value{
    The (cached) value of \code{expr}.
}

\author{
  Wolfgang Huber, \email{huber@ebi.ac.uk}
  Seth Falcon, \email{sfalcon@fhcrc.org}
}

\section{Note}{

  The first version of this function had a slightly different interface
  which is no longer functional.  The old version has arguments
  \code{name} and \code{expr} and the intended usage is: \code{foo <-
  cache("foo", expr)}.

}

\examples{
    bigCalc <- function() runif(10)
    cache(myComplicatedObject <- bigCalc())
    aCopy <- myComplicatedObject
    remove(myComplicatedObject)
    cache(myComplicatedObject <- bigCalc())
    stopifnot(all.equal(myComplicatedObject, aCopy))
    allCacheFiles <-
       list.files(".", pattern="^tmp_R_cache_.*\\\\.RData$", full.name=TRUE)
    file.remove(allCacheFiles)
}

\keyword{manip}
\keyword{array}

\name{isCurrent}
\alias{isCurrent}

\alias{isCurrent,ANY,ANY-method}

\title{Use version information to test whether class is current}

\description{
  This generic function uses \code{\link{Versioned-class}} information
  to ask whether an instance of a class (e.g., read from disk) has
  current version information.

  By default, \code{isCurrent} has the following behaviors:
  \describe{
    \item{\code{isCurrent(Versioned-instance)}}{Returns a vector of
	  logicals, indicating whether each version matches the current version
	  from the class prototype.}
    \item{\code{isCurrent(ANY)}}{Return \code{NA}, indicating that the
      version cannot be determined}
    \item{\code{isCurrent(Versioned-instance, "class")}}{Returns a
	  logical vector indicating whether version identifiers shared between
	  \code{Versioned-instance} and \code{"class"} are current.}
  }

  Starting with R-2.6 / Bioconductor 2.1 / Biobase 1.15.1,
  \code{isCurrent(Versioned-instance, ...)} returns an element \code{S4}
  indicating whether the class has the `S4' bit set; a value of
  \code{FALSE} indicates that the object needs to be recreated.
}

\usage{
isCurrent(object, value)
}

\arguments{
  \item{object}{Object whose version is to be determined, as described above.}
  \item{value}{(Optional) character string identifying a class with which to compare versions.}
}
\value{
  \code{isCurrent} returns a logical vector.
}

\author{Biocore team}

\seealso{\code{\link{Versions-class}}}

\examples{



obj <- new("VersionedBiobase")
isCurrent(obj)

isCurrent(1:10) # NA

A <- setClass("A", contains="VersionedBiobase",
         prototype=prototype(new("VersionedBiobase", versions=c(A="1.0.0"))))

a <- A()
classVersion(a)

isCurrent(a, "VersionedBiobase") # is the 'VersionedBiobase' portion current?
classVersion(a)["A"] <- "1.0.1"
classVersion(a)
isCurrent(a, "VersionedBiobase")
isCurrent(a) # more recent, so does not match 'current' defined by prototype

removeClass("A")
}

\keyword{manip}

\name{data:aaMap}
\alias{data:aaMap}
\alias{aaMap}
\docType{data}
\title{Dataset: Names and Characteristics of Amino Acids }
\usage{data(aaMap)}
\description{
The \code{aaMap} data frame has 20 rows and 6 columns. Includes elementary information about amino acids.
}
\format{
  This data frame contains the following columns:
  \describe{
    \item{name}{amino acid name}
    \item{let.1}{one-letter code}
    \item{let.3}{three-letter code}
    \item{scProp}{side chain property at pH 7 (polar/nonpolar)}
    \item{hyPhilic}{logical: side chain is hydrophilic at pH 7}
    \item{acidic}{logical: side chain is acidic at pH 7}
  }
}
\source{
Nei M and Kumar S: Molecular evolution and phylogenetics (Oxford 2000), Table 1.2
}
\examples{
data(aaMap)
}
\keyword{datasets}

\name{Aggregate}
\alias{Aggregate}
\title{A Simple Aggregation Mechanism.  }
\description{
   Given an environment and an aggregator (an object of class \code{aggregate} simple aggregations are made.
}
\usage{
Aggregate(x, agg)
}
\arguments{
   \item{x}{ The data to be aggregated. }
   \item{agg}{The aggregator to be used. }
}
\details{
  Given some data, \code{x} the user can accumulate (or aggregate)
  information in \code{env} using the two supplied functions.
  See the accompanying documentation for a more complete example of this
  function and its use.
}
\value{
 No value is returned. This function is evaluated purely for side
 effects. The symbols and values in \code{env} are altered.
}

\author{R. Gentleman }

\seealso{
   \code{\link{new.env}},  \code{\link{class:aggregator}}
}

\examples{
  agg1 <- new("aggregator")
  Aggregate(letters[1:10], agg1)
  # the first 10 letters should be symbols in env1 with values of 1
  Aggregate(letters[5:11], agg1)
  # now letters[5:10] should have value 2
  bb <- mget(letters[1:11], env=aggenv(agg1), ifnotfound=NA)
  t1 <- as.numeric(bb); names(t1) <- names(bb)
  t1
# a b c d e f g h i j k
# 1 1 1 1 2 2 2 2 2 2 1
}

\keyword{programming}
\keyword{methods}

\name{contents}
\alias{contents}
\title{Function to retrieve contents of environments}
\description{
  The contents method is used to retrieve the values stored in an
  environment.
}
\usage{
contents(object, all.names)
}
\arguments{
    \item{object}{The environment (data table) that you want to get all contents from}
    \item{all.names}{a logical indicating whether to copy all values in \code{as.list.environment}}
}
\value{
  A named list is returned, where the elements are the objects stored in
  the environment.  The names of the elements are the names of the
  objects.

  The \code{all.names} argument is identical to the one used in
  \code{as.list.environment}.
}
\author{R. Gentleman}
\seealso{\code{\link{as.list.environment}}}
\examples{
  z <- new.env()
  multiassign(letters, 1:26, envir=z)
  contents(z)
}
\keyword{manip}

\name{read.AnnotatedDataFrame}
\alias{read.AnnotatedDataFrame}
\alias{write.AnnotatedDataFrame}
\concept{AnnotatedDataFrame}

\title{Read and write 'AnnotatedDataFrame'}

\description{

  Create an instance of class AnnotatedDataFrame by reading a file, or
  save an AnnotatedDataFrame to a file.

}

\usage{
read.AnnotatedDataFrame(filename, path,
     sep = "\t", header = TRUE, quote = "", stringsAsFactors = FALSE, 
     row.names = 1L,
     varMetadata.char="#",
     widget = getOption("BioC")$Base$use.widgets,
     sampleNames = character(0), ...) 
write.AnnotatedDataFrame(x, file="", varMetadata.char="#", ...,
     append=FALSE, fileEncoding="")
}

\arguments{
  \item{filename, file}{file or connection from which to read / write.}
  \item{x}{An instance of class \code{AnnotatedDataFrame}.}
  \item{path}{(optional) directory in which to find \code{filename}.}
  \item{row.names}{this argument gets passed on to
    \code{\link{read.table}} and will be used for the row names of the
    phenoData slot.}
  \item{varMetadata.char}{lines beginning with this character are used
    for the \code{varMetadata} slot. See examples.}
  \item{sep, header, quote, stringsAsFactors, ...}{further arguments
    that get passed on to \code{\link{read.table}} or \code{write.table}.}
  \item{widget}{logical. Currently this is \emph{not} implemented, and
    setting this option to \code{TRUE} will result in an error. In a
    precursor of this function, \code{read.phenoData}, this option could
    be used to open an interactive GUI widget for entering the data.}
  \item{sampleNames}{optional argument that could be used in conjunction
    with \code{widget}; do not use.}
  \item{append, fileEncoding}{Arguments as described in
    \code{\link{write.table}}}.
}

\details{

  The function \code{\link{read.table}} is used to read
  \code{pData}. The argument \code{varMetadata.char} is passed on to
  that function as its argument \code{comment.char}.
  Lines beginning with  \code{varMetadata.char} are expected to contain
  further information on the column headers of \code{pData}.
  The format is of the form: \code{# variable: textual explanation of the
    variable, units, measurement method, etc.} (assuming that \code{#}
  is the value of \code{varMetadata.char}). See also examples.

  \code{write.AnnotatedDataFrame} outputs \code{varLabels} and
  \code{varMetadata(x)$labelDescription} as commented header lines, and
  \code{pData(x)} as a with \code{write.table}.

}

\value{

  \code{read.AnnotatedDataFrame}: An instance of class
  \code{AnnotatedDataFrame}

  \code{write.AnnotatedDataFrame}: \code{NULL}, invisibly.

}

\author{Martin Morgan <mtmorgan@fhcrc.org> and Wolfgang Huber,
  based on \code{read.phenoData} by Rafael A. Irizarry.}

\seealso{\code{\link{AnnotatedDataFrame}} for additional methods,
  \code{\link{read.table}} for details of reading in phenotypic data}

\examples{

exampleFile = system.file("extdata", "pData.txt", package="Biobase")

adf <- read.AnnotatedDataFrame(exampleFile)
adf
head(pData(adf))
head(noquote(readLines(exampleFile)), 11)

write.AnnotatedDataFrame(adf)           # write to console by default

}
\keyword{file}
\keyword{manip}

\name{class:characterORMIAME}
\docType{class}
\alias{class:characterORMIAME}
\alias{characterORMIAME-class}

\concept{characterORMIAME}
\title{Class to Make Older Versions Compatible}
\description{This class can be either \code{character} or
  \code{MIAME}.}
\section{Methods}{
No methods defined with class "characterORMIAME" in the signature.
}
\seealso{See also \code{\link{MIAME}}}
\keyword{classes}

\name{copySubstitute}
\alias{copySubstitute}

\title{Copy Between Connections or Files with Configure-Like Name-Value Substitution}

\description{
  Copy files, directory trees or between connections and
  replace all occurences of a symbol by the corresponding value.
}

\usage{
copySubstitute(src, dest, symbolValues, symbolDelimiter="@", allowUnresolvedSymbols=FALSE,
               recursive = FALSE, removeExtension = "\\\\.in$")
}

\arguments{
  \item{src}{Source, either a character vector with filenames and/or
    directory names, or a connection object.}
  \item{dest}{Destination, either a character vector of length 1
    with the name of an existing, writable directory, or a connection
    object. The class of the \code{dest} argument must match that of the
    \code{src} argument.}
  \item{symbolValues}{A named list of character strings.}
  \item{symbolDelimiter}{A character string of length one with a single
    character in it.}
  \item{allowUnresolvedSymbols}{Logical. If \code{FALSE}, then the function
    will execute \code{\link[base:stop]{stop}} if it comes across
    symbols that are not defined in \code{symbolValues}.}
  \item{recursive}{Logical. If \code{TRUE}, the function
    works recursively down a directory tree (see details).}
  \item{removeExtension}{Character. Matches to this regular expression are removed
    from filenames and directory names.}
}

\details{
  Symbol substitution: this is best explained with an example. If the list
  \code{symbolValues} contains an element with name \code{FOO} and value
  \code{bar}, and symbolDelimiter is \code{@}, then any occurrence of
  \code{@FOO@} is replaced by \code{bar}. This applies both the text
  contents of the files in \code{src} as well as to the filenames. See examples.

  If \code{recursive} is \code{FALSE}, both \code{src} and \code{dest}
  must be connection or a filenames. The text in \code{src} is read
  through the function \code{\link[base:readLines]{readLines}},
  symbols are replaced by their values, and the result is written to
  \code{dest} through the function \code{\link[base:readLines]{writeLines}}.

  If \code{recursive} is \code{TRUE},
  \code{\link[Biobase:copySubstitute]{copySubstitute}}
  works recursively down a directory tree (see details and example).
  \code{src} must be a character vector with multiple filenames or
  directory names, \code{dest} a directory name.

  One use of this function is in
  \code{\link[Biobase:createPackage]{createPackage}}
  for the automatic generation of packages from a template package directory.
}

\value{
  None. The function is called for its side effect.
}

\author{Wolfgang Huber \url{http://www.dkfz.de/mga/whuber}}
\keyword{connection}
\keyword{programming}

\examples{
## create an example file
infile  = tempfile()
outfile = tempfile()

writeLines(text=c("We will perform in @WHAT@:",
  "So, thanks to @WHOM@ at once and to each one,",
  "Whom we invite to see us crown'd at @WHERE@."),
  con = infile)

## create the symbol table
z = list(WHAT="measure, time and place", WHOM="all", WHERE="Scone")

## run copySubstitute
copySubstitute(infile, outfile, z)

## display the results
readLines(outfile)



##--------------------------------------------------------------
## This is a slightly more complicated example that demonstrates
## how copySubstitute works on nested directories
##--------------------------------------------------------------
d = tempdir()
my.dir.create = function(x) {dir.create(x); return(x)}

unlink(file.path(d, "src"), recursive=TRUE)
unlink(file.path(d, "dest"), recursive=TRUE)

## create some directories and files:
src  = my.dir.create(file.path(d, "src"))
dest = file.path(d, "dest")
d1   = my.dir.create(file.path(src, "dir1.in"))
d2   = my.dir.create(file.path(src, "dir2@FOO@.in"))
d3   = my.dir.create(file.path(d2, "dir3"))
d4   = my.dir.create(file.path(d3, "dir4"))
d5   = my.dir.create(file.path(d4, "dir5@BAR@"))
writeLines(c("File1:", "FOO: @FOO@"),     file.path(d1, "file1.txt.in"))
writeLines(c("File2:", "BAR: @BAR@"),     file.path(d2, "file2.txt.in"))
writeLines(c("File3:", "SUN: @SUN@"),     file.path(d3, "file3.txt.in"))
writeLines(c("File4:", "MOON: @MOON@"),   file.path(d4, "@SUN@.txt"))

## call copySubstitute
copySubstitute(src, dest, recursive=TRUE,
               symbolValues = list(FOO="thefoo", BAR="thebar",
                                   SUN="thesun", MOON="themoon"))

## view the result
listsrc  = dir(src,  full.names=TRUE, recursive=TRUE)
listdest = dir(dest, full.names=TRUE, recursive=TRUE)
listsrc
listdest

cat(unlist(lapply(listsrc,  readLines)), sep="\n")
cat(unlist(lapply(listdest, readLines)), sep="\n")
}

\name{userQuery}
\alias{userQuery}
\title{A function to query the user for input}
\description{
  This function will output a given message and seek a response from the
  user, repeating the message until the input is from a valid set
  provided by the code.
}
\usage{
userQuery(msg, allowed = c("y", "n"), default = "n", case.sensitive = FALSE)
}
\arguments{
  \item{msg}{The output message}
  \item{allowed}{Allowed input from the user}
  \item{default}{Default response if called in batch mode}
  \item{case.sensitive}{Is the response case sensitive? Defaults to
    \code{FALSE}}
}
\value{
  The input from the user
}
\author{Jeff Gentry}
\keyword{utilities}

\name{reporter}
\alias{data:reporter}
\alias{reporter}
\docType{data}
\title{Example data.frame representing reporter information}
\description{
  The \code{reporter} object is a 500 by 1 data frame. The rows represent
  the 500 probe IDs in the \code{geneData} data. The values in
  \code{reporter} are the predefined probe types for the probes.
  \code{reporter} is used in conjunction with the \code{geneData} object
  and its associates.  
}
\usage{data(reporter)}
\format{
  A 500 by 1 data frame
}
\details{
  There are 10 predefined probe types:

  \itemize{
    \item \code{AFFX-} Quality Control (QC)
    \item \code{_f_} SequenceFamily
    \item \code{_g_} CommonGroups
    \item \code{_s_} SimilarityConstraint
    \item \code{_r_} RulesDropped
    \item \code{_i_} Incomplete
    \item \code{_b_} AmbiguousProbeSet
    \item \code{_l_} LongProbeSet
    \item \code{_at} AntiSenseTarget
    \item \code{_st} SenseTarget
  }
}
\source{
  Affymetrix GeneChip Expression Analysis Data Analysis Fundamentals (\url{http://www.affymetrix.com/Auth/support/downloads/manuals/data_analysis_fundamentals_manual.pdf})
}
\examples{
data(reporter)
## maybe str(reporter) ; plot(reporter) ...
}
\keyword{datasets}

\name{Versions}
\docType{class}
\alias{Versions-class}
\alias{Versions}

\alias{initialize,Versions-method}
\alias{[,Versions-method}
\alias{[<-,Versions-method}
\alias{[[<-,Versions-method}
\alias{$<-,Versions-method}
\alias{Compare,Versions,Versions-method}
\alias{Compare,Versions,character-method}
\alias{Compare,character,Versions-method}
\alias{updateObject,Versions-method}
\alias{show,Versions-method}
\alias{coerce,Versions,character-method}

\title{Class "Versions"}

\description{

  A class to record version number information. This class is used to
  report versions; to add version information to your own class, use
  \code{\link{Versioned-class}}.

}

\section{Methods}{

  The following are defined; package developers may write additional methods.
  \describe{
    \item{\code{new("Versions", ...)}}{Create a new \code{Versions-class} instance,
      perhaps with named version elements (the contents of
      \code{...}) added. Named elements of \code{versions} are
      character strings that can be coerced using
      \code{\link{package_version}}, or \code{package_version}
      instances, \code{Versions-class} objects.}
    \item{\code{object["id"]}}{Obtain version information \code{"id"} from \code{object}.}
    \item{\code{object["id"] <- value}}{Create or update version information \code{"id"} on instance \code{object}.}
    \item{\code{object[["id"]]}}{Obtain version information \code{"id"} from \code{object}. The result is a list of integers, corresponding to entries in the version string.}
    \item{\code{object[["id"]] <- value}}{Create or update version information \code{"id"} on instance \code{object}.}
    \item{\code{object$id}}{Obtain version information \code{"id"} from \code{object}.The result is a list of integers, corresponding to entries in the version string.}
    \item{\code{object$id <- value}}{Create or update version
      information \code{"id"} on instance \code{object}.}
    \item{\code{show(object)}}{Display version information.}
    \item{\code{updateObject(object)}}{Update \code{object} to the
      current \code{Versions-class} representation. Note that this does \emph{not}
      update another class that uses \code{Versions-class} to track the
      class version.}
    \item{\code{as(object, "character")}}{Convert \code{object} to character representation, e.g., \code{1.0.0}}
    \item{\code{object1 < object2}}{Compare \code{object1} and \code{object2} using version class information. Symbols in addition to \code{<} are admissible; see \code{?Ops}}
  }
}

\author{Biocore}

\seealso{
  \code{\link{classVersion}}
  \code{\link{isCurrent}}
  \code{\link{isVersioned}}
}

\examples{

obj <- new("Versions", A="1.0.0")
obj

obj["A"] <- "1.0.1"
obj
obj["B"] <- "2.0"
obj

obj1 <- obj
obj1["B"] <- "2.0.1"

obj1 == obj
obj1["B"] > "2.0.0"
obj["B"] == "2.0" # TRUE!

}

\keyword{classes}

\name{selectSome}
\alias{selectSome}
\title{Extract elements of a vector for concise rendering}
\description{
Extract the first and last several elements of a vector for concise
rendering; insert ellipses to indicate elided elements. This function
is primarily meant for developer rather than end-user use.
}
\usage{
selectSome(obj, maxToShow=5)
}
\arguments{
  \item{obj}{A vector.}
  \item{maxToShow}{The number of elements (including "...") to render.}
}
\details{
This function can be used in 'show' methods to give users exemplars of
the tokens used in a vector.  For example, an
\code{\link{ExpressionSet}} built from a yeast experiment might have
features enumerated using systematic gene names (e.g., YPR181C) or
standard gene names (e.g., SEC23).  The \code{\link{show}} method for
\code{\link{ExpressionSet}} uses \code{selectSome} to alert the user to
the tokens used, and thereby to indicate what vocabulary must be
understood to work with the feature names.
}

\value{
A string vector with at most \code{maxToShow} plus 1 elements,
where an ellipsis ("...") is included to indicate incompleteness
of the excerpt.
}
\author{Martin Morgan <mtmorgan@fhcrc.org>}
\examples{
selectSome(1:20)
}
\keyword{utilities}

\name{notes}
\alias{notes}
\alias{notes<-}

\title{Retrieve and set eSet notes.}
\description{
  These generic functions access notes (unstructured descriptive data)
  associated \code{\link{eSet-class}}.

  \code{notes(<ExpressionSet>) <- <character>} is unusual, in that the
  character vector is appended to the list of notes; use
  \code{notes(<ExpressionSet>) <- <list>} to entirely replace the list.
}
\usage{
notes(object)
notes(object) <- value
}
\arguments{
  \item{object}{Object, possibly derived from class \code{eSet-class}.}
  \item{value}{Character vector containing unstructured information describing the experinement.}
}
\value{
  \code{notes} returns a list.
}
\author{Biocore}

\seealso{\code{\link{ExpressionSet-class}}, \code{\link{SnpSet-class}}}

\keyword{manip}

\name{MIAME}
\docType{class}
\alias{class:MIAME}
\alias{MIAME}

\alias{MIAME-class}
\alias{abstract,MIAME-method}
\alias{combine,MIAME,MIAME-method}
\alias{expinfo,MIAME-method}
\alias{hybridizations,MIAME-method}
\alias{normControls,MIAME-method}
\alias{otherInfo,MIAME-method}
\alias{preproc}
\alias{preproc,MIAME-method}
\alias{preproc<-,MIAME-method}
\alias{preproc<-}
\alias{notes,MIAME-method}
\alias{notes<-,MIAME,list-method}
\alias{notes<-,MIAME,character-method}
\alias{pubMedIds,MIAME-method}
\alias{pubMedIds<-,MIAME,ANY-method}
\alias{samples,MIAME-method}
\alias{show,MIAME-method}
\alias{updateObject,MIAME-method}
\alias{isCurrent,MIAME,missing-method}
\alias{samples}

\concept{abstract}
\concept{expinfo}
\concept{hybridizations}
\concept{normControls}
\concept{preproc}

\title{
   Class for Storing Microarray Experiment Information
}

\description{
   Class \code{MIAME} covers MIAME entries that are not covered by other classes
in Bioconductor. Namely, experimental design, samples, hybridizations,
normalization controls, and pre-processing information. The \code{MIAME} class 
is derived from \code{\link{MIAxE}}.}

\section{Slots}{
   \describe{
      \item{\code{name}:}{Object of class \code{character} containing the experimenter name}
      \item{\code{lab}:}{Object of class \code{character} containing the laboratory where the experiment was conducted}
      \item{\code{contact}:}{Object of class \code{character} containing contact information for lab and/or experimenter}
      \item{\code{title}:}{Object of class \code{character} containing a single-sentence experiment title }
      \item{\code{abstract}:}{Object of class \code{character} containing an abstract describing the experiment}
      \item{\code{url}:}{Object of class \code{character} containing a URL for the experiment}
      \item{\code{samples}:}{Object of class \code{list} containing information about the samples}
      \item{\code{hybridizations}:}{Object of class \code{list} containing information about the hybridizations}
      \item{\code{normControls}:}{Object of class \code{list} containing information about the controls such as house keeping genes}
      \item{\code{preprocessing}:}{Object of class \code{list} containing information about the pre-processing steps used on the raw data from this experiment}
      \item{\code{pubMedIds}:}{Object of class \code{character} listing strings of PubMed identifiers of papers relevant to the dataset}
      \item{\code{other}:}{Object of class \code{list} containing other information for which none of the above slots does not applies}
  }
}

\section{Methods}{
   Constructor methods:
   \describe{
      \item{\code{MIAME()}:}{
      \code{MIAME(name = "", lab = "", contact = "",
                  title = "", abstract = "", url = "",
                  pubMedIds = "" , samples = "",
                  hybridizations = list(), normControls = list(),
                  preprocessing = list(), other = list())}:
      Creates a new \code{MIAME} object with slots as defined above.}
    }

   Class-specific methods:
   \describe{
      \item{\code{abstract(MIAME)}:}{An accessor function for \code{abstract}.}
      \item{\code{combine(MIAME,MIAME)}:}{Combine two objects of \code{MIAME-class}, issuing warnings when ambiguities encountered.}
      \item{\code{expinfo(MIAME)}:}{An accessor function for \code{name}, \code{lab}, \code{contact}, \code{title}, and \code{url}.}
      \item{\code{hybridizations(MIAME)}:}{An accessor function for \code{hybridizations}.}
      \item{\code{normControls(MIAME)}:}{An accessor function for \code{normControls}.}
      \item{\code{notes(MIAME), notes(MIAME) <- value}:}{Accessor functions for \code{other}. \code{notes(MIAME) <- character}
           \emph{appends} character to notes; use \code{notes(MIAME) <- list} to replace the notes entirely.}
      \item{\code{otherInfo(MIAME)}:}{An accessor function for \code{other}.}
      \item{\code{preproc(MIAME)}:}{An accessor function for \code{preprocessing}.}
      \item{\code{pubMedIds(MIAME), pubMedIds(MIAME) <- value}:}{Accessor function for \code{pubMedIds}.}
      \item{\code{samples(MIAME)}:}{An accessor function for \code{samples}.}
   }
   Standard generic methods:
   \describe{
     \item{\code{updateObject(object, \dots, verbose=FALSE)}}{Update instance to current version, if necessary. See \code{\link{updateObject}}}
     \item{\code{isCurrent(object)}}{Determine whether version of object is current. See \code{\link{isCurrent}}}
     \item{\code{isVersioned(object)}}{Determine whether object contains a 'version' string describing its structure . See \code{\link{isVersioned}}}
      \item{\code{show(MIAME)}:}{Renders information about the MIAME information }
   }
}

\references{
   \url{http://www.mged.org/Workgroups/MIAME/miame_1.1.html}
}

\seealso{
   \code{\link{class:characterORMIAME}}, \code{\link{read.MIAME}}
}

\author{
   Rafael A. Irizarry
}

\keyword{classes}

\name{dumpPackTxt}
\alias{dumpPackTxt}

\title{Dump Textual Description of a Package  }

\description{
   Dump textual description of a package
}
\usage{
dumpPackTxt(package)
}
\arguments{
  \item{package}{Character string naming an R package}
}
\details{
dumps DESCRIPTION and INDEX files from package sources
}
\value{
   \code{stdout} output
}
\author{<stvjc@channing.harvard.edu>}

\note{ Other approaches using formatDL are feasible }

\examples{
dumpPackTxt("stats")
}
\keyword{ models }

\name{aggregator}
\docType{class}
\alias{class:aggregator}
\alias{aggregator}
\alias{aggregator-class}
\alias{initialize,aggregator-method}

\alias{aggenv,aggregator-method}
\alias{aggfun,aggregator-method}
\alias{initfun,aggregator-method}

\concept{aggenv}
\concept{aggfun}
\concept{initfun}

\title{A Simple Class for Aggregators }
\description{ A class of objects designed to help aggregate
   calculations over an iterative computation. The aggregator consists
   of three objects. An environment to hold the values.
   A function that sets up an initial value the first time an object is
   seen. An aggregate function that increments the value of an object
   seen previously. }
\section{Creating Objects}{
   \code{new('aggregator', aggenv  = [environment], initfun = [function], aggfun  = [function])}
}
\section{Slots}{
   \describe{
      \item{\code{aggenv}:}{Object of class 'environment', holds the values between iterations}
      \item{\code{initfun}:}{Object of class 'function' specifies how to initialize the value for a name the first time it is encountered}
      \item{\code{aggfun}:}{Object of class 'function' used to increment (or perform any other function) on a name}
   }
}
\section{Methods}{
   \describe{
      \item{\code{aggenv(aggregator)}:}{Used to access the environment of the aggregator}
      \item{\code{aggfun(aggregator)}:}{Used to access the function that aggregates}
      \item{\code{initfun(aggregator)}:}{Used to access the initializer function}
  }
}
\seealso{
   \code{\link{Aggregate}}
}
\details{
  This class is used to help aggregate different values over function
  calls. A very simple example is to use leave one out cross-validation
  for prediction. At each stage we first perform feature selection and
  then cross-validate. To keep track of how often each feature is
  selected we can use an aggregator. At the end of the cross-validation
  we can extract the names of the features chosen from \code{aggenv}.
  }
\keyword{methods}
\keyword{classes}

\name{MIAxE}
\docType{class}
\alias{MIAxE}
\alias{class:MIAxE}
\alias{MIAxE-class}
\alias{show,MIAxE-method}

\title{MIAxE objects}

\description{
  The \code{MIAxE} virtual class is a general container for storing
  experiment metadata. Information such as experimental design, samples,
  normalization methods and pre-processing information can be stored in 
  these objets. 

  The \code{MIAxE} class is virtual and \code{MIAxE} 
  objects cannot be instantiated directly. The following classes
  derive directly from the \code{MIAxE} class: MIAME. 
}

\section{Slots}{
   Introduced in \code{MIAxE}:
   \describe{
      \item{\code{.__classVersion__}:}{A \code{Versions} object describing
    the \code{MIAxE} version number. Intended for developer use.}
  }
}


\section{Methods}{
   Standard generic methods:
   \describe{
      \item{\code{show(object)}}{Informatively display object contents.}
   }
}


\author{Biocore team}

\seealso{
  Related  classes
  \code{\link{MIAME-class}}, \code{\link{ExpressionSet-class}}.
  Derived classes
  \code{\link{MIAME-class}}.
}

\examples{

# Create a new class
MyData <- setClass("MyData", contains="MIAxE")
MyData()

# MIAxE objects cannot be instantiated directly
try(new("MIAxE"))

}

\keyword{classes}

\name{NChannelSet-class}
\docType{class}
\alias{NChannelSet-class}
\alias{NChannelSet}
\alias{class.NChannelSet}
\alias{assayData<-,NChannelSet,environment-method}
\alias{assayData<-,NChannelSet,list-method}
\alias{channelNames,NChannelSet-method}
\alias{channelNames<-,NChannelSet,character-method}
\alias{channelNames<-,NChannelSet,list-method}
\alias{channel,NChannelSet,character-method}
\alias{sampleNames,NChannelSet-method}
\alias{sampleNames<-,NChannelSet,list-method}
\alias{selectChannels,NChannelSet,character-method}
\alias{initialize,NChannelSet-method}

\title{Class to contain data from multiple channel array technologies}

\description{
  Container for high-throughput assays and experimental meta-data. Data
  are from experiments where a single \sQuote{chip} contains several
  (more than 1) different \sQuote{channels}. All channels on a chip have
  the same set of\sQuote{features}. An experiment consists of a
  collection of several N-channel chips; each chip is a \sQuote{sample}.

  An \code{NChannelSet} provides a way to coordinate assay data
  (expression values) with phenotype information and references to chip
  annotation data; it extends the \code{\link{eSet}} class.

  An \code{NChannelSet} allows channels to be extracted (using the
  \code{channels} method, mentioned below), and subsets of features or
  samples to be selected (using \code{[<features>,
    <samples>]}). Selection and subsetting occur so that relevant
  phenotypic data is maintained by the selection or subset.}

\section{Objects from the Class}{
  Objects can be created by calls of the form \code{NChannelSet(
    assayData, phenoData, ...)}. See the examples below.
}

\section{Slots}{
  \describe{
    \item{\code{assayData}:}{
      Object of class \code{\link{AssayData}}, usually
      an environment containing matrices of identical size. Each matrix
      represents a single channel. Columns in each matrix correspond to
      samples, rows to features. Once created, \code{NChannelSet} manages
      coordination of samples and channels.
    }

    \item{\code{phenoData}:}{
      Object of class \code{\link{AnnotatedDataFrame}}.

      The \code{data} component of the \code{AnnotatedDataFrame} is
      \code{data.frame} with number of rows equal to the number of
      samples. Columns of the \code{data} component correspond to measured
      covariates.

      The \code{varMetadata} component consists of mandatory columns
      \code{labelDescription} (providing a textual description of each column
      label in the \code{data} component) and \code{channel}. The \code{channel}
      of \code{varMetadata} is a \code{factor}, with levels equal to the names
      of the \code{assayData} channels, plus the special symbol
      \code{_ALL_}. The \code{channel} column is used to indicate which
      channel(s) the corresponding column in the \code{data} component
      of \code{AnnotatedDataFrame} correspond;  the \code{_ALL_} symbol
      indicates that the \code{data} column is applicable to all
      channels. \code{varMetadata} may contain additional columns with
      arbitrary information.

      Once created, \code{NChannelSet} coordinates selection and subsetting
      of channels in \code{phenoData}.
    }

    \item{\code{featureData}:}{
      Object of class \code{\link{AnnotatedDataFrame}}, used to contain
      feature data that is unique to this experiment; feature-level
      descriptions common to a particular chip are usually referenced
      through the \code{annotation} slot.
    }
    \item{\code{experimentData}:}{
      Object of class \code{\link{MIAME}} containing descriptions of the
      experiment.
    }

    \item{\code{annotation}:}{
      Object of class \code{"character"}. Usually a length-1 character
      string identifying the chip technology used during the
      experiment. The annotation string is used to retrieve information 
      about features, e.g., using the \code{annotation} package.}

    \item{\code{protocolData}:}{
      Object of class \code{"character"}. A character vector
      identifying the dates the samples were scanned during the
      experiment.}

    \item{\code{.__classVersion__}:}{
      Object of class \code{\link{Versions}}, containing
      automatically created information about the class definition
      Biobase package version, and other information about the user
      system at the time the instance was created. See
      \code{\link{classVersion}} and \code{\link{updateObject}} for
      examples of use.
    }
  }
}

\section{Extends}{
  Class \code{"\linkS4class{eSet}"}, directly.
  Class \code{"\linkS4class{VersionedBiobase}"}, by class "eSet", distance 2.
  Class \code{"\linkS4class{Versioned}"}, by class "eSet", distance 3.
}

\section{Methods}{
  Methods with class-specific functionality:
  \describe{
    \item{\code{channel(object, name, ...)}}{
      \code{signature(object="NChannelSet", name="character")}.
      Return an \code{ExperessionSet} created from the channel and
      corresponding phenotype of argument \code{name}. \code{name} must
      have length 1. Arguments \code{...} are rarely used, but are
      passed to the \code{ExpressionSet} constructor, for instance
      to influence \code{storage.mode}.
    }

    \item{\code{channelNames(object)}, \code{channelNames(object) <- value}}{
      \code{signature(object = "NChannelSet")}.
      Obtain, reorder, or rename channels contained in
      \code{object}. See \code{\link{channelNames}}.
    }

    \item{\code{selectChannels(object, names, ...}}{
      \code{signature(object = "NChannelSet", names = "character")}.
      Create a new \code{NChannelSet} from \code{object}, containing
      only channels in \code{names}. The \code{...} is not used by this
      method.
    }
    \item{\code{object[features, samples]}}{
      \code{signature(object = "NChannelSet",
        features = "ANY", samples = "ANY")}.
      Create a new \code{NChannelSet} from \code{object}, containing
      only elements matching \code{features} and \code{samples}; either
      index may be missing, or a character, numeric, or logical vector.
    }
    \item{\code{sampleNames(object) <- value}}{
      \code{signature(object = "NChannelSet", value = "list")} assign
      each (named) element of \code{value} to the \code{sampleNames} of
      the correspondingly named elements of \code{assayData} in
      \code{object}.
    }
      
  }

  Methods with functionality derived from \code{\link{eSet}}:
  \code{annotation}, \code{annotation<-}, \code{assayData},
  \code{assayData<-}, \code{classVersion}, \code{classVersion<-},
  \code{dim}, \code{dims}, \code{experimentData}, \code{experimentData<-},
  \code{featureData}, \code{featureData<-}, \code{phenoData},
  \code{phenoData<-}, \code{protocolData}, \code{protocolData<-},
  \code{pubMedIds}, \code{pubMedIds<-}, \code{sampleNames},
  \code{sampleNames<-}, \code{storageMode}, \code{storageMode<-},
  \code{varMetadata}, \code{varMetadata<-}, \code{isCurrent},
  \code{isVersioned}, \code{updateObject}.

  Additional methods: \code{coerce} (\sQuote{as}, to convert between
  objects, if possible), \code{initialize} (used internally for
  creating objects), \code{show} (invoked automatically when the
  object is displayed to the screen)
}

\author{Martin Morgan <mtmorgan@fhcrc.org>}

\seealso{
  \code{\linkS4class{eSet}}, \code{\linkS4class{ExpressionSet}}. 
}
\examples{
## An empty NChannelSet
obj <- NChannelSet()

## An NChannelSet with two channels (R, G) and no phenotypic data
obj <- NChannelSet(R=matrix(0,10,5), G=matrix(0,10,5))

## An NChannelSet with two channels and channel-specific phenoData
R <- matrix(0, 10, 3, dimnames=list(NULL, LETTERS[1:3]))
G <- matrix(1, 10, 3, dimnames=list(NULL, LETTERS[1:3]))
assayData <- assayDataNew(R=R, G=G)
data <- data.frame(ChannelRData=numeric(ncol(R)),
                   ChannelGData=numeric(ncol(R)),
                   ChannelRAndG=numeric(ncol(R)))
varMetadata <- data.frame(labelDescription=c(
                            "R-specific phenoData",
                            "G-specific phenoData",
                            "Both channel phenoData"),
                          channel=factor(c("R", "G", "_ALL_")))
phenoData <- AnnotatedDataFrame(data=data, varMetadata=varMetadata)
obj <- NChannelSet(assayData=assayData, phenoData=phenoData)
obj

## G channel as NChannelSet
selectChannels(obj, "G")

## G channel as ExpressionSet
channel(obj, "G")

## Samples "A" and "C"
obj[,c("A", "C")]
}
\keyword{classes}

\name{copyEnv}
\alias{copyEnv}


\title{List-Environment interactions}

\description{
  These functions can be used to make copies of environments, or to
  get/assign all of the objects inside of an environment.
}

\usage{
copyEnv(oldEnv, newEnv, all.names=FALSE)
}

\arguments{
  \item{oldEnv}{An environment to copy from}
  \item{newEnv}{An environment to copy to.  If missing, a new environment
  with the same parent environment as oldEnv.}
  \item{all.names}{Whether to retrieve objects with names that start
    with a dot.}
}

\details{
  \code{copyEnv}: This function will make a copy of the contents from
  \code{oldEnv} and place them into \code{newEnv}.
}

\author{Jeff Gentry and R. Gentleman}

\seealso{\code{\link{environment}}, \code{\link{as.list}}}

\examples{
   z <- new.env(hash=TRUE, parent=emptyenv(), size=29L)
   multiassign(c("a","b","c"), c(1,2,3), z)

   a <- copyEnv(z)
   ls(a)
}
\keyword{utilities}

\name{note}
\alias{note}
\title{Informational Messages}
\description{
  Generates  an informational message that corresponds to its
  argument(s).  Similar to warning() except prefaced by "Note:"
  instead of "Warning message:".
}
\usage{
note(...)
}
\arguments{
  \item{\dots}{character vectors (which are pasted together) or NULL}
}
\details{
  This function essentially cat()'s the created string to the screen.
  It is intended for messages to the user that are deemed to be
  'informational', as opposed to warnings, etc.
}
\author{Jeff Gentry}
\seealso{\code{\link{warning}},\code{\link{stop}}}
\examples{
   note("This is an example of a note")
}
\keyword{utilities}

\name{selectChannels}
\alias{selectChannels}

\title{Create a new NChannelSet instance by selecting specific channels}
\description{
  This generic function extracts specific elements from an object,
  returning a instance of that object.
}
\usage{
selectChannels(object, names, ...)
}
\arguments{
  \item{object}{An S4 object, typically derived from class
    \code{\link{eSet}}}
  \item{names}{Character vector of named channels.}
  \item{...}{Additional arguments.}
}
\value{
  Instance of class \code{object}.
}
\author{Biocore}

\examples{
obj <- NChannelSet(R=matrix(runif(100), 20, 5), G=matrix(runif(100), 20, 5))

## G channel as NChannelSet
selectChannels(obj, "G")
  }
\keyword{manip}

\name{validMsg}
\alias{validMsg}
\title{Conditionally append result to validity message}
\description{
This function facilitates constructing messages during S4 class
validation, and is meant for developer rather than end-user use.
}
\usage{
validMsg(msg, result)
}
\arguments{
  \item{msg}{A character vector or NULL.}
  \item{result}{Any vector.}
}
\details{
This function appends \code{result} to \code{msg}, but only if
\code{result} is a character vector.
}
\author{Martin Morgan <mtmorgan@fhcrc.org>}

\examples{
msg <- NULL
validMsg(msg, FALSE) # still NULL
msg <- validMsg(msg, "one")
validMsg(msg, "two")
}
\keyword{utilities}

\name{classVersion}
\alias{classVersion}
\alias{classVersion<-}

\alias{classVersion,ANY-method}
\alias{classVersion,character-method}

\title{Retrieve information about versioned classes}
\description{

  These generic functions return version information for classes
  derived from \code{\link{Versioned-class}}, or
  \code{\link{VersionsNull-class}} for unversioned objects. The
  version information is an object of \code{\link{Versions-class}}.

  By default, \code{classVersion} has the following behaviors:
  \describe{
    \item{\code{classVersion(Versioned-instance)}}{Returns a \code{Versions-class} object obtained from the object.}
    \item{\code{classVersion{"class"}}}{Consults the definition of \code{class} and return the current version information, if available.}
    \item{\code{classVersion(ANY)}}{Return a \code{\link{VersionsNull-class}} object to indicate no version information available.}
  }

  By default, the \code{classVersion<-} method has the following behavior:
  \describe{
    \item{\code{classVersion(Versioned-instance)["id"] <- value}}{Assign (update or add) \code{value} to \code{Versions-instance}. \code{value} is coerced to a valid version description. see \code{\link{Versions-class}} for additional access methods.}
  }

}
\usage{
classVersion(object)
classVersion(object) <- value
}
\arguments{
  \item{object}{Object whose version is to be determined, as described above.}
  \item{value}{\code{Version-class} object to assign to object of \code{Versioned-class} object.}
}
\value{
  \code{classVersion} returns an instance of \code{\link{Versions-class}}
}

\author{Biocore team}

\seealso{\code{\link{Versions-class}}}

\examples{
obj <- new("VersionedBiobase")

classVersion(obj)
classVersion(obj)["Biobase"]
classVersion(1:10) # no version
classVersion("ExpressionSet") # consult ExpressionSet prototype

classVersion(obj)["MyVersion"] <- "1.0.0"
classVersion(obj)
}

\keyword{manip}

\name{reverseSplit}
\alias{reverseSplit}
\title{ A function to reverse the role of names and values in a list. }
\description{
Given a list with names \code{x} and values in a set \code{y} this function
returns a list with names in \code{y} and values in \code{x}.
}
\usage{
reverseSplit(inList)
}
\arguments{
  \item{inList}{ A named list with values that are vectors. }
}
\details{
 First the list is unrolled to provide a two long vectors, names are repeated,
 once for each of their values. Then the names are \code{split} by the values.
 
 This turns out to be useful for inverting mappings between one set of 
identifiers and an other.
}
\value{
 A list with length equal to the number of distinct values in the input list
and values from the names of the input list.
}
\author{ R. Gentleman }

\seealso{ \code{\link{split}}}
\examples{
 l1 = list(a=1:4, b=c(2,3), d=c(4,5))
 reverseSplit(l1)

}
\keyword{ manip } 

\name{exprs}
\alias{exprs}
\alias{exprs<-}
\alias{se.exprs}
\alias{se.exprs<-}

\title{Retrieve expression data from eSets.}
\description{
  These generic functions access the expression and error measurements
  of assay data stored in an object derived from the \code{\link{eSet-class}}.
}
\usage{
exprs(object)
exprs(object) <- value
se.exprs(object)
se.exprs(object) <- value
}
\arguments{
  \item{object}{Object derived from class \code{eSet}.}
  \item{value}{Matrix with rows representing features and columns samples.}
}
\value{
  \code{exprs} returns a (usually large!) matrix of expression values;
  \code{se.exprs} returns the corresponding matrix of standard errors,
  when available.
}
\author{Biocore}

\seealso{\code{\link{eSet-class}}, \code{\link{ExpressionSet-class}}, \code{\link{SnpSet-class}}}

\keyword{manip}

\name{featureData}
\alias{featureData}
\alias{featureData<-}
\alias{fData}
\alias{fData<-}
\alias{fvarLabels}
\alias{fvarLabels<-}
\alias{fvarMetadata}
\alias{fvarMetadata<-}

\title{Retrieve information on features recorded in eSet-derived
  classes.}
\description{
  These generic functions access feature data (experiment specific
  information about features) and feature meta-data (e.g., descriptions
  of feature covariates).  
}
\usage{
featureData(object)
featureData(object) <- value
fData(object)
fData(object) <- value
fvarLabels(object)
fvarLabels(object) <- value
fvarMetadata(object)
fvarMetadata(object) <- value
}
\arguments{
  \item{object}{Object, possibly derived from \code{\link{eSet-class}}
    or \code{\link{AnnotatedDataFrame-class}}.}
  \item{value}{Value to be assigned to corresponding object.}
}
\value{
  \code{featureData} returns an object containing information on both
  variable values and variable meta-data.  \code{fvarLabels} returns a
  character vector of measured variable names. \code{fData} returns a data
  frame with features as rows, variables as columns. \code{fvarMetadata}
  returns a data frame with variable names as rows, description tags
  (e.g., unit of measurement) as columns.
}

\author{Biocore}

\seealso{
  \code{\linkS4class{eSet}},
  \code{\linkS4class{ExpressionSet}}
}
\keyword{manip}

\name{channelNames}
\alias{channelNames}
\alias{channelNames<-}

\title{Retrieve and set channel names from object}
\description{
  This generic function reports or updates the channels in an object.
}
\usage{
channelNames(object, ...)
channelNames(object, ...) <- value
}
\arguments{
  \item{object}{An S4 object, typically derived from class
    \code{\link{eSet}}}
  \item{value}{Replacement value, either a character vector (to
    re-order existing channel names or a named character vector or list
    (to change channel names from the vector elements to the
    corresponding names).}
  \item{...}{Additional argument, not currently used.}
}

\details{

  \code{channelNames} returns the names of the channels in a defined
  order. Change the order using the replacement method with a permuation
  of the channel names as \code{value}. Rename channels using the
  replacement method with a named list, where the vector elements are a
  permutation of the current channels, with corresponding names the new
  identifier for the channel.
  
}

\value{
  \code{character}.
}
\author{Biocore}

\examples{
## channelNames default to alphabetical order of channels
obj <- NChannelSet(
           R=matrix(runif(100), 20, 5),
           G=matrix(-runif(100), 20, 5))
channelNames(obj)
channelNames(obj) <- c(Gn="G", Rd="R")   ## rename
channelNames(obj)
channelNames(obj) <- c("Rd", "Gn")       ## reorder
channelNames(obj)
all(assayData(obj)[["Gn"]] <= 0)
all(assayData(obj)[["Rd"]] >= 0)
}
\keyword{manip}

\name{updateOldESet}
\alias{updateOldESet}

\title{Update previously created eSet object to current eSet structure}

\description{

  This function updates \code{eSet} objects created in previous versions
  of Biobase to the current class structure. Warnings indicate when
  coercions change how data in the \code{from} object are
  altered. If the \code{from} object was not a valid object of the
  original eSet class, then \code{updateOldESet} may fail.
}
\usage{
updateOldESet(from, toClass, ...)
}
\arguments{
  \item{from}{Object created using a previous version of the eSet class.}
  \item{toClass}{Character string identifying new class, e.g.,
    \code{"ExpressionSet"}}
  \item{...}{Additional arguments passed to the initialization method
    for class \code{toClass}}
}
\value{
  Valid object of class \code{toClass}.
}
\author{Biocore}

\seealso{\code{\link{eSet-class}}, \code{\link{ExpressionSet-class}}, \code{\link{SnpSet-class}}}

\examples{
\dontrun{
updateOldESet(oldESet, "ExpressionSet")
}}

\keyword{manip}

\name{getPkgVigs}
\alias{getPkgVigs}

\title{List Vignette Files for a Package}

\description{
This function will return a listing of all vignettes stored in a package's \code{doc} directory.
}
\usage{
getPkgVigs(package = NULL)
}
\arguments{
  \item{package}{A character vector of packages to search or
    \code{NULL}. The latter is for all attached packages (in \code{\link{search}()}).}
}
\value{
A data.frame with columns \code{package}, \code{filename}, \code{title}.
}
\author{Jeff Gentry, modifications by Wolfgang Huber.}
\seealso{\code{\link{openVignette}}}
\examples{
 z <- getPkgVigs()
 z # and look at them
}
\keyword{utilities}

\name{read.MIAME}
\alias{read.MIAME}

\title{
   Read MIAME Information into an Instance of Class 'MIAME'
}

\description{
   Reads MIAME information from a file or using a widget.
}

\usage{
read.MIAME(filename = NULL, widget = getOption("BioC")$Base$use.widgets, ...)
}

\arguments{
   \item{filename}{Filename from which to read MIAME information.}
   \item{widget}{Logical. If \code{TRUE} and a filename is not given, a widget is used to enter information.}
   \item{\dots}{Further arguments to \code{scan}.}
}

\details{
  Notice that the \code{\link{MIAME}}
  class tries to cover the MIAME entries that are not covered by other
  classes in Bioconductor. Namely, experimental design, samples,
  hybridizations, normalization controls, and pre-processing
  information.

  The function \code{\link{scan}} is used to read.
  The file must be a flat file with the
  different entries for the instance
  of MIAME class separated by carriage returns. The order should be: name, lab,
  contact, title, abstract, and url.

  Alternatively a widget can be used.
}
\value{An object of class \code{\link{MIAME}}.}

\author{Rafael Irizarry <rafa@jhu.edu>}

\seealso{\code{\link{MIAME}},\code{\link[tkWidgets]{tkMIAME}} }

\examples{
miame <- read.MIAME(widget=FALSE) ##creates an empty instance
show(miame)
}
\keyword{file}

\name{Internals}
\alias{aggenv}
\alias{aggfun}
\alias{content}
\alias{expinfo}
\alias{hybridizations}
\alias{initfun}
\alias{locked}
\alias{normControls}
\alias{otherInfo}


%classes
\alias{data.frameOrNULL-class}
\alias{listOrEnv-class}

%methods
\alias{contents,environment-method}

\title{Internals}
\description{
   Use help.search("your keyword", package="Biobase").
}
\keyword{internal}

\name{lcSuffix}

\alias{lcSuffix}
\alias{lcPrefix}
\alias{lcPrefixC}

\title{Compute the longest common prefix or suffix of a string}

\description{
These functions find the longest common prefix or suffix among the
strings in a character vector.
}

\usage{
lcPrefix(x, ignore.case=FALSE)
lcPrefixC(x, ignore.case=FALSE)
lcSuffix(x, ignore.case=FALSE)
}
\arguments{
  \item{x}{ a character vector. }
  \item{ignore.case}{ A logical value indicating whether or
    not to ignore the case in making comparisons. }
}
\details{
Computing the longest common suffix is helpful for truncating names of
objects, like microarrays, that often have a common suffix, such as .CEL.

There are some potential problems with the approach used if
multibyte character encodings are being used.

\code{lcPrefixC} is a faster implementation in C.  It only handles
ascii characters.

}
\value{
The common prefix or suffix.
}
\author{ R. Gentleman }

\seealso{ \code{\link{nchar}}, \code{\link{nchar}}}
\examples{
s1 <- c("ABC.CEL", "DEF.CEL")
lcSuffix(s1)

s2 <- c("ABC.123", "ABC.456")
lcPrefix(s2)


CHK <- stopifnot

CHK(".CEL" == lcSuffix(s1))
CHK("bc" == lcSuffix(c("abc", "333abc", "bc")))
CHK("c" == lcSuffix(c("c", "abc", "xxxc")))
CHK("" == lcSuffix(c("c", "abc", "xxx")))

CHK("ABC." == lcPrefix(s2))
CHK("ab" == lcPrefix(c("abcd", "abcd123", "ab", "abc", "abc333333")))
CHK("a" == lcPrefix(c("abcd", "abcd123", "ax")))
CHK("a" == lcPrefix(c("a", "abcd123", "ax")))
CHK("" == lcPrefix(c("a", "abc", "xxx")))

CHK("ab" == lcPrefixC(c("abcd", "abcd123", "ab", "abc", "abc333333")))
CHK("a" == lcPrefixC(c("abcd", "abcd123", "ax")))
CHK("a" == lcPrefixC(c("a", "abcd123", "ax")))
CHK("" == lcPrefixC(c("a", "abc", "xxx")))

}
\keyword{ manip }

\name{protocolData}
\alias{protocolData}
\alias{protocolData<-}
\alias{protocolData<-,eSet,AnnotatedDataFrame-method}

\title{Protocol Metadata}
\description{
This generic function handles methods for adding and retrieving
protocol metadata for the samples in eSets.
}
\usage{
protocolData(object)
protocolData(object) <- value
}
\arguments{
  \item{object}{Object derived from class eSet}
  \item{value}{Object of class AnnotatedDataFrame}
}
\value{
  \code{protocolData(object)} returns an AnnotatedDataFrame containing the
  protocol metadata for the samples.
}
\author{Biocore}

\seealso{\code{phenoData}, \code{\link{AnnotatedDataFrame-class}},
  \code{\link{eSet-class}}, \code{\link{ExpressionSet-class}},
  \code{\link{SnpSet-class}}}

\keyword{manip}

\name{rowMedians}
\alias{rowMedians}
\alias{rowMedians,matrix-method}
\alias{rowMedians,ExpressionSet-method}

\title{Calculates the median for each row in a matrix}

\description{
  Calculates the median for each row in a matrix.
}

\usage{rowMedians(x, na.rm=FALSE, ...)}

\arguments{
 \item{x}{A \code{\link[base]{numeric}} NxK \code{\link[base]{matrix}}.}
 \item{na.rm}{If \code{\link[base:logical]{TRUE}},
   \code{\link[base]{NA}}s are excluded first, otherwise not.}
 \item{...}{Not use.}
}

\value{
  Returns a \code{\link[base]{numeric}} \code{\link[base]{vector}} of
  length N.
}

\section{Missing values}{
  Missing values are excluded before calculating the medians.
}

\details{
  The implementation of \code{rowMedians()}
  is optimized for both speed and memory.
  To avoid coercing to \code{\link[base]{double}}s (and hence memory
  allocation), there is a special implementation for
  \code{\link[base]{integer}} matrices.  That is, if \code{x} is an
  \code{\link[base]{integer}} \code{\link[base]{matrix}}, then 
  \code{rowMedians(as.double(x))} would require three times the memory
  of \code{rowMedians(x)}, but all this is avoided.
}

\author{Henrik Bengtsson}

\seealso{
  See \code{rowMeans()} in \code{\link[base]{colSums}}().
}

\examples{
set.seed(1)
x <- rnorm(n=234*543)
x[sample(1:length(x), size=0.1*length(x))] <- NA
dim(x) <- c(234,543)
y1 <- rowMedians(x, na.rm=TRUE)
y2 <- apply(x, MARGIN=1, FUN=median, na.rm=TRUE)
stopifnot(all.equal(y1, y2))

x <- cbind(x1=3, x2=c(4:1, 2:5))
stopifnot(all.equal(rowMeans(x), rowMedians(x)))
}

\keyword{manip}

\name{package.version}
\alias{package.version}
\title{Report Version of a Package}
\description{
  Will report the version number of a requested installed package
}
\usage{
package.version(pkg, lib.loc = NULL)
}
\arguments{
  \item{pkg}{The name of the package}
  \item{lib.loc}{a character vector describing the location of R library trees
          to search through, or `NULL'.  The default value of `NULL'
          corresponds to all libraries currently known.}
}
\details{
  This function is a convenience wrapper around
  \code{package.description}, and will report simply the version number
  of the requested package.  If the package does not exist or if the
  DESCRIPTION file can not be read, then an error will be thrown.
}
\value{
  A character string reporting the version number.
}
\author{Jeff Gentry}
\seealso{\code{\link{package.description}}}
\examples{
  package.version("Biobase")
}
\keyword{utilities}

\name{openVignette}
\alias{openVignette}
\title{ Open a Vignette or Show Vignette Selection Menu}
\description{
  Using the data returned by \code{vignette} this function provides a
  simple easy to use interface for opening vignettes.
}
\usage{
openVignette(package=NULL)
}
\arguments{
  \item{package}{character string indicating the package to be used.}
 }
 \details{
   If \code{package} is NULL then all packages are scanned for
   vignettes.  The list of vignettes is presented to the user via the
   \code{menu} command.  The user may select one of the vignettes to be
   opened in a PDF viewer.
}
\value{
 No value is returned; this function is run entirely for the side effect
 of opening the pdf document in the PDF viewer.
}
\author{R. Gentleman }

\seealso{\code{\link{vignette}}, \code{\link{openPDF}},
  \code{\link{menu}}, \code{\link{getPkgVigs}}}

\examples{
  if( interactive() )
    openVignette("Biobase")
}
\keyword{ utilities }

\name{AnnotatedDataFrame}
\docType{class}
\alias{class:AnnotatedDataFrame}
\alias{AnnotatedDataFrame}
\alias{AnnotatedDataFrame-class}
\alias{AnnotatedDataFrame,missing,missing-method}
\alias{AnnotatedDataFrame,data.frame,missing-method}
\alias{AnnotatedDataFrame,data.frame,data.frame-method}

\alias{dimLabels}
\alias{dimLabels<-}

\alias{[,AnnotatedDataFrame-method}
\alias{[[<-,AnnotatedDataFrame-method}
\alias{[[,AnnotatedDataFrame-method}
\alias{$<-,AnnotatedDataFrame-method}
\alias{$,AnnotatedDataFrame-method}
\alias{coerce,AnnotatedDataFrame,data.frame-method}
\alias{combine,AnnotatedDataFrame,AnnotatedDataFrame-method}
\alias{initialize,AnnotatedDataFrame-method}
\alias{coerce,data.frame,AnnotatedDataFrame-method}
\alias{coerce,phenoData,AnnotatedDataFrame-method}
\alias{head.AnnotatedDataFrame}
\alias{tail.AnnotatedDataFrame}
\alias{dim,AnnotatedDataFrame-method}
\alias{dimnames,AnnotatedDataFrame-method}
\alias{dimnames<-,AnnotatedDataFrame-method}
\alias{dimLabels,AnnotatedDataFrame-method}
\alias{dimLabels<-,AnnotatedDataFrame,character-method}
\alias{ncol,AnnotatedDataFrame-method}
\alias{pData<-,AnnotatedDataFrame,data.frame-method}
\alias{pData,AnnotatedDataFrame-method}
\alias{varMetadata<-,AnnotatedDataFrame,data.frame-method}
\alias{varMetadata,AnnotatedDataFrame-method}
\alias{sampleNames<-,AnnotatedDataFrame,ANY-method}
\alias{sampleNames,AnnotatedDataFrame-method}
\alias{featureNames,AnnotatedDataFrame-method}
\alias{featureNames<-,AnnotatedDataFrame-method}
\alias{show,AnnotatedDataFrame-method}
\alias{updateObject,AnnotatedDataFrame-method}
\alias{varLabels<-,AnnotatedDataFrame-method}
\alias{varLabels,AnnotatedDataFrame-method}

\title{
  Class Containing Measured Variables and Their Meta-Data Description.
}

\description{
  An \code{AnnotatedDataFrame} consists of two parts. There is a collection
  of samples and the values of variables measured on those
  samples. There is also a description of each variable measured. The
  components of an \code{AnnotatedDataFrame} can be accessed with
  \code{\link{pData}} and \code{\link{varMetadata}}.
}
\section{Extends}{
   Versioned
}
\section{Creating Objects}{

  \code{AnnotatedDataFrame(data, varMetadata, dimLabels=c("rowNames", "columnNames"), ...)}

  \code{AnnotatedDataFrame} instances are created using
  \code{AnnotatedDataFrame}. The function can take three arguments, \code{data} is a
  \code{data.frame} of the samples (rows) and measured variables
  (columns).  \code{varMetadata} is a \code{data.frame} with the number
  of rows equal to the number of columns of the \code{data} argument.
  \code{varMetadata} describes aspects of each measured
  variable. \code{dimLabels} provides aesthetic control for labeling rows
  and columns in the \code{show} method. \code{varMetadata} and
  \code{dimLabels} can be missing.

\code{as(data.frame, "AnnotatedDataFrame")} coerces a \code{data.frame} to an
\code{AnnotatedDataFrame}.

\code{\link{annotatedDataFrameFrom}} may be a convenient way to create
an \code{AnnotatedDataFrame} from \code{\link{AssayData-class}}.

}

\section{Slots}{
  Class-specific slots:
   \describe{
      \item{\code{data}:}{A \code{data.frame} containing samples (rows)
	and measured variables (columns).}
	  \item{\code{dimLabels}:}{A \code{character} vector of length 2 that
	provides labels for the rows and columns in the \code{show} method.}
      \item{\code{varMetadata}:}{A \code{data.frame} with number of rows
	equal number of columns in \code{data}, and at least one column,
	named \code{labelDescription}, containing a textual description
	of each variable.}
      \item{\code{.__classVersion__}:}{A \code{Versions} object describing
    the R and Biobase version numbers used to created the instance.
    Intended for developer use.}
  }
}
\section{Methods}{

  Class-specific methods.
  \describe{

    \item{\code{as(annotatedDataFrame, "data.frame")}}{Coerce objects of
      \code{AnnotatedDataFrame} to \code{data.frame}.}
    \item{\code{combine(<AnnotatedDataFrame>,
	<AnnotatedDataFrame>}:}{Bind data from one
      \code{AnnotatedDataFrame} to a second
      \code{AnnotatedDataFrame}, returning the result as an
      \code{AnnotatedDataFrame}. Row (sample) names in each argument
      must be unique. Variable names present in both arguments occupy a
      single column in the resulting \code{AnnotatedDataFrame}. Variable
      names unique to either argument create columns with values
      assigned for those samples where the variable is
      present. \code{varMetadata} in the returned
      \code{AnnotatedDataFrame} is updated to reflect the combination.}
    \item{\code{pData(<AnnotatedDataFrame>)},
      \code{pData(<AnnotatedDataFrame>)<-<data.frame>}:}{Set and
      retrieve the data (samples and variables) in the
      \code{AnnotatedDataFrame}}
    \item{\code{varMetadata(<AnnotatedDataFrame>)},
      \code{varMetadata(<AnnotatedDataFrame>)<-<data.frame>}:}{Set and
      retrieve the meta-data (variables and their descriptions) in the
      \code{AnnotatedDataFrame}}
    \item{\code{featureNames(<AnnotatedDataFrame>)},
	\code{featureNames(<AnnotatedDataFrame>)<-<ANY>}:}{Set and
	  retrieve the feature names in \code{AnnotatedDataFrame}; a
	  synonym for \code{sampleNames}.}
    \item{\code{sampleNames(<AnnotatedDataFrame>)},
      \code{sampleNames(<AnnotatedDataFrame>)<-<ANY>}:}{Set and
      retrieve the sample names in \code{AnnotatedDataFrame}}
    \item{\code{varLabels(<AnnotatedDataFrame>)},
      \code{varLabels(<AnnotatedDataFrame>)<-<data.frame>}:}{Set and
      retrieve the variable labels in the \code{AnnotatedDataFrame}}
    \item{
      \code{dimLabels(<AnnotatedDataFrame>)},
      \code{dimLabels(<AnnotatedDataFrame>) <- <character>}}{Retrieve
      labels used for display of \code{AnnotatedDataFrame}, e.g.,
      \sQuote{rowNames}, \sQuote{columnNames}.}
  }

  Standard generic methods:
  \describe{
    \item{\code{initialize(<AnnotatedDataFrame>)}:}{Object instantiation, used
      by \code{new}; not to be called directly by the user.}
    \item{\code{as(<data.frame>, "AnnotatedDataFrame")}:}{Convert a
      \code{data.frame} to an AnnotatedDataFrame.}
    \item{\code{as(<phenoData>,<AnnotatedDataFrame>)}:}{Convert
      old-style \code{phenoData-class} objects to
      \code{AnnotatedDataFrame}, issuing warnings as appropriate.}
    \item{\code{validObject(<AnnotatedDataFrame>)}:}{Validity-checking
      method, ensuring coordination between \code{data} and
      \code{varMetadata} elements}
     \item{\code{updateObject(object, ..., verbose=FALSE)}}{Update instance to current version, if necessary. See \code{\link{updateObject}}}
     \item{\code{isCurrent(object)}}{Determine whether version of object is current. See \code{\link{isCurrent}}}
     \item{\code{isVersioned(object)}}{Determine whether object contains a 'version' string describing its structure . See \code{\link{isVersioned}}}
     \item{\code{show(<AnnotatedDataFrame>)}}{Abbreviated display of object}
    \item{\code{[<sample>,<variable>}:}{Subset operation, taking two arguments and
      indexing the sample and variable. Returns an
      \code{AnnotatedDataFrame}, i.e., including relevant
      metadata. Unlike a \code{data.frame}, setting \code{drop=TRUE}
      generates an error. }
    \item{\code{[[<variable>}, \code{$<variable>}:}{Selector returning a
      variable (column of \code{pData}).}
    \item{\code{[[<variable>, ...]]<-<new_value>},
      \code{$<variable> <- <new_value>}:}{Replace or add a variable to
      \code{pData}. ... can include named arguments (especially
      \code{labelDescription}) to be added to \code{varMetadata}.}
    \item{\code{head(<AnnotatedDataFrame>, n = 6L, ...)},
      \code{tail(<AnnotatedDataFrame>, n=6L, ...)}}{Select the first
      (last for tail) \code{n} rows; negative \code{n} returns the first
      (last) \code{nrow() - n} rows.}
    \item{\code{dim(<AnnotatedDataFrame>)},
      \code{ncol(<AnnotatedDataFrame>)}:}{Number of samples and
      variables (\code{dim}) and variables (\code{ncol}) in the
      argument.}
    \item{\code{dimnames(<AnnotatedDataFrame>)},
      \code{rownames(<AnnotatedDataFrame>)},
      \code{colnames(<AnnotatedDataFrame>)}:}{row and column names.}
  }
}
\author{V.J. Carey, after initial design by R. Gentleman }

\seealso{
  \code{\link{eSet}}, \code{\link{ExpressionSet}},
  \code{\link{read.AnnotatedDataFrame}}
}
\examples{
df <- data.frame(x=1:6,
                 y=rep(c("Low", "High"),3),
                 z=I(LETTERS[1:6]),
                 row.names=paste("Sample", 1:6, sep="_"))
metaData <-
  data.frame(labelDescription=c(
               "Numbers",
               "Factor levels",
               "Characters"))

AnnotatedDataFrame()
AnnotatedDataFrame(data=df)
AnnotatedDataFrame(data=df, varMetadata=metaData)
as(df, "AnnotatedDataFrame")

obj <- AnnotatedDataFrame()
pData(obj) <- df
varMetadata(obj) <- metaData
validObject(obj)
}
\keyword{classes}

\name{VersionsNull}
\docType{class}
\alias{VersionsNull-class}
\alias{VersionsNull}

\alias{initialize,VersionsNull-method}
\alias{show,VersionsNull-method}

\title{Class "VersionsNull"}

\description{

  A class used to represent the `version' of unversioned
  objects. Useful primarily for method dispatch.

}

\section{Methods}{

  The following are defined; package developers may write additional methods.
  \describe{
    \item{\code{new("VersionsNull", ...)}}{Create a new
      \code{VersionsNull-class} instance, ignoring any additional arguments.}
    \item{\code{show(object)}}{Display ``No version''.}
  }
}

\author{Biocore}

\seealso{
  \code{\link{classVersion}}
}

\examples{

obj <- new("VersionsNull")
obj

obj <- new("VersionsNull", A="1.0.0") # warning
obj

}

\keyword{classes}

\name{data:sample.MultiSet}
\alias{data:sample.MultiSet}
\alias{sample.MultiSet}
\docType{data}
\title{Data set of class 'MultiSet'}
\usage{data(sample.MultiSet)}
\format{
  The data for 4 cases, labeled a to d and 500 genes.
  Each case has five covariates: SlideNumber: number; FileName: name;
  Cy3: genotype labeled Cy3; Cy5: genotype labeled Cy5; Date: date.
}
\description{
 The expression data are real but anonymized. The data are from an
experiment that used Affymetrix U95v2 chips. The data were processed by
dChip and then exported to R for analysis.

The phenoData, standard error estimates, and description data are fake.
}
\examples{
data(sample.MultiSet)
}
\keyword{datasets}

\name{makeDataPackage}
\alias{makeDataPackage}
\alias{makeDataPackage,ANY-method}
\title{Make an R package from a data object}
\description{
  This generic creates a valid R package from an R data object.
}
\usage{
makeDataPackage(object, author, email,
                packageName=deparse(substitute(object)),
                packageVersion=package_version("1.0.0"),
                license="Artistic-2.0",
                biocViews="ExperimentData",
                filePath=tempdir(),
                \dots)
}
\arguments{
  \item{object}{An instance of an R data object.}
  \item{author}{The author, as a character string.}
  \item{email}{A valid email address for the maintainer, as a character string.}
  \item{packageName}{The name of the package, defaults to the name of the object instance.}
  \item{packageVersion}{The version number, as a character string.}
  \item{license}{The license, as a character string.}
  \item{biocViews}{A character vector of valid biocViews views.}
  \item{filePath}{The location to create the package.}
  \item{\dots}{Additional arguments to specific methods.}
}
\details{
  The function makes use of various tools in R and Bioconductor to automatically
  generate the source files for a valid R package.
}
\value{
 The return value is that from a call to \code{link{createPackage}} which
is invoked once the default arguments are set up. The data instance
is stored in the data directory with a name the same as that of the
resulting package.
}
\note{Developers implementing derived methods might force correct
      package name evaluation by including 'packageName' in any
      \code{callNextMethod()}.}
\author{R. Gentleman}
\seealso{\code{\link{createPackage}}}
\examples{
 data(sample.ExpressionSet)
 ## package created in tempdir()
 s1 <- makeDataPackage(sample.ExpressionSet,
                       author = "Foo Author",
                       email = "foo@bar",
                       packageName = "FooBarPkg",
                       packageVersion = "1.0.0")
}
\keyword{manip}

\name{isVersioned}
\alias{isVersioned}

\alias{isVersioned,ANY-method}
\alias{isVersioned,character-method}

\title{Determine whether object or class contains versioning information}
\description{

  This generic function checks to see whether \code{\link{Versioned-class}} information
  is present. When the argument to \code{isVersioned} is a character
  string, the prototype of the class corresponding to the string is
  consulted.

  By default, \code{isVersioned} has the following behaviors:
  \describe{
    \item{\code{isVersioned(Versioned-instance)}}{Returns \code{TRUE} when the instance have version information.}
    \item{\code{isCurrent("class-name")}}{Returns \code{TRUE} when the named class extends \code{\link{Versioned-class}}.}
    \item{\code{isVersioned(ANY)}}{Returns \code{FALSE}}
  }

}
\usage{
isVersioned(object)
}
\arguments{
  \item{object}{Object or class name to check for version information, as described above.}
}
\value{
  \code{isVersioned} returns a logical indicating whether version information is present.
}

\author{Biocore team}

\seealso{\code{\link{Versions-class}}}

\examples{

obj <- new("VersionedBiobase")
isVersioned(obj)

isVersioned(1:10) # FALSE

A <- setClass("A", contains="VersionedBiobase",
         prototype=prototype(new("VersionedBiobase", versions=c(A="1.0.0"))))
a <- A()
isVersioned(a)

removeClass("A")
}

\keyword{manip}

\name{phenoData}
\alias{phenoData}
\alias{phenoData<-}
\alias{varLabels}
\alias{varLabels<-}
\alias{varMetadata}
\alias{varMetadata<-}
\alias{pData}
\alias{pData<-}

\title{Retrieve information on experimental phenotypes recorded in
  eSet and ExpressionSet-derived classes.}
\description{
  These generic functions access the phenotypic data (e.g., covariates)
  and meta-data (e.g., descriptions of covariates) associated with an
  experiment. 
}
\usage{
phenoData(object)
phenoData(object) <- value
varLabels(object)
varLabels(object) <- value
varMetadata(object)
varMetadata(object) <- value
pData(object)
pData(object) <- value
}
\arguments{
  \item{object}{Object, possibly derived from \code{\link{eSet-class}}
    or \code{\linkS4class{AnnotatedDataFrame}}.}
  \item{value}{Value to be assigned to corresponding object.}
}
\value{
  \code{phenoData} returns an object containing information on both
  variable values and variable meta-data.  \code{varLabels} returns a
  character vector of measured variables. \code{pData} returns a data
  frame with samples as rows, variables as columns. \code{varMetadata}
  returns a data frame with variable names as rows, description tags
  (e.g., unit of measurement) as columns.
}
\author{Biocore}

\seealso{\code{\link{eSet-class}}, \code{\link{ExpressionSet-class}}, 
  \code{\link{SnpSet-class}}}

\keyword{manip}

\name{subListExtract}
\alias{subListExtract}

\title{Extract the same element from the sublists of a list}
\description{
  Given a list of lists, this function can be used to extract a named
  element from each sublist.
}
\usage{
subListExtract(L, name, simplify = FALSE, keep.names = TRUE)
}

\arguments{
  \item{L}{A list of named lists}
  \item{name}{The name of the element in the sublists that should be
    extracted.  This should be a length one character vector.}
  \item{simplify}{When \code{TRUE}, the return value will be an atomic
  vector.  If any extracted sublist value has length not equal to one
  and \code{simplify=TRUE}, an error will be raised.  When \code{FALSE},
  a list is returned containing the extracted elements.}
  \item{keep.names}{If \code{TRUE} (default), the names of \code{L} will
  be attached to the returned vector.}
}
\details{
  This function is implemented in C and is intended to be faster than
  calling \code{lapply} or \code{sapply}.
}
\value{
  If \code{simplify=FALSE}, a list will be returned having the same
  length as \code{L}, but with each element containing the
  element named \code{name} from the corresponding inner list of
  \code{L}.

  When \code{simplify=TRUE}, an atomic vector will be returned
  containing the extracted elements.  If any of the inner list elements
  do not have length one or cannot be put inside an atomic vector, an
  error will be raised.
}
\author{Seth Falcon}
\examples{
list_size = 500000
innerL = list(foo="foo", bar="bar")
L = rep(list(innerL), list_size)

system.time({j0 = sapply(L, function(x) x$foo)})
system.time({j1 = subListExtract(L, "foo", simplify=TRUE)})
stopifnot(all.equal(j0, j1))

LS = L[1:3]
names(LS) = LETTERS[1:3]
subListExtract(LS, "bar", simplify=TRUE)
subListExtract(LS, "bar", simplify=FALSE)
subListExtract(LS, "bar", simplify=TRUE, keep.names=FALSE)
}

\keyword{manip}

\name{addVigs2WinMenu}
\alias{addVigs2WinMenu}

\concept{addVig2Menu}
\concept{addVig4Win}
\concept{addVig4Unix}
\concept{addNonExisting}
\concept{addPDF2Vig}

\title{Add Menu Items to an Existing/New Menu of Window}
\description{
  This function adds a menu item for a package's vignettes.
}
\usage{
addVigs2WinMenu(pkgName)
}

\arguments{
  \item{pkgName}{\code{pkgName} - a character string for the name of an
    R package}
}
\details{
   The original functions \code{addVig2Menu}, \code{addVig4Win}, \code{addVig4Unix}, \code{addNonExisting}, \code{addPDF2Vig} have been replaced by \code{addVigs2WinMenu}, please use those instead.
}
\value{
  The functions do not return any value.
}

\author{Jianhua Zhang and Jeff Gentry}

\examples{
    # Only works for windows now
    if(interactive() && .Platform$OS.type == "windows" &&
             .Platform$GUI == "Rgui"){
        addVigs2WinMenu("Biobase")
    }
}
\keyword{interface}

\name{strbreak}
\alias{strbreak}
\title{Break Character Strings to Fit Width}
\description{
  Inserts line breaks (\code{collapse}) into input character strings.
  The main intention of this
  function is to prepare long strings for printing, so the output
  is not wider than \code{width}.
}
\usage{
  strbreak(x, width=getOption("width"), exdent=2, collapse="\n")
}
\arguments{
  \item{x}{a character vector}
  \item{width}{a positive integer giving the width of the output.}
  \item{exdent}{a positive integer specifying the indentation of
     subsequent lines after the first line.}
  \item{collapse}{a character.  This is inserted to break lines.}
}
\author{Wolfgang Huber \url{http://www.ebi.ac.uk/huber}}
\seealso{\code{\link{strwrap}}, \code{\link{substring}}}

\examples{
longString = paste(rep(LETTERS, 10), collapse="", sep="")
cat(strbreak(longString))
}
\keyword{character}

\name{featureNames}
\alias{featureNames}
\alias{featureNames<-}
\alias{sampleNames}
\alias{sampleNames<-}


\title{Retrieve feature and sample names from eSets.}
\description{
These generic functions access the feature names (typically, gene or SNP
identifiers) and sample names stored in an object derived from the
\code{\link{eSet-class}}.
}
\usage{
featureNames(object)
featureNames(object) <- value
sampleNames(object)
sampleNames(object) <- value
}
\arguments{
  \item{object}{Object, possibly derived from class \code{eSet}.}
  \item{value}{Character vector containing feature or sample names.}
}
\value{
  \code{featureNames} returns a (usually long!) character vector
  uniquely identifying each feature.\code{sampleNames} returns a
  (usually shorter) character vector identifying samples. 
}
\author{Biocore}

\seealso{\code{\link{ExpressionSet-class}}, \code{\link{SnpSet-class}}}

\keyword{manip}

\name{isUnique}
\alias{isUnique}
\title{Determine Unique Elements}
\description{
  Determines which elements of a vector occur exactly once.
}

\usage{
isUnique(x)
}

\arguments{
\item{x}{a vector}
}

\value{A logical vector of the same length as \code{x}, in which
\code{TRUE} indicates uniqueness.}
 
\seealso{\code{\link[base:unique]{unique}},\code{\link[base:duplicated]{duplicated}}.}
\author{Wolfgang Huber}

\examples{
x <- c(9:20, 1:5, 3:7, 0:8)
isUnique(x)
}
\keyword{logic}
\keyword{manip}

\name{SnpSet}
\docType{class}
\alias{class:SnpSet}
\alias{SnpSet}

\alias{SnpSet-class}
\alias{exprs<-,SnpSet,matrix-method}
\alias{exprs,SnpSet-method}
\alias{snpCall,SnpSet-method}
\alias{snpCall<-,SnpSet,matrix-method}
\alias{snpCallProbability,SnpSet-method}
\alias{snpCallProbability<-,SnpSet,matrix-method}

\alias{initialize,SnpSet-method}

\title{
  Class to Contain Objects Describing High-Throughput SNP Assays.
}

\description{
  Container for high-throughput assays and experimental
  metadata. \code{SnpSet} class is derived from
  \code{\link{eSet}}, and requires matrices \code{call},
  \code{callProbability} as assay data members.}

\section{Extends}{
   Directly extends class \code{\link{eSet}}.
}

\section{Creating Objects}{

  \code{new('SnpSet',
    phenoData = [AnnotatedDataFrame],
    experimentData = [MIAME],
    annotation = [character],
    protocolData = [AnnotatedDataFrame],
    call = [matrix],
    callProbability = [matrix],
    ...)
  }

  \code{SnpSet} instances are usually created through
  \code{new("SnpSet", ...)}. Usually the arguments to \code{new}
  include \code{call} (a matrix of genotypic calls, with features (SNPs)
  corresponding to rows and samples to columns), \code{phenoData},
  \code{experimentData}, \code{annotation}, and \code{protocolData}. 
  \code{phenoData}, \code{experimentData}, \code{annotation} and
  \code{protocolData} can be missing, in which case they are assigned
  default values.
}
\section{Slots}{
  Inherited from \code{eSet}:
   \describe{
      \item{\code{assayData}:}{Contains matrices with equal
	dimensions, and with column number equal to
	\code{nrow(phenoData)}. \code{assayData} must contain a matrix
	\code{call} with rows representing features (e.g., SNPs)
	and columns representing samples, and a matrix
	\code{callProbability} describing the certainty of the
	call. The content of \code{call} and \code{callProbability} are
	not enforced by the class. Additional matrices of
	identical size may also be included in
	\code{assayData}. Class:\code{\link{AssayData-class}}} 
      \item{\code{phenoData}:}{See \code{\link{eSet}}}
      \item{\code{experimentData}:}{See \code{\link{eSet}}}
      \item{\code{annotation}:}{See \code{\link{eSet}}}
      \item{\code{protocolData}:}{See \code{\link{eSet}}}
  }
}
\section{Methods}{

  Class-specific methods:
  \describe{
     \item{\code{snpCall(SnpSet)}, \code{snpCall(SnpSet,matrix)<-}}{Access and
       set elements named \code{call} in the \code{AssayData}
       slot.}

     \item{\code{exprs(SnpSet)}, \code{exprs(SnpSet,matrix)<-}}{Synonym
	   for \code{snpCall}.}

     \item{\code{snpCallProbability(SnpSet)},
	   \code{snpCallProbability<-(SnpSet,matrix)<-}}{ Access and set
	   elements named \code{callProbability} in the \code{AssayData}
	   slot.}  }
  
   Derived from \code{\link{eSet}}:
   \describe{
     \item{\code{updateObject(object, ..., verbose=FALSE)}}{Update instance to current version, if necessary. See \code{\link{updateObject}} and \code{\link{eSet}}}
     \item{\code{isCurrent(object)}}{Determine whether version of object is current. See \code{\link{isCurrent}}}
     \item{\code{isVersioned(object)}}{Determine whether object contains a 'version' string describing its structure . See \code{\link{isVersioned}}}
     \item{\code{sampleNames(SnpSet)} and \code{sampleNames(SnpSet)<-}:}{See \code{\link{eSet}}}
     \item{\code{featureNames(SnpSet)}, \code{featureNames(SnpSet, value)<-}:}{See \code{\link{eSet}}}
     \item{\code{dims(SnpSet)}:}{See \code{\link{eSet}}}
     \item{\code{phenoData(SnpSet)}, \code{phenoData(SnpSet,value)<-}:}{See \code{\link{eSet}}}
     \item{\code{varLabels(SnpSet)}, \code{varLabels(SnpSet, value)<-}:}{See \code{\link{eSet}}}
     \item{\code{varMetadata(SnpSet)}, \code{varMetadata(SnpSet,value)<-}:}{See \code{\link{eSet}}}
     \item{\code{pData(SnpSet)}, \code{pData(SnpSet,value)<-}:}{See \code{\link{eSet}}}
     \item{\code{varMetadata(SnpSet)}, \code{varMetadata(SnpSet,value)}}{See \code{\link{eSet}}}
     \item{\code{experimentData(SnpSet)},\code{experimentData(SnpSet,value)<-}:}{See \code{\link{eSet}}}
     \item{\code{pubMedIds(SnpSet)}, \code{pubMedIds(SnpSet,value)}}{See \code{\link{eSet}}}
     \item{\code{abstract(SnpSet)}:}{See \code{\link{eSet}}}
     \item{\code{annotation(SnpSet)}, \code{annotation(SnpSet,value)<-}}{See \code{\link{eSet}}}
     \item{\code{protocolData(SnpSet)}, \code{protocolData(SnpSet,value)<-}}{See \code{\link{eSet}}}
     \item{\code{combine(SnpSet,SnpSet)}:}{See \code{\link{eSet}}}
     \item{\code{storageMode(eSet)}, \code{storageMode(eSet,character)<-}:}{See \code{\link{eSet}}}
  }

  Standard generic methods:
  \describe{
     \item{\code{initialize(SnpSet)}:}{Object instantiation, used by \code{new}; not to be called directly by the user.}
     \item{\code{validObject(SnpSet)}:}{Validity-checking method, ensuring that \code{call} and \code{callProbability} is a member of \code{assayData}. \code{checkValidity(SnpSet)} imposes this validity check, and the validity checks of \code{eSet}.}
     \item{\code{show(SnpSet)}}{See \code{\link{eSet}}}
     \item{\code{dim(SnpSet)}, \code{ncol}}{See \code{\link{eSet}}}
     \item{\code{SnpSet[(index)}:}{See \code{\link{eSet}}}
     \item{\code{SnpSet$}, \code{SnpSet$<-}}{See \code{\link{eSet}}}
  }
}

\author{Martin Morgan, V.J. Carey, after initial design by R. Gentleman }

\seealso{
  \code{\link{eSet}}, \code{\link{ExpressionSet}}
}

\keyword{classes}

\name{data:geneData}
\alias{data:geneData}
\alias{geneData}
\alias{data:geneCov}
\alias{geneCov}
\alias{data:geneCovariate}
\alias{geneCovariate}
\alias{data:seD}
\alias{seD}
\docType{data}
\title{Sample expression matrix and phenotype data.frames.}
\usage{data(geneData)}
\description{
The \code{geneData} data.frame has 500 rows and 26 columns.  It consists
of a subset of real expression data from an Affymetrix U95v2 chip. The
data are anonymous. The covariate data \code{geneCov} and
\code{geneCovariate} are made up. The standard error data \code{seD} is
also made up.
}
\format{
  A 500 by 26 data frame.
}
\source{
  The J. Ritz Laboratory (S. Chiaretti).
}
\examples{
data(geneData)
data(geneCovariate)
data(seD)
}
\keyword{datasets}

\name{container}
\docType{class}
\alias{class:container}
\alias{container}

\alias{container-class}
\alias{[,container-method}
\alias{[[<-,container-method}
\alias{[[,container-method}
\alias{content,container-method}
\alias{length,container-method}
\alias{locked,container-method}
\alias{show,container-method}

\concept{content}
\concept{locked}

\title{A Lockable List Structure with Constraints on Content}

\description{Container class that specializes the list construct of R to provide content and access control }

\section{Creating Objects}{
   \code{new('container', x  = [list], content = [character], locked = [logical])}
}

\section{Slots}{
   \describe{
      \item{x}{list of entities that are guaranteed to share a certain property}
      \item{content}{tag describing container contents}
      \item{locked}{boolean indicator of locked status. Value of TRUE implies assignments into the container are not permitted}
   }
}

\section{Methods}{
   Class-specific methods:
   \describe{
      \item{\code{content(container)}}{returns \code{content} slot of argument}
      \item{\code{locked(container)}}{returns \code{locked} slot of argument}
   }
   Standard methods defined for 'container':
   \describe{
      \item{\code{show(container)}}{prints container}
      \item{\code{length(container)}}{returns number of elements in the container}
      \item{\code{[[(index)} and \code{[[(index, value)}}{access and replace elements in the container }
      \item{\code{[(index)}}{make a subset of a container (which will itself be a container)}
   }
}
\examples{
  x1 <- new("container", x=vector("list", length=3), content="lm")
  lm1 <- lm(rnorm(10)~runif(10))
  x1[[1]] <- lm1
 }
\keyword{methods}
\keyword{classes}

\name{rowQ}
\alias{rowQ}
\alias{rowQ,matrix,numeric-method}
\alias{rowQ,ExpressionSet,numeric-method}
\alias{rowMin}
\alias{rowMax}

\title{A function to compute empirical row quantiles.}
\description{
 This function computes the requested quantile for each row of a matrix,
 or of an \code{ExpressionSet}.
}
\usage{
rowQ(imat, which)
rowMax(imat)
rowMin(imat)
}
\arguments{
  \item{imat}{Either a matrix or an \code{ExpressionSet}.}
  \item{which}{An integer indicating which order statistic should be returned.}
}
\details{
 \code{rowMax} and \code{rowMin} simply call \code{rowQ}
with the appropriate argument set. 

 The argument \code{which} takes values between 1, for the minimum per row,
 and \code{ncol(imat)}, for the maximum per row.

}
\value{
 A vector of length equal to the number of rows of the input matrix containing
the requested quantiles.
}
\author{R. Gentleman}

\seealso{
 \code{\link{rowMedians}}.
 \code{rowMeans()} in \code{\link[base]{colSums}}().
}

\examples{
 data(sample.ExpressionSet)
 rowMin(sample.ExpressionSet)
 rowQ(sample.ExpressionSet, 4)
}

\name{assayData}
\alias{assayData}
\alias{assayData<-}

\title{Retrieve assay data from eSets and ExpressionSets.}
\description{
This generic function accesses assay data stored in an object derived from 
the \code{\link{eSet}} or \code{\link{ExpressionSet}} class.
}
\usage{
assayData(object)
assayData(object) <- value
}
\arguments{
  \item{object}{Object derived from class eSet}
  \item{value}{Named list or environment containing one or more matrices with 
        identical dimensions}
}
\value{
  \code{assayData} applied to \code{eSet}-derived classes returns a list
  or environment; applied to \code{ExpressionSet}, the method returns an
  environment. See the class documentation for specific details.
}
\author{Biocore}

\seealso{\code{\link{eSet-class}}, \code{\link{ExpressionSet-class}}, 
 \code{\link{SnpSet-class}}}

\keyword{manip}

\name{eSet}
\docType{class}
\alias{class:eSet}
\alias{eSet}

\alias{eSet-class}
\alias{[,eSet-method}
\alias{$,eSet-method}
\alias{$<-,eSet-method}
\alias{[[,eSet-method}
\alias{[[<-,eSet-method}
\alias{abstract,eSet-method}
\alias{annotation,eSet-method}
\alias{annotation<-,eSet,character-method}
\alias{assayData,eSet-method}
\alias{assayData<-,eSet,AssayData-method}
\alias{assayDataElement}
\alias{assayDataElement<-}
\alias{assayDataElementNames}
\alias{assayDataElementReplace}
\alias{combine,eSet,ANY-method}
\alias{combine,eSet,eSet-method}
\alias{description,eSet-method}
\alias{description<-,eSet,MIAME-method}
\alias{dimnames}
\alias{dimnames<-}
\alias{dimnames,eSet-method}
\alias{dimnames<-,eSet-method}
\alias{dim,eSet-method}
\alias{dims}
\alias{dims,eSet-method}
\alias{experimentData,eSet-method}
\alias{experimentData<-,eSet,MIAME-method}
\alias{exprs,eSet-method}
\alias{exprs<-,eSet,AssayData-method}
\alias{featureData,eSet-method}
\alias{featureData<-,eSet,AnnotatedDataFrame-method}
\alias{featureNames,eSet-method}
\alias{featureNames<-,eSet-method}
\alias{fData,eSet-method}
\alias{fData<-,eSet,data.frame-method}
\alias{fvarLabels,eSet-method}
\alias{fvarLabels<-,eSet-method}
\alias{fvarMetadata,eSet-method}
\alias{fvarMetadata<-,eSet,data.frame-method}
\alias{initialize,eSet-method}
\alias{ncol,eSet-method}
\alias{notes,eSet-method}
\alias{notes<-,eSet,ANY-method}
\alias{pData,eSet-method}
\alias{pData<-,eSet,data.frame-method}
\alias{phenoData,eSet-method}
\alias{phenoData<-,eSet,AnnotatedDataFrame-method}
\alias{pubMedIds,eSet-method}
\alias{pubMedIds<-,eSet,character-method}
\alias{preproc,eSet-method}
\alias{preproc<-,eSet-method}
\alias{protocolData,eSet-method}
\alias{protocolData<-,eSet,character-method}
\alias{sampleNames,eSet-method}
\alias{sampleNames<-,eSet,ANY-method}
\alias{show,eSet-method}
\alias{storageMode,eSet-method}
\alias{storageMode<-,eSet,character-method}
\alias{varLabels,eSet-method}
\alias{varLabels<-,eSet-method}
\alias{varMetadata,eSet-method}
\alias{varMetadata<-,eSet,data.frame-method}
\alias{storageMode,eSet-method}
\alias{storageMode<-,eSet,character-method}
\alias{updateObject,eSet-method}
\alias{updateObjectTo,eSet,eSet-method}

\alias{listOrEnv}
\alias{SW}

\concept{exprs}
\concept{annotation}
\concept{combine}
\concept{description}
\concept{ncol}
\concept{notes}
\concept{featureNames}
\concept{sampleNames}

\title{
  Class to Contain High-Throughput Assays and Experimental Metadata
}
\description{
  Container for high-throughput assays and experimental
  metadata. Classes derived from \code{eSet} contain one or more
  identical-sized matrices as \code{assayData} elements. Derived
  classes (e.g., \code{\link{ExpressionSet-class}}, \code{\link{SnpSet-class}})
  specify which elements must be present in the \code{assayData} slot.

  \code{eSet} object cannot be instantiated directly; see the examples
  for usage.
}
\section{Creating Objects}{
  \code{eSet} is a virtual class, so instances cannot be created.

  Objects created under previous definitions of \code{eSet-class} can be
  coerced to the current classes derived from \code{eSet} using
  \code{updateOldESet}.
}
\section{Slots}{
   Introduced in \code{eSet}:
   \describe{
      \item{\code{assayData}:}{Contains matrices with equal
	dimensions, and with column number equal to
	\code{nrow(phenoData)}. Class:\code{\link{AssayData-class}}}
      \item{\code{phenoData}:}{Contains experimenter-supplied variables
      describing sample (i.e., columns in \code{assayData}) phenotypes.
	Class: \code{\link{AnnotatedDataFrame-class}}}
      \item{\code{featureData}:}{Contains variables describing features
	(i.e., rows in \code{assayData}) unique to this experiment. Use
	the \code{annotation} slot to efficiently reference feature data
	common to the annotation package used in the experiment. Class:
	\code{\link{AnnotatedDataFrame-class}}} 
      \item{\code{experimentData}:}{Contains details of experimental
	methods. Class: \code{\link{MIAME-class}}}
      \item{\code{annotation}:}{Label associated with the annotation
	package used in the experiment. Class: \code{character}}
      \item{\code{protocolData}:}{Contains microarray equipment-generated
      variables describing sample (i.e., columns in \code{assayData}) phenotypes.
    Class: \code{\link{AnnotatedDataFrame-class}}}
      \item{\code{.__classVersion__}:}{A \code{Versions} object describing
    the R and Biobase version numbers used to created the instance.
    Intended for developer use.}
  }
}
\section{Methods}{
  Methods defined in derived classes (e.g., \code{\link{ExpressionSet-class}},
  \code{\link{SnpSet-class}}) may override the methods described here.

   Class-specific methods:
   \describe{
     \item{\code{sampleNames(object)} and
       \code{sampleNames(object)<-value}:}{Coordinate accessing and setting
       sample names in \code{assayData} and \code{phenoData}}
     \item{\code{featureNames(object)},
       \code{featureNames(object) <- value}:}{Coordinate accessing and setting of
       feature names (e.g, genes, probes) in \code{assayData}.}
     \item{\code{dimnames(object)}, \code{dimnames(object) <-
	 value}:}{Also \code{rownames} and \code{colnames}; access and set
	 feature and sample names.}
     \item{\code{dims(object)}:}{Access the common dimensions (\code{dim}) or
       column numbers (\code{ncol}), or dimensions of all members
       (\code{dims}) of \code{assayData}.}

     \item{\code{phenoData(object)},
       \code{phenoData(object) <- value}:}{Access and set
	   \code{phenoData}. Adding new columns to \code{phenoData} is often
	   more easily done with \code{eSetObject[["columnName"]] <- value}.}
     \item{\code{pData(object)}, \code{pData(object) <- value}:}{Access and set
       sample data information. Adding new columns to \code{pData} is often
	   more easily done with \code{eSetObject[["columnName"]] <- value}.}
     \item{\code{varMetadata(object)},
       \code{varMetadata(eSet,value)}}{Access and set metadata describing
       variables reported in \code{pData}}
     \item{\code{varLabels(object)}, \code{varLabels(eSet,
	     value)<-}:}{Access and set variable labels in
       \code{phenoData}.}

     \item{\code{featureData(object)},
       \code{featureData(object) <- value}:}{Access and set \code{featureData}.}
     \item{\code{fData(object)}, \code{fData(object) <- value}:}{Access and set
       feature data information.}
     \item{\code{fvarMetadata(object)},
       \code{fvarMetadata(eSet,value)}}{Access and set metadata describing
       features reported in \code{fData}}
     \item{\code{fvarLabels(object)},
       \code{fvarLabels(eSet, value)<-}:}{Access and set variable labels in
       \code{featureData}.} 

     \item{\code{assayData(object), assayData(object) <- value}:}{
       \code{signature(object = "eSet", value = "AssayData")}: Access
       and replace the \code{AssayData} slot of an
       \code{eSet} instance. \code{assayData} returns a list or
       environment; elements in \code{assayData} not accessible in other
       ways (e.g., via \code{exprs} applied directly to the \code{eSet})
       can most reliably be accessed with, e.g., \code{assayData(obj)[["se.exprs"]]}.}
     \item{\code{experimentData(object)},\code{experimentData(object) <- value}:}{Access
       and set details of experimental methods}
     \item{\code{description(object)},\code{description(object) <- value}:}{Synonymous with experimentData.}
     \item{\code{notes(object)},\code{notes(object) <- value}:}{
       \code{signature(object="eSet", value="list")} Retrieve and set unstructured notes associated with \code{eSet}.
       \code{signature(object="eSet", value="character")} As with
       value="list", but \emph{append} value to current list of notes.}
     
     \item{\code{pubMedIds(object)}, \code{pubMedIds(eSet,value)}}{Access
       and set PMIDs in \code{experimentData}.}
     \item{\code{abstract(object)}:}{Access abstract in
       \code{experimentData}.}
     \item{\code{annotation(object)},
       \code{annotation(object) <- value}}{Access and set annotation label
       indicating package used in the experiment.}
     \item{\code{protocolData(object)},
       \code{protocolData(object) <- value}}{Access and set the protocol data.}
     \item{\code{preproc(object)},
       \code{preproc(object) <- value}:}{\code{signature(object="eSet",
	 value="list")} Access and set \code{preprocessing} information
       in the \code{\link{MIAME-class}} object associated with this
       \code{eSet}.}
     \item{\code{combine(eSet,eSet)}:}{Combine two \code{eSet}
       objects. To be combined, eSets must have identical numbers of
       \code{featureNames}, distinct \code{sampleNames}, and identical \code{annotation}.}
     \item{\code{storageMode(object)}, \code{storageMode(eSet,character)<-}:}{Change storage mode
       of \code{\link{assayData}}. Can be used to 'unlock' environments,
       or to change between \code{list} and \code{environment} modes of
       storing \code{assayData}.}
  }
  Standard generic methods:
  \describe{
    \item{\code{initialize(object)}:}{Object instantiation, can be called by
      derived classes but not usually by the user.}
    \item{\code{validObject(object)}:}{Validity-checking method,
	  ensuring (1) all assayData components have the same number of
	  features and samples; (2) the number and names of
	  \code{phenoData} rows match the number and names of
	  \code{assayData} columns}
     \item{\code{as(eSet, "ExpressionSet")}}{Convert instance of class \code{"eSet"} to instance of \code{\link{ExpressionSet-class}}, if possible.}
     \item{\code{as(eSet, "MultiSet")}}{Convert instance of class \code{"eSet"} to instance of \code{\link{MultiSet-class}}, if possible.}
     \item{\code{updateObject(object, ..., verbose=FALSE)}}{Update instance to current version, if necessary. Usually called through class inheritance rather than directly by the user. See \code{\link{updateObject}}}
     \item{\code{updateObjectTo(object, template, ..., verbose=FALSE)}}{Update instance to current version by updating slots in \code{template}, if necessary. Usually call by class inheritance, rather than directly by the user. See \code{\link{updateObjectTo}}}
     \item{\code{isCurrent(object)}}{Determine whether version of object is current. See \code{\link{isCurrent}}}
     \item{\code{isVersioned(object)}}{Determine whether object contains a 'version' string describing its structure . See \code{\link{isVersioned}}}
     \item{\code{show(object)}}{Informatively display object contents.}
     \item{\code{dim(object)}, \code{ncol}}{Access the common
       dimensions (\code{dim}) or column numbers (\code{ncol}), of all
       memebers (\code{dims}) of \code{assayData}.}
     \item{\code{object[(index)}:}{Conducts subsetting of matrices and
       phenoData components }
     \item{\code{object$name}, \code{object$name<-value}}{Access and set \code{name} column in \code{phenoData}}
     \item{\code{object[[i, ...]]}, \code{object[[i, ...]]<-value}}{Access and set column \code{i} (character or
       numeric index) in \code{phenoData}. The ... argument can include
       named variables (especially \code{labelDescription}) to be added
       to varMetadata.}
   }
   Additional functions:
   \describe{
    \item{assayDataElement(object, element)}{Return matrix
      \code{element} from \code{assayData} slot of \code{object}.}
    \item{assayDataElement(object, element, validate=TRUE) <-
       value)}{Set element \code{element} in \code{assayData} slot of
       \code{object} to matrix \code{value}. If \code{validate=TRUE},
       check that value row and column names of conform to object.}
    \item{assayDataElementReplace(object, element, value,
      validate=TRUE)}{Set element \code{element} in \code{assayData}
      slot of \code{object} to matrix \code{value}. If
      \code{validate=TRUE}, check that row and column names of value
      conform to object.}
    \item{assayDataElementNames(object)}{Return element names in
      \code{assayData} slot of \code{object}}
     \item{\code{updateOldESet}}{Update versions of \code{eSet}
       constructued using \code{listOrEnv} as \code{assayData} slot
       (before May, 2006).}
   }
}
\author{Biocore team}

\seealso{
  Method use in \code{\link{ExpressionSet-class}}.
  Related  classes
  \code{\link{AssayData-class}}, \code{\link{AnnotatedDataFrame-class}}, \code{\link{MIAME-class}}.
  Derived classes
  \code{\link{ExpressionSet-class}}, \code{\link{SnpSet-class}}.
  To update objects from previous class versions, see \code{\link{updateOldESet}}.
}

\examples{

# update previous eSet-like class oldESet to existing derived class
\dontrun{updateOldESet(oldESet, "ExpressionSet")}

# create a new, ad hoc, class, for personal use
# all methods outlined above are available automatically
.MySet <- setClass("MySet", contains="eSet")
.MySet()

# Create a more robust class, with constructor and validation methods
# to ensure assayData contains specific matricies
.TwoColorSet <- setClass("TwoColorSet", contains="eSet")

TwoColorSet <-
    function(phenoData=AnnotatedDataFrame(), experimentData=MIAME(),
             annotation=character(), R=new("matrix"), G=new("matrix"),
             Rb=new("matrix"), Gb=new("matrix"), ...)
{
    .TwoColorSet(phenoData=phenoData, experimentData=experimentData,
                 annotation=annotation, R=R, G=G, Rb=Rb, Gb=Gb, ...)
}

setValidity("TwoColorSet", function(object) {
  assayDataValidMembers(assayData(object), c("R", "G", "Rb", "Gb"))
})

TwoColorSet()

# eSet objects cannot be instantiated directly, only derived objects
try(new("eSet"))

removeClass("MySet")
removeClass("TwoColorSet")
}

\keyword{classes}

\name{snpCall}
\alias{snpCall}
\alias{snpCall<-}
\alias{snpCallProbability}
\alias{snpCallProbability<-}

\title{Get and retrieve SNP call and call probability data.}
\description{
  These generic functions access the calls and call probabilities
  stored in objects.
}
\usage{
snpCall(object, ...)
snpCall(object, ...) <- value
snpCallProbability(object, ...)
snpCallProbability(object, ...) <- value
}
\arguments{
  \item{object}{Object, possibly derived from class \code{SnpSet}.}
  \item{value}{Matrix with rows representing SNP calls or call
	probabilities and columns samples.}
  \item{...}{Additional arguments available to methods.}
}
\value{
  \code{snpCall} returns a matrix of SNP calls;
  \code{snpCallProbability} returns the corresponding matrix of standard errors,
  when available.
}
\author{Biocore}

\seealso{\code{\link{SnpSet-class}}}

\keyword{manip}

\name{updateObjectTo}
\alias{updateObjectTo}
\alias{updateObjectTo,ANY,ANY-method}

\title{Update an object to the class definition of a template}
\description{
  The \code{updateObjectTo} generic function returns an instance
  of \code{object} updated to the class definition of \code{template}.

  It requires that the class of the returned object be the same as the
  class of the \code{template} argument, and that the object is valid.
  Usually, updating proceeds by modifying slots in
  \code{template} with information from \code{object}, and returning
  \code{template}. Use \code{\link{as}} to coerce an object from one
  type to another; \code{updateObjectTo} might be useful to update a
  virtual superclass. By default, \code{updateObjectTo} has the following
  behavior:
  \describe{
    \item{\code{updateObjectTo(ANY-object,ANY-template)}}{Attempt \code{as(ANY-object,class(ANY-template))}.}
  }
}
\usage{
updateObjectTo(object, template, \dots, verbose=FALSE)
}
\arguments{
  \item{object}{Object to be updated.}
  \item{template}{Instance representing a template for updating object.}
  \item{\dots}{Additional arguments, for use in specific update methods.}
  \item{verbose}{A logical, indicating whether information about the
    update should be reported. Use \code{message} to report this.}
}
\value{
  \code{updateObjectTo} returns a valid instance of \code{template}.
}

\author{Biocore team}

\seealso{
  \code{\link[BiocGenerics]{updateObject}},
  \code{\link{Versions-class}}
}

\keyword{manip}

\name{testBioCConnection}
\alias{testBioCConnection}
\title{A function to check internet connectivity to Bioconductor}
\description{
  This function will attempt to determine if the user has internet
  connectivity to the Bioconductor website.  This is useful in many
  situations dealing with code that uses automated downloads and other
  such things.
}
\usage{
testBioCConnection()
}
\value{
  TRUE if a connection is possible, FALSE if not.
}
\author{Jeff Gentry}
\examples{
 z <- testBioCConnection()
}
\keyword{utilities}

\name{listLen}
\alias{listLen}

\title{Lengths of list elements}

\description{
  This function returns an integer vector with the length
  of the elements of its argument, which is expected to be a list.
}

\usage{
listLen(x)
}

\arguments{
  \item{x}{A list}
}

\details{
  This function returns a vector of the same length as
  the list \code{x} containing the lengths of each element.

  The current implementation is intended for lists containing vectors
  and the C-level length function is used to determine length.  This
  means no dispatch is done for the elements of the list.  If your
  list contains S4 objects, you should use \code{sapply(x, length)}
  instead.
}

\author{Jeff Gentry and R. Gentleman}

\seealso{\code{\link{sapply}}}

\examples{
  foo = lapply(1:8, rnorm)
  listLen(foo)
}
\keyword{utilities}
